dofile_once("data/scripts/lib/utilities.lua")
local entity_id = GetUpdatedEntityID()

local mass = 1

local phys_body = EntityGetFirstComponent(entity_id, "PhysicsBodyComponent")
if (phys_body ~= nil) and (phys_body > 0) then
    mass = ComponentGetValue2(phys_body, "mPixelCount")
end

local phys_body2 = EntityGetFirstComponent(entity_id, "PhysicsBody2Component")
if (phys_body2 ~= nil) and (phys_body2 > 0) then
    mass = ComponentGetValue2(phys_body2, "mPixelCount")
end

local x, y, rot = EntityGetTransform(entity_id)
local controls_component = EntityGetFirstComponentIncludingDisabled(entity_id, "ControlsComponent")

if ( controls_component ~= nil ) and ( controls_component > 0 ) then

	local input = {
		ComponentGetValue(controls_component, "mButtonDownRight"), --right
		ComponentGetValue(controls_component, "mButtonDownUp"), --up
		ComponentGetValue(controls_component, "mButtonDownLeft"), --left
		ComponentGetValue(controls_component, "mButtonDownDown"), --down
	}

	-- Calculate force multipliers based on the square root of the mass
	local force_multiplier = 1 / math.pow(mass,0.4)

	if mass < 180 then
		force_multiplier = force_multiplier * 0.6
	end
	local tx = 0
	local ty = 0
	if input[1] == "1" then tx = tx + (3 * force_multiplier) end
	if input[2] == "1" then ty = ty - (3 * force_multiplier) end
	if input[3] == "1" then tx = tx - (3 * force_multiplier) end
	if input[4] == "1" then ty = ty + (3 * force_multiplier) end

	if (phys_body ~= nil) and (phys_body > 0) then
		local px, py, angle, vel_x, vel_y, angular_vel = PhysicsComponentGetTransform(phys_body)
		PhysicsComponentSetTransform(phys_body, px, py, angle, vel_x + tx, vel_y + ty, angular_vel)
	end

	if (phys_body2 ~= nil) and (phys_body2 > 0) then
		local px, py, angle, vel_x, vel_y, angular_vel = PhysicsComponentGetTransform(phys_body2)
		PhysicsComponentSetTransform(phys_body2, px, py, angle, vel_x + tx * 0.8, vel_y + ty * 0.8, angular_vel)
	end
end

local rotation_var_comp = get_variable_storage_component( entity_id, "dont_rotate_body_when_polyd" )
if not rotation_var_comp then
	PhysicsApplyTorque(entity_id, -rot * (mass * 0.5))
end

