dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local has_player_tag = EntityHasTag(entity_id, "polymorphed_player")
if has_player_tag == true then
	local x, y = EntityGetTransform(entity_id)
	local var_comp = get_variable_storage_component( entity_id, "setup_poly_player" )
	
	if not var_comp then
        local comps = EntityGetAllComponents(entity_id) or {}
        local remove_comps = {}
        local enable_comps = {}
        
        -- Gather components
        for _, comp in ipairs(comps) do
            if (ComponentGetEntity(comp) ~= nil) and (ComponentGetEntity(comp) > 0) then
                if ComponentHasTag(comp, "remove_when_polyd") then
                    table.insert(remove_comps, comp)
                end
                if ComponentHasTag(comp, "enable_when_polyd") then
                    table.insert(enable_comps, comp)
                end
            end
        end

        -- Process components to remove
        for _, comp in ipairs(remove_comps) do
            EntityRemoveComponent(entity_id, comp)
        end

        -- Process components to enable
        for _, comp in ipairs(enable_comps) do
            EntitySetComponentIsEnabled(entity_id, comp, true)
        end
	
		EntityAddComponent2(entity_id, "VariableStorageComponent", {
			name = "setup_poly_player"
		})
	end

end