dofile_once("data/scripts/lib/utilities.lua")
dofile_once( "data/scripts/invisibility_check.lua" )

local range = 20
local projectile_velocity = 20
local scatter = 0

local entity_id = GetUpdatedEntityID()
local pos_x, pos_y = EntityGetFirstHitboxCenter( entity_id )
local root_id = EntityGetRootEntity( entity_id )

-- locate nearest enemy
local enemy, enemy_x, enemy_y
local min_dist = 9999
for _,id in pairs(EntityGetInRadiusWithTag(pos_x, pos_y, range, "mortal")) do
	-- is target a valid enemy
	if ( EntityGetFirstComponent(id, "GenomeDataComponent") ~= nil ) and  ( EntityGetFirstComponent(id, "GenomeDataComponent") > 0 ) and ( EntityGetHerdRelation(root_id, id) < 40 ) and ( is_invisible(id) == false ) then
		local x, y = EntityGetFirstHitboxCenter( id )
		local dist = get_distance(pos_x, pos_y, x, y)
		if dist < min_dist then
			min_dist = dist
			enemy = id
			enemy_x = x
			enemy_y = y
		end
	end
end
if ( enemy ~= nil ) and ( enemy > 0 ) then
	local distance = get_distance(pos_x, pos_y, enemy_x, enemy_y)

	if distance < range then
		--animation
		local sprite_component = EntityGetFirstComponent(entity_id, "SpriteComponent")
		local animation = ComponentGetValue2( sprite_component, "rect_animation")

		ComponentSetValue2(sprite_component, "rect_animation", "attack")
		ComponentSetValue2(sprite_component, "next_rect_animation", "stand")

		--attack
		GamePlaySound("data/audio/Desktop/animals.bank", "animals/giantshooter/attack_bite", pos_x, pos_y)
		EntityInflictDamage( enemy, 1, "DAMAGE_SLICE", "Alligator Bite", "BLOOD_EXPLOSION", 0, 0, root_id, enemy_x, enemy_y, 1000)

	end
end