dofile_once("data/scripts/lib/utilities.lua")

local range = 300

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

function get_distance(dx, dy, dx2, dy2)
	return math.sqrt(((dx-dx2)^2) + ((dy-dy2)^2))
end
--local x,y = EntityGetTransform( entity_id )
local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	players = {player}
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		players = {polymorphed_player}
	end
end


if #players > 0 then
	local target = players[1]
	local tx, ty = EntityGetTransform(target)
	local dist = get_distance(tx, ty, x, y)

	if dist > range then
	
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", false)

		for i, child in ipairs(EntityGetAllChildren(entity_id) or {}) do
		  
		  if EntityGetName(child) == "spine" then
		  
			EntityKill(child)
			
		  end
		  
		end
		
	else
	
		local value = GetValueNumber("timeout_frames", 0)
		
		if value >= 1 then
			EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)
		end
		
		SetValueNumber("timeout_frames", value + 1)
	
		spines = 0

		for i, child in ipairs(EntityGetAllChildren(entity_id) or {}) do

		  if EntityGetName(child) == "spine" then
			spines = spines + 1
		  end
		
		end
		
		if spines < 5 then
		
			for i, child in ipairs(EntityGetAllChildren(entity_id) or {}) do
			  
				if EntityGetName(child) == "spine" then
			  
					EntityKill(child)
					
				end

			end
		
		end
		
		if spines == 0 then
			
		    local ent = EntityLoad("data/entities/verlet_chains/beanpodupine/verlet.xml", x, y)
			EntitySetTransform( ent, x, y )
			local inherit_comp = EntityAddComponent2(ent, "InheritTransformComponent")
			local tx, ty, scale_x, scale_y, rot = ComponentGetValue2(inherit_comp, "Transform")
			ComponentSetValue2(inherit_comp, "Transform", 4, -6, scale_x, scale_y, rot)
			EntitySetName(ent, "spine")
			EntityAddChild(entity_id, ent)
			
		    local ent = EntityLoad("data/entities/verlet_chains/beanpodupine/verlet.xml", x, y)
			EntitySetTransform( ent, x, y )
			local inherit_comp = EntityAddComponent2(ent, "InheritTransformComponent")
			local tx, ty, scale_x, scale_y, rot = ComponentGetValue2(inherit_comp, "Transform")
			ComponentSetValue2(inherit_comp, "Transform", 1, -6, scale_x, scale_y, rot)
			EntitySetName(ent, "spine")
			EntityAddChild(entity_id, ent)
			
		    local ent = EntityLoad("data/entities/verlet_chains/beanpodupine/verlet.xml", x, y)
			EntitySetTransform( ent, x, y )
			local inherit_comp = EntityAddComponent2(ent, "InheritTransformComponent")
			local tx, ty, scale_x, scale_y, rot = ComponentGetValue2(inherit_comp, "Transform")
			ComponentSetValue2(inherit_comp, "Transform", -3, -4, scale_x, scale_y, rot)
			EntitySetName(ent, "spine")
			EntityAddChild(entity_id, ent)
			
		    local ent = EntityLoad("data/entities/verlet_chains/beanpodupine/verlet.xml", x, y)
			EntitySetTransform( ent, x, y )
			local inherit_comp = EntityAddComponent2(ent, "InheritTransformComponent")
			local tx, ty, scale_x, scale_y, rot = ComponentGetValue2(inherit_comp, "Transform")
			ComponentSetValue2(inherit_comp, "Transform", -6, -1, scale_x, scale_y, rot)
			EntitySetName(ent, "spine")
			EntityAddChild(entity_id, ent)
			
		    local ent = EntityLoad("data/entities/verlet_chains/beanpodupine/verlet.xml", x, y)
			EntitySetTransform( ent, x, y )
			local inherit_comp = EntityAddComponent2(ent, "InheritTransformComponent")
			local tx, ty, scale_x, scale_y, rot = ComponentGetValue2(inherit_comp, "Transform")
			ComponentSetValue2(inherit_comp, "Transform", -5, 0, scale_x, scale_y, rot)
			EntitySetName(ent, "spine")
			EntityAddChild(entity_id, ent)
			
		end

	end
	
end