dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y, rotation = EntityGetTransform(entity_id)

local times = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")

SetRandomSeed(GameGetFrameNum(), x + y + entity_id)

if times > 300 then

	--animation
	local sprite_comps = EntityGetComponent(entity_id, "SpriteComponent") or {}
	for i, comp in ipairs(sprite_comps) do

		ComponentSetValue2(comp, "rect_animation", "despawn")
		ComponentSetValue2(comp, "next_rect_animation", "despawn")
		
	end

elseif times > 120 then
	local rotate_value = 90

	rotation = rotation - math.rad(rotate_value)
	local distance_from_center = 5
	local projectile_speed = 200
	-- SetRandomSeed(GameGetFrameNum(), x + y * i)
	-- local random_angle_adjustment = math.rad(Random(-60, 60))
	local target_x = x + math.cos(rotation) * distance_from_center
	local target_y = y + math.sin(rotation) * distance_from_center

	local vel_x = math.cos(rotation) * projectile_speed
	local vel_y = math.sin(rotation) * projectile_speed

	shoot_projectile(entity_id, "data/entities/projectiles/skullblood.xml", target_x, target_y, vel_x + Random(-15, 15), vel_y  + Random(-15, 15))
end

local did_hit_root_up = Raytrace(x, y, x, y - 1)
local did_hit_root = Raytrace(x, y, x, y + 1)
local did_hit_root_right = Raytrace(x, y, x + 1, y)
local did_hit_root_left = Raytrace(x, y, x - 1, y)
if ( not did_hit_root_up ) and ( not did_hit_root ) and ( not did_hit_root_right ) and ( not did_hit_root_left ) then
	EntityKill(entity_id)
end

