dofile_once( "data/scripts/invisibility_check.lua" )

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

function get_state()
  local entity_id = GetUpdatedEntityID()
  state = state or {}
  state[entity_id] = state[entity_id] or {}
  return state[entity_id]
end

local number_of_frames = 3
local state = get_state()
state.counter = ((state.counter or 0) % number_of_frames + 1)

function get_particle_emitter_components(entity_id)
  local all_components = EntityGetAllComponents(entity_id)
  local t = {}
  for i, comp in ipairs(all_components) do
    if ComponentGetTypeName(comp) == "ParticleEmitterComponent" then
      table.insert(t, comp)
    end
  end
  return t
end

local particle_emitter_components = get_particle_emitter_components(entity_id)
local current = state.counter - 1
if current <= 0 then
  current = current + number_of_frames
end
local next = (current % number_of_frames) + 1

EntitySetComponentIsEnabled(entity_id, particle_emitter_components[current], false)
EntitySetComponentIsEnabled(entity_id, particle_emitter_components[next], true)

--disable Ghost component if player is in holy mountain:

function get_state2()
  state2 = state2 or {}
  state2[entity_id] = state2[entity_id] or {
    last_frame_hit = 0
  }
  return state2[entity_id]
end

local state2 = get_state2()
local frames_active_after_getting_hit = 600

function damage_received()
  state2.last_frame_hit = GameGetFrameNum()
end

local is_angry = state2.last_frame_hit + frames_active_after_getting_hit > GameGetFrameNum()

local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	players = {player}
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		players = {polymorphed_player}
	end
end

local ghost_component = EntityGetFirstComponentIncludingDisabled(entity_id, "GhostComponent")

if not is_angry and BiomeMapGetName() == "$biome_holymountain" and #players > 0 then
	EntitySetComponentIsEnabled( entity_id, ghost_component, false )
elseif is_angry and BiomeMapGetName() == "$biome_holymountain" and #players > 0 then
	EntitySetComponentIsEnabled( entity_id, ghost_component, true )
else
	EntitySetComponentIsEnabled( entity_id, ghost_component, true )
end

local times = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")

if ( #players > 0 ) and ( is_invisible(players[1]) == true ) then

	for _, child in ipairs(EntityGetAllChildren(entity_id) or {} ) do
		if EntityGetName(child) == "Ghost Target" then
			target_id = child
			tx, ty = EntityGetTransform(target_id)
		end
	end
	
	SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
	
	if times % 12 == 0 then
		EntitySetTransform( target_id, x + Random(-200, 200), y + Random(-200, 200))
		ComponentSetValue2( ghost_component, "mNextTargetCheckFrame", GameGetFrameNum() )
	end
	
	tx, ty = EntityGetTransform(target_id)
	
	local ghost_component = EntityGetFirstComponentIncludingDisabled(entity_id, "GhostComponent")
	if ( ghost_component ~= nil ) and ( ghost_component > 0 ) then
		ComponentSetValue2( ghost_component, "mTargetEntityId", target_id )
		ComponentSetValue2( ghost_component, "mTargetPosition", tx, ty )
		ComponentSetValue2( ghost_component, "mRandomTarget", tx, ty )
	end
end