dofile_once("data/scripts/lib/utilities.lua")
dofile_once( "data/scripts/invisibility_check.lua" )

local times_executed = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")
local entity_id    = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

local phase = GetValueNumber("number", 1)
local delay = GetValueNumber("number2", 0)

-- GamePrint(tostring(phase) .. " " .. tostring(delay))

local enemy, enemy_x, enemy_y
for _,id in pairs(EntityGetInRadiusWithTag(x, y, 400, "mortal") or {}) do
	-- is target a valid enemy
	if ( entity_id ~= id ) and ( EntityGetFirstComponent(id, "GenomeDataComponent") ~= nil ) and ( EntityGetFirstComponent(id, "GenomeDataComponent") > 0 ) and (EntityGetHerdRelation(entity_id, id) < 40) and ( is_invisible(id) == false ) then
		local ex, ey = EntityGetFirstHitboxCenter( id )
		local did_hit, hit_x, hit_y = RaytracePlatforms(x, y - 5, ex, ey)
		if phase == 1 then
			if not did_hit then
				enemy = id
				enemy_x = ex
				enemy_y = ey
				
				SetValueNumber("number2", delay + 1)
			end
		elseif phase == 2 then
			if did_hit then
				enemy = id
				enemy_x = ex
				enemy_y = ey
				
				SetValueNumber("number2", delay + 1)
			else
				SetValueNumber("number2", 0)
			end
		end
	end
end
	
if phase == 1 then
	local did_hit2 = RaytracePlatforms(x, y, x, y + 150)
	if ( enemy ~= nil ) and ( enemy > 0 ) and ( delay > 22 ) and ( did_hit2 ) then
	
		local child = EntityLoad( "data/entities/particles/bluemancer_transform.xml", x, y )
		EntityAddChild(entity_id, child)
		
		SetValueNumber("number2", 0)
		EntitySetTransform( entity_id, x, y + 5)

		-- EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", false)

		local sprite_component = EntityGetFirstComponentIncludingDisabled(entity_id, "SpriteComponent")
		if ( sprite_component ~= nil ) and ( sprite_component > 0 ) then
			ComponentSetValue2( sprite_component, "alpha", 0 )
			ComponentSetValue2( sprite_component, "image_file", "data/enemies_gfx/bluemancer_land.xml" )
			EntityRefreshSprite( entity_id, sprite_component )
			ComponentSetValue2( sprite_component, "rect_animation", "land" )
			ComponentSetValue2( sprite_component, "next_rect_animation", "land" )
		end
		
		local sprite_stains_component = EntityGetFirstComponentIncludingDisabled(entity_id, "SpriteStainsComponent")
		if ( sprite_stains_component ~= nil ) and ( sprite_stains_component > 0 ) then
			EntityRemoveComponent( entity_id, sprite_stains_component )
			EntityAddComponent(entity_id, "SpriteStainsComponent", {})
		end

		local animal_ai_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AnimalAIComponent")
		if ( animal_ai_component ~= nil ) and ( animal_ai_component > 0 ) then
			ComponentSetValue2( animal_ai_component, "attack_dash_enabled", true )
			ComponentSetValue2( animal_ai_component, "attack_melee_enabled", true )
			ComponentSetValue2( animal_ai_component, "can_fly", false )
			ComponentSetValue2( animal_ai_component, "can_walk", false )
			ComponentSetValue2( animal_ai_component, "attack_ranged_offset_y", -14 )
			ComponentSetValue2( animal_ai_component, "attack_ranged_offset_x", 3 )
			ComponentSetValue2( animal_ai_component, "attack_ranged_action_frame", 5 )
			ComponentSetValue2( animal_ai_component, "attack_ranged_frames_between", 120 )
			ComponentSetValue2( animal_ai_component, "ai_state", 18 )
		end

		local damage_model_component = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")
		if ( damage_model_component ~= nil ) and ( damage_model_component > 0 ) then
			ComponentSetValue2( damage_model_component, "minimum_knockback_force", 10000000 )
			ComponentSetValue2( damage_model_component, "ragdoll_filenames_file", "data/ragdolls/bluemancer/filenames2.txt" )
		end

		local character_data_component = EntityGetFirstComponentIncludingDisabled(entity_id, "CharacterDataComponent")
		if ( character_data_component ~= nil ) and ( character_data_component > 0 ) then
			ComponentSetValue2( character_data_component, "collision_aabb_min_x", -2 )
			ComponentSetValue2( character_data_component, "collision_aabb_max_x", 2 )
			ComponentSetValue2( character_data_component, "collision_aabb_min_y", -10 )
			ComponentSetValue2( character_data_component, "collision_aabb_max_y", 3 )
			ComponentSetValue2( character_data_component, "flying_needs_recharge", true )
		end

		local pathfinding_component = EntityGetFirstComponentIncludingDisabled(entity_id, "PathFindingComponent")
		if ( pathfinding_component ~= nil ) and ( pathfinding_component > 0 ) then
			ComponentSetValue2( pathfinding_component, "can_swim_on_surface", true )
			ComponentSetValue2( pathfinding_component, "can_jump", true )
			ComponentSetValue2( pathfinding_component, "can_fly", false )
			ComponentSetValue2( pathfinding_component, "can_walk", true )
			ComponentSetValue2( pathfinding_component, "cost_of_flying", 9999999 )
		end

		local hitbox_component = EntityGetFirstComponent(entity_id, "HitboxComponent")
		if ( hitbox_component ~= nil ) and ( hitbox_component > 0 ) then
			ComponentSetValue2( hitbox_component, "aabb_min_y", -20 )
			ComponentSetValue2( hitbox_component, "aabb_max_y", 3 )
			ComponentSetValue2( hitbox_component, "aabb_min_x", -4.5 )
			ComponentSetValue2( hitbox_component, "aabb_max_x", 4.5 )
		end
		SetValueNumber("number", 2)
	end
elseif phase == 2 then
	
	if ( enemy ~= nil ) and ( enemy > 0 ) and ( delay > 22 ) then
	
		local child = EntityLoad( "data/entities/particles/bluemancer_transform_normal.xml", x, y )
		EntityAddChild(entity_id, child)
		
		SetValueNumber("number2", 0)

		-- EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)
		
		local sprite_stains_component = EntityGetFirstComponentIncludingDisabled(entity_id, "SpriteStainsComponent")
		if ( sprite_stains_component ~= nil ) and ( sprite_stains_component > 0 ) then
			EntityRemoveComponent( entity_id, sprite_stains_component )
			EntityAddComponent(entity_id, "SpriteStainsComponent", {})
		end

		local sprite_component = EntityGetFirstComponentIncludingDisabled(entity_id, "SpriteComponent")
		if ( sprite_component ~= nil ) and ( sprite_component > 0 ) then
			ComponentSetValue2( sprite_component, "alpha", 0 )
			ComponentSetValue2( sprite_component, "image_file", "data/enemies_gfx/bluemancer.xml" )
			EntityRefreshSprite( entity_id, sprite_component )
			ComponentSetValue2( sprite_component, "rect_animation", "spawn" )
			ComponentSetValue2( sprite_component, "next_rect_animation", "spawn" )
		end

		local animal_ai_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AnimalAIComponent")
		if ( animal_ai_component ~= nil ) and ( animal_ai_component > 0 ) then
			ComponentSetValue2( animal_ai_component, "attack_dash_enabled", false )
			ComponentSetValue2( animal_ai_component, "attack_melee_enabled", false )
			ComponentSetValue2( animal_ai_component, "can_fly", true )
			ComponentSetValue2( animal_ai_component, "can_walk", false )
			ComponentSetValue2( animal_ai_component, "attack_ranged_offset_y", -3 )
			ComponentSetValue2( animal_ai_component, "attack_ranged_action_frame", 3 )
			ComponentSetValue2( animal_ai_component, "ai_state", 18 )
			ComponentSetValue2( animal_ai_component, "attack_ranged_frames_between", 30 )
		end

		local damage_model_component = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")
		if ( damage_model_component ~= nil ) and ( damage_model_component > 0 ) then
			ComponentSetValue2( damage_model_component, "minimum_knockback_force", 0 )
			ComponentSetValue2( damage_model_component, "ragdoll_filenames_file", "data/ragdolls/bluemancer/filenames.txt" )
		end

		local character_data_component = EntityGetFirstComponentIncludingDisabled(entity_id, "CharacterDataComponent")
		if ( character_data_component ~= nil ) and ( character_data_component > 0 ) then
			ComponentSetValue2( character_data_component, "collision_aabb_min_x", -4 )
			ComponentSetValue2( character_data_component, "collision_aabb_max_x", 4 )
			ComponentSetValue2( character_data_component, "collision_aabb_min_y", -10 )
			ComponentSetValue2( character_data_component, "collision_aabb_max_y", 3 )
			ComponentSetValue2( character_data_component, "flying_needs_recharge", false )
		end

		local pathfinding_component = EntityGetFirstComponentIncludingDisabled(entity_id, "PathFindingComponent")
		if ( pathfinding_component ~= nil ) and ( pathfinding_component > 0 ) then
			ComponentSetValue2( pathfinding_component, "can_swim_on_surface", false )
			ComponentSetValue2( pathfinding_component, "can_jump", false )
			ComponentSetValue2( pathfinding_component, "can_fly", true )
			ComponentSetValue2( pathfinding_component, "can_walk", false )
			ComponentSetValue2( pathfinding_component, "cost_of_flying", 0 )
		end

		local hitbox_component = EntityGetFirstComponent(entity_id, "HitboxComponent")
		if ( hitbox_component ~= nil ) and ( hitbox_component > 0 ) then
			ComponentSetValue2( hitbox_component, "aabb_min_y", -8 )
			ComponentSetValue2( hitbox_component, "aabb_max_y", 3 )
			ComponentSetValue2( hitbox_component, "aabb_min_x", -4.5 )
			ComponentSetValue2( hitbox_component, "aabb_max_x", 4.5 )
		end
		SetValueNumber("number", 1)
	end
	-- if times_executed % 12 == 0 then
		-- shoot_projectile( entity_id, "data/entities/projectiles/phantom_boss_wave_projectile2.xml", x, y, 0, 2000 )
	-- end
end