dofile_once( "data/scripts/lib/utilities.lua" )

function collision_trigger(colliding_entity)
	local entity_id = GetUpdatedEntityID()

	local x, y = EntityGetTransform( entity_id )
	  
	local did_hit, hit_x, hit_y = RaytraceSurfaces(x - 5, y - 13, x + 5, y - 13)
	  
	if not did_hit then
		
		EntitySetComponentsWithTagEnabled(entity_id, "shoot_pos", true)
		EntitySetComponentsWithTagEnabled(entity_id, "kick_pos", false)

		local animal_ai_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AnimalAIComponent")
		if ( animal_ai_component ~= nil ) and ( animal_ai_component > 0 ) then
			ComponentSetValue2( animal_ai_component, "attack_ranged_offset_y", 0 )
			ComponentSetValue2( animal_ai_component, "eye_offset", -6 )
		end
		
		local damage_model_component = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")
		if ( damage_model_component ~= nil ) and ( damage_model_component > 0 ) then
			ComponentSetValue2( damage_model_component, "ragdoll_filenames_file", "data/ragdolls/bloom/filenames.txt" )
			ComponentSetValue2( damage_model_component, "minimum_knockback_force", 0 )
		end

		local character_platforming_component = EntityGetFirstComponentIncludingDisabled(entity_id, "CharacterPlatformingComponent")
		if ( character_platforming_component ~= nil ) and ( character_platforming_component > 0 ) then
			ComponentSetValue2( character_platforming_component, "pixel_gravity", 600 )
			ComponentSetValue2( character_platforming_component, "jump_velocity_y", -12 )
			ComponentSetValue2( character_platforming_component, "run_velocity", 12 )
			ComponentSetValue2( character_platforming_component, "velocity_min_x", -50 )
			ComponentSetValue2( character_platforming_component, "velocity_max_x", 50 )
			ComponentSetValue2( character_platforming_component, "velocity_min_y", -500 )
			ComponentSetValue2( character_platforming_component, "velocity_max_y", 500 )
		end
		
		local pathfinding_component = EntityGetFirstComponentIncludingDisabled(entity_id, "PathFindingComponent")
		if ( pathfinding_component ~= nil ) and ( pathfinding_component > 0 ) then
			ComponentSetValue2( pathfinding_component, "can_swim_on_surface", true )
			ComponentSetValue2( pathfinding_component, "can_dive", true )
			ComponentSetValue2( pathfinding_component, "can_jump", true )
			ComponentSetValue2( pathfinding_component, "can_walk", true )
		end
		
		local lua_comps = EntityGetComponentIncludingDisabled(entity_id, "LuaComponent") or {}

		for i, lua_comp in ipairs(lua_comps) do
			if ComponentGetValue2(lua_comp, "script_shot") == "data/scripts/projectiles/bloom_ceiling_shot.lua" then
				ComponentSetValue2( lua_comp, "script_shot", "data/scripts/projectiles/bloom_shot.lua" )
			end
		end
	end
end