dofile_once( "data/scripts/lib/utilities.lua" )

function collision_trigger(colliding_entity)
	local entity_id = GetUpdatedEntityID()

	local x, y = EntityGetTransform( entity_id )
	  
	local did_hit, hit_x, hit_y = RaytraceSurfaces(x - 3, y - 11, x + 3, y - 11)
	  
	if not did_hit then
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", false)
		
		local sprite_component = EntityGetFirstComponentIncludingDisabled(entity_id, "SpriteComponent")
		if ( sprite_component ~= nil ) and ( sprite_component > 0 ) then
			ComponentSetValue2( sprite_component, "image_file", "data/enemies_gfx/landflower.xml" )
			EntityRefreshSprite( entity_id, sprite_component )
			ComponentSetValue2( sprite_component, "offset_x", 12 )
			ComponentSetValue2( sprite_component, "offset_y", 21 )
			-- ComponentSetValue2( damage_model_component, "ragdoll_offset_y", 1 )
		end
		
		local animal_ai_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AnimalAIComponent")
		if ( animal_ai_component ~= nil ) and ( animal_ai_component > 0 ) then
			ComponentSetValue2( animal_ai_component, "attack_ranged_offset_y", -17 )
			-- ComponentSetValue2( animal_ai_component, "attack_ranged_offset_x", 3 )
			-- ComponentSetValue2( animal_ai_component, "eye_offset", -6 )
		end
		
		local damage_model_component = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")
		if ( damage_model_component ~= nil ) and ( damage_model_component > 0 ) then
			ComponentSetValue2( damage_model_component, "ragdoll_filenames_file", "data/ragdolls/landflower/filenames.txt" )
			ComponentSetValue2( damage_model_component, "minimum_knockback_force", 0 )
			-- ComponentSetValue2( damage_model_component, "ragdoll_offset_y", 1 )
		end

		local character_data_component = EntityGetFirstComponentIncludingDisabled(entity_id, "CharacterDataComponent")
		if ( character_data_component ~= nil ) and ( character_data_component > 0 ) then
			ComponentSetValue2( character_data_component, "collision_aabb_min_x", -2.5 )
			ComponentSetValue2( character_data_component, "collision_aabb_max_x", 2.5 )
			ComponentSetValue2( character_data_component, "collision_aabb_min_y", -17 )
			ComponentSetValue2( character_data_component, "collision_aabb_max_y", 3 )
			ComponentSetValue2( character_data_component, "mass", 1.8 )
		end

		local character_platforming_component = EntityGetFirstComponentIncludingDisabled(entity_id, "CharacterPlatformingComponent")
		if ( character_platforming_component ~= nil ) and ( character_platforming_component > 0 ) then
			ComponentSetValue2( character_platforming_component, "pixel_gravity", 600 )
			ComponentSetValue2( character_platforming_component, "jump_velocity_y", -12 )
			ComponentSetValue2( character_platforming_component, "run_velocity", 12 )
			ComponentSetValue2( character_platforming_component, "velocity_min_x", -50 )
			ComponentSetValue2( character_platforming_component, "velocity_max_x", 50 )
			ComponentSetValue2( character_platforming_component, "velocity_min_y", -500 )
			ComponentSetValue2( character_platforming_component, "velocity_max_y", 500 )
		end
		
		local hitbox_component = EntityGetFirstComponent(entity_id, "HitboxComponent")
		if ( hitbox_component ~= nil ) and ( hitbox_component > 0 ) then
			ComponentSetValue2( hitbox_component, "aabb_min_y", -16 )
			ComponentSetValue2( hitbox_component, "aabb_max_y", 3 )
			ComponentSetValue2( hitbox_component, "aabb_min_x", -4.5 )
			ComponentSetValue2( hitbox_component, "aabb_max_x", 4.5 )
		end
		
		local pathfinding_component = EntityGetFirstComponentIncludingDisabled(entity_id, "PathFindingComponent")
		if ( pathfinding_component ~= nil ) and ( pathfinding_component > 0 ) then
			ComponentSetValue2( pathfinding_component, "can_swim_on_surface", true )
			ComponentSetValue2( pathfinding_component, "can_dive", true )
			ComponentSetValue2( pathfinding_component, "can_jump", true )
			ComponentSetValue2( pathfinding_component, "can_walk", true )
		end
	end
end