local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local variable_component = EntityGetFirstComponentIncludingDisabled(entity_id, "VariableStorageComponent")
if ( variable_component ~= nil ) and ( variable_component > 0 ) then
	local value = ComponentGetValue2(variable_component, "value_int")
	if value == 0 then

		SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

		local orientation = Random(1,2)
		if orientation == 2 then
			-- EntitySetComponentsWithTagEnabled(entity_id, "shoot_pos", true)
			-- EntitySetComponentsWithTagEnabled(entity_id, "kick_pos", false)
			EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", true)
			
			local sprite_component = EntityGetFirstComponentIncludingDisabled(entity_id, "SpriteComponent")
			if ( sprite_component ~= nil ) and ( sprite_component > 0 ) then
				ComponentSetValue2( sprite_component, "image_file", "data/enemies_gfx/ceilingflower.xml" )
				EntityRefreshSprite( entity_id, sprite_component )
				ComponentSetValue2( sprite_component, "offset_x", 12 )
				ComponentSetValue2( sprite_component, "offset_y", 9 )
			end

			local animal_ai_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AnimalAIComponent")
			if ( animal_ai_component ~= nil ) and ( animal_ai_component > 0 ) then
				ComponentSetValue2( animal_ai_component, "attack_ranged_offset_y", 10 )
				-- ComponentSetValue2( animal_ai_component, "attack_ranged_offset_x", 3 )
				-- ComponentSetValue2( animal_ai_component, "eye_offset", -6 )
			end
			
			local damage_model_component = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")
			if ( damage_model_component ~= nil ) and ( damage_model_component > 0 ) then
				ComponentSetValue2( damage_model_component, "minimum_knockback_force", 100000000 )
				ComponentSetValue2( damage_model_component, "ragdoll_filenames_file", "data/ragdolls/ceilingflower/filenames.txt" )
				-- ComponentSetValue2( damage_model_component, "ragdoll_offset_y", 1 )
			end

			local character_data_component = EntityGetFirstComponentIncludingDisabled(entity_id, "CharacterDataComponent")
			if ( character_data_component ~= nil ) and ( character_data_component > 0 ) then
				ComponentSetValue2( character_data_component, "collision_aabb_min_x", -2.5 )
				ComponentSetValue2( character_data_component, "collision_aabb_max_x", 2.5 )
				ComponentSetValue2( character_data_component, "collision_aabb_min_y", -10 )
				ComponentSetValue2( character_data_component, "collision_aabb_max_y", 10 )
				ComponentSetValue2( character_data_component, "mass", 1.8 )
			end

			local character_platforming_component = EntityGetFirstComponentIncludingDisabled(entity_id, "CharacterPlatformingComponent")
			if ( character_platforming_component ~= nil ) and ( character_platforming_component > 0 ) then
				ComponentSetValue2( character_platforming_component, "pixel_gravity", -600 )
				ComponentSetValue2( character_platforming_component, "jump_velocity_y", 0 )
				ComponentSetValue2( character_platforming_component, "run_velocity", 0 )
			end
			
			local hitbox_component = EntityGetFirstComponent(entity_id, "HitboxComponent")
			if ( hitbox_component ~= nil ) and ( hitbox_component > 0 ) then
				ComponentSetValue2( hitbox_component, "aabb_min_y", -9.5 )
				ComponentSetValue2( hitbox_component, "aabb_max_y", 9.5 )
				ComponentSetValue2( hitbox_component, "aabb_min_x", -4.5 )
				ComponentSetValue2( hitbox_component, "aabb_max_x", 4.5 )
			end
			
			local pathfinding_component = EntityGetFirstComponentIncludingDisabled(entity_id, "PathFindingComponent")
			if ( pathfinding_component ~= nil ) and ( pathfinding_component > 0 ) then
				ComponentSetValue2( pathfinding_component, "can_swim_on_surface", false )
				ComponentSetValue2( pathfinding_component, "can_dive", false )
				ComponentSetValue2( pathfinding_component, "can_jump", false )
				ComponentSetValue2( pathfinding_component, "can_walk", false )
			end

		-- else
			-- EntitySetComponentsWithTagEnabled(entity_id, "shoot_pos", false)
			-- EntitySetComponentsWithTagEnabled(entity_id, "kick_pos", true)
		end

		local variable_component = EntityGetFirstComponentIncludingDisabled(entity_id, "VariableStorageComponent")
		if ( variable_component ~= nil ) and ( variable_component > 0 ) then
			ComponentSetValue2( variable_component, "value_int", orientation )
		end
	end
end