function collision_trigger(colliding_entity)
	dofile_once( "data/scripts/invisibility_check.lua" )
	local entity_id = GetUpdatedEntityID()
	local times = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")
	if ( times > 120 ) and ( EntityGetFirstComponent(colliding_entity, "GenomeDataComponent") ~= nil ) and ( EntityGetFirstComponent(colliding_entity, "GenomeDataComponent") > 0 ) and ( EntityGetHerdRelation(entity_id, colliding_entity) < 40 ) and ( is_invisible(colliding_entity) == false ) then
	
		local x, y, rot, scale_x = EntityGetTransform(entity_id)

		-- if #players > 0 then
		  
		local player_x, player_y = EntityGetTransform(colliding_entity)
		local animation_id = EntityLoad( "data/entities/animals/chest_great_mimic_transform.xml", x, y )
		EntitySetTransform(animation_id, x, y, rot, scale_x)
		
		--Killing the entity:
		EntityAddComponent(entity_id, "VariableStorageComponent", {
			_tags="no_gold_drop",
		})
		
		local damage_model_component = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")
		
		ComponentSetValue2(damage_model_component, "create_ragdoll", false)
		ComponentSetValue2(damage_model_component, "hp", 0)
		ComponentSetValue2(damage_model_component, "air_needed", true)
		ComponentSetValue2(damage_model_component, "air_in_lungs", 0)
		
		GamePlaySound("data/audio/Desktop/animals.bank", "animals/necromancer_shop/death", x, y)
			
		-- end
		
	end
	
end

function damage_received( dmg, msg, source, is_fatal)
	local entity_id = GetUpdatedEntityID()
	local x, y, rot, scale_x = EntityGetTransform(entity_id)
	local players = {}
	local player = EntityGetWithName( "DEBUG_NAME:player" )
	if ( player ~= nil ) and ( player > 0 ) then
		players = {player}
	else
		local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
		if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
			players = {polymorphed_player}
		end
	end

	if #players > 0 then
		player = players[1]
		if source == player then

			local animation_id = EntityLoad( "data/entities/animals/chest_great_mimic_transform.xml", x, y )
			EntitySetTransform(animation_id, x, y, rot, scale_x)
			
			--Killing the entity:
			EntityAddComponent(entity_id, "VariableStorageComponent", {
				_tags="no_gold_drop",
			})
			
			local damage_model_component = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")
			
			ComponentSetValue2(damage_model_component, "create_ragdoll", false)
			ComponentSetValue2(damage_model_component, "hp", 0)
			ComponentSetValue2(damage_model_component, "air_needed", true)
			ComponentSetValue2(damage_model_component, "air_in_lungs", 0)
			
			GamePlaySound("data/audio/Desktop/animals.bank", "animals/necromancer_shop/death", x, y)
		end
	end
end

function physics_body_modified( is_destroyed )
	local entity_id = GetUpdatedEntityID()

	local x, y, rot, scale_x = EntityGetTransform(entity_id)

	local animation_id = EntityLoad( "data/entities/animals/chest_great_mimic_transform.xml", x, y )
	EntitySetTransform(animation_id, x, y, rot, scale_x)
	
	--Killing the entity:
	EntityAddComponent(entity_id, "VariableStorageComponent", {
		_tags="no_gold_drop",
	})
	
	local damage_model_component = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")
	
	ComponentSetValue2(damage_model_component, "create_ragdoll", false)
	ComponentSetValue2(damage_model_component, "hp", 0)
	ComponentSetValue2(damage_model_component, "air_needed", true)
	ComponentSetValue2(damage_model_component, "air_in_lungs", 0)
	
	GamePlaySound("data/audio/Desktop/animals.bank", "animals/necromancer_shop/death", x, y)
end