dofile_once("data/scripts/lib/utilities.lua")

local range = 400

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	players = {player}
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		players = {polymorphed_player}
	end
end

if #players > 0 then
	local target = players[1]

	local tx, ty = EntityGetTransform(target)
	local dist = get_distance(tx, ty, x, y)

	if dist > range then
	
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", false)
		
		local variable_storage = EntityGetComponent(entity_id, "VariableStorageComponent")
		
		for k, v in pairs(variable_storage)do
			local name = ComponentGetValue2(v, "name")
			if(name == "verlet_entity")then
				EntityRemoveComponent( entity_id, v )
			end
		end

		for i, child in ipairs(EntityGetAllChildren(entity_id)  or {}) do
			-- EntitySetComponentsWithTagEnabled(child, "enabled_in_world", false)
			
			EntityKill(child)
		end
		
	else
	
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)
		
		-- for i, child in ipairs(EntityGetAllChildren(entity_id)  or {}) do
			-- EntitySetComponentsWithTagEnabled(child, "enabled_in_world", true)
		-- end

	end
	
end