dofile_once( "data/scripts/invisibility_check.lua" )

function get_state()
  local entity_id = GetUpdatedEntityID()
  state = state or {}
  state[entity_id] = state[entity_id] or {}
  return state[entity_id]
end

function get_direction( x1, y1, x2, y2 )
  return math.atan2( ( y2 - y1 ), ( x2 - x1 ) )
end

local state = get_state()

local frames_to_bite = 10

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
state.prev_x = state.prev_x or x
state.prev_y = state.prev_y or y
local vx, vy = x - state.prev_x, y - state.prev_y
local worm_component = EntityGetFirstComponent(entity_id, "WormComponent")
local target_kill_radius = ComponentGetValue2(worm_component, "target_kill_radius")

local entities = EntityGetInRadiusWithTag(x + vx * frames_to_bite, y + vy * frames_to_bite, target_kill_radius + 5, "hittable")
local child_entities = EntityGetAllChildren(entity_id) or {}
local face_entity
for i, v in ipairs(child_entities) do
  if EntityGetName(v) == "face_worm_head" then
    face_entity = v
    break
  end
end

local sprite_component = EntityGetFirstComponent(face_entity, "SpriteComponent")
local dir = get_direction(vx, vy, 0, 0)
local fx, fy = EntityGetTransform(face_entity)
EntitySetTransform(face_entity, fx, fy, dir)
local mFrameNextDamage = ComponentGetValue2(worm_component, "mFrameNextDamage")

if #entities > 1 and (GameGetFrameNum() - mFrameNextDamage > 0) then
  local an = ComponentGetValue2(sprite_component, "rect_animation")
  if an ~= "bite" then
    ComponentSetValue2(sprite_component, "rect_animation", "bite")
  end
end

state.prev_x = x
state.prev_y = y

--GOTO PLAYER
function get_distance(dx, dy, dx2, dy2)
    return math.sqrt(((dx-dx2)^2) + ((dy-dy2)^2))
end
--local x, y = EntityGetTransform(entity_id)
local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	local px, py = EntityGetTransform(player)
	local dist = get_distance(x, y, px, py)
	if dist <= 150 then
		players = {player}
	end
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		local px, py = EntityGetTransform(polymorphed_player)
		local dist = get_distance(x, y, px, py)
		if dist <= 150 then
			players = {polymorphed_player}
		end
	end
end

if #players > 0 then
  
  local worm_ai_component = EntityGetFirstComponentIncludingDisabled( entity_id, "WormAIComponent")

  if worm_ai_component and ( EntityGetFirstComponent(players[1], "GenomeDataComponent") ~= nil ) and ( EntityGetFirstComponent(players[1], "GenomeDataComponent") > 0 ) and ( EntityGetHerdRelation(entity_id, players[1]) < 40 ) and ( is_invisible(players[1]) == false ) then
	ComponentSetValue2( worm_ai_component, "mTargetEntityId", players[1] )
  end
end
