local times = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")

dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local x, y, rot, scale_x  = EntityGetTransform(entity_id)

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

local physics_body_component = EntityGetFirstComponent(entity_id, "PhysicsBodyComponent")

-- local number = GetValueNumber("number", 10)

-- GamePrint(number)

local facing_right = scale_x
local thrusting = 1
local scale = 1
local targ_x = x
local targ_y = y
local state = 18
	
if times % 10 == 0 then


	-- SetValueNumber( "number", Random(8, 12) )
	local top_corner = { x1 = 0, y1 = -5 }
	local top_x, top_y = vec_rotate(top_corner.x1, top_corner.y1, rot)
	top_x = x + top_x
	top_y = y + top_y

	local bottom_corner = { x1 = -4, y1 = 1 }
	local bottom_x, bottom_y = vec_rotate(bottom_corner.x1, bottom_corner.y1, rot)
	bottom_x = x + (bottom_x * scale_x)
	bottom_y = y + bottom_y

	--do nothing if there's no target
	local animal_ai_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AnimalAIComponent")
	if ( animal_ai_component ~= nil ) and ( animal_ai_component > 0 ) then
		state = ComponentGetValue2(animal_ai_component, "ai_state")
		
		pathfinding_component = EntityGetFirstComponentIncludingDisabled(entity_id, "PathFindingComponent")
		targ_x, targ_y = ComponentGetValueVector2(pathfinding_component, "path_next_node_vector_to")
	end


	local has_player_tag = EntityHasTag(entity_id, "polymorphed_player")
	if has_player_tag == true then
		local comps = EntityGetAllComponents(entity_id)
		local concomp = nil
		for i,v in ipairs(comps) do
			if ComponentGetTypeName(v) == "ControlsComponent" then concomp = v; break end
		end
		local input = {
			ComponentGetValue(concomp, "mButtonDownRight"), --right
			ComponentGetValue(concomp, "mButtonDownUp"), --up
			ComponentGetValue(concomp, "mButtonDownLeft"), --left
			ComponentGetValue(concomp, "mButtonDownDown"), --down
		}
		
		local tx = x
		local ty = y
		if input[1] == "1" then tx = tx + 100 facing_right = 1 end
		if input[2] == "1" then ty = ty - 100 end
		if input[3] == "1" then tx = tx - 100  facing_right = -1 end
		if input[4] == "1" then ty = ty + 100  thrusting = 0 end
		
		targ_x = tx
		targ_y = ty
	elseif ( targ_x == 0 ) and ( targ_y == 0 ) then
		EntitySetComponentsWithTagEnabled(entity_id, "pitcheck_b", false)
	else
		EntitySetComponentsWithTagEnabled(entity_id, "pitcheck_b", true)
	end
	
	-- local velcomp = EntityGetFirstComponent(entity_id, "CharacterDataComponent")
	-- local vel_comp_x, vel_comp_y = ComponentGetValue2(velcomp, "mVelocity")
	
	if ( physics_body_component ~= nil ) and ( physics_body_component > 0 ) then
		local physvelx, physvely = PhysicsGetComponentVelocity( entity_id, physics_body_component )
		
		if ( x + physvelx ) > x then
			scale = 1
		elseif ( x + physvelx ) < x then
			scale = -1
		end
	end
	if has_player_tag == false then
		EntitySetTransform(entity_id, x, y, rot, scale )
	else
		EntitySetTransform(entity_id, x, y, rot, facing_right )
	end
	
	local x, y = EntityGetTransform(entity_id)

	local path_is_stuck = ComponentGetValue2(pathfinding_component, "path_is_stuck")
	local path_frames_stuck = ComponentGetValue2(pathfinding_component, "path_frames_stuck")

	local rotate_value = -90

	local rotation = rot - math.rad(rotate_value)
	local distance_from_center = 5
	local projectile_speed = 100
	-- SetRandomSeed(GameGetFrameNum(), x + y * i)
	-- local random_angle_adjustment = math.rad(Random(-60, 60))
	-- local target_x = x + math.cos(rotation) * distance_from_center
	-- local target_y = y + math.sin(rotation) * distance_from_center

	local vel_x = math.cos(rotation) * projectile_speed
	local vel_y = math.sin(rotation) * projectile_speed

	for i = 1, Random(1,3) do
		shoot_projectile(entity_id, "data/entities/projectiles/fireworkman/firework" .. Random(1,4) .. ".xml", bottom_x, bottom_y, vel_x, vel_y)
	end
	
	if ( physics_body_component ~= nil ) and ( physics_body_component > 0 ) then
		if top_y < (y - 3) then
			if has_player_tag == true then
				if ( targ_x ) > x then
					PhysicsApplyTorque(entity_id, 6)
				elseif ( targ_x ) < x then
					PhysicsApplyTorque(entity_id, -6)
				end
			else
				if ( x + targ_x ) > x then
					PhysicsApplyTorque(entity_id, 3)
				elseif ( x + targ_x ) < x then
					PhysicsApplyTorque(entity_id, -3)
				end
			end
		end

		if ( y + targ_y ) > y then
			PhysicsApplyForce(entity_id, -vel_x * 4, -vel_y * 2 * thrusting)
			-- ComponentSetValueVector2( velcomp, "mVelocity", vel_comp_x + vel_x, vel_comp_y + vel_y )
		elseif ( y + targ_y ) < y then
			PhysicsApplyForce(entity_id, -vel_x * 5, -vel_y * 5 * thrusting)
			-- ComponentSetValueVector2( velcomp, "mVelocity", vel_comp_x + (vel_x * 5), vel_comp_y + (vel_y * 5) )
		end

		-- GameCreateSpriteForXFrames( "data/debug/sui_close_button.png", x + targ_x, y + targ_y, true, 0, 0, 1, true )

		PhysicsApplyTorque(entity_id, -rot * 30)
	
	end

	if ( state == 0 ) or path_is_stuck or ( path_frames_stuck > 200 ) then
		ComponentSetValue2( animal_ai_component, "ai_state", 1 )
	end
end

if ( times ~= nil ) and ( times >= 10 ) then
	if ( physics_body_component ~= nil ) and ( physics_body_component > 0 ) then
		local found, nx, ny, apd = GetSurfaceNormal(x, y, 9, 16)
		local physx, physy = PhysicsComponentGetTransform( physics_body_component )
		-- GamePrint(tostring(physics_body_component) .. " " .. tostring(physx) .. " " .. tostring(physy))
		if physx then
			if found then
				nx = nx * (math.abs(apd) + 4)
				ny = ny * (math.abs(apd) + 4)
			else
				nx = 0
				ny = 0
			end

			PhysicsComponentSetTransform( physics_body_component, physx - (nx * 0.01), physy - (ny * 0.01))
		end
	end
end
-- ComponentSetValue2(GetUpdatedComponentID(), "execute_every_n_frame", Random(8, 12))