local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

--disable Ghost component if player is in holy mountain:

function get_state2()
  state2 = state2 or {}
  state2[entity_id] = state2[entity_id] or {
    last_frame_hit = 0
  }
  return state2[entity_id]
end

local state2 = get_state2()
local frames_active_after_getting_hit = 600

function damage_received()
  state2.last_frame_hit = GameGetFrameNum()
end

local is_angry = state2.last_frame_hit + frames_active_after_getting_hit > GameGetFrameNum()

function get_distance(dx, dy, dx2, dy2)
	return math.sqrt(((dx-dx2)^2) + ((dy-dy2)^2))
end

local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	players = {player}
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		players = {polymorphed_player}
	end
end
local ghost_component = EntityGetFirstComponentIncludingDisabled(entity_id, "GhostComponent")

if not is_angry and BiomeMapGetName() == "$biome_holymountain" and #players > 0 then
	EntitySetComponentIsEnabled( entity_id, ghost_component, false )
else
	EntitySetComponentIsEnabled( entity_id, ghost_component, true )
end