dofile_once("data/scripts/lib/utilities.lua")
dofile_once( "data/scripts/invisibility_check.lua" )

function collision_trigger(colliding_entity)

	local entity_id = GetUpdatedEntityID()
	local x, y = EntityGetTransform(entity_id)

	local parent_id = EntityGetRootEntity(entity_id)

	local this_lua = GetUpdatedComponentID()
	local times_executed = ComponentGetValue2(this_lua, "mTimesExecuted")

	local number = GetValueNumber("number", 0)

	if number > 0 then
		SetValueNumber("number", number - 1)
	end

	if ( times_executed % 75 == 0 ) and ( number <= 0 ) then

		local players = {}
		local player = EntityGetWithName( "DEBUG_NAME:player" )
		if ( player ~= nil ) and ( player > 0 ) then
			local px, py = EntityGetTransform(player)
			local dist = get_distance(x, y, px, py)
			if dist <= 250 then
				players = {player}
			end
		else
			local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
			if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
				local px, py = EntityGetTransform(polymorphed_player)
				local dist = get_distance(x, y, px, py)
				if dist <= 250 then
					players = {polymorphed_player}
				end
			end
		end

		if #players > 0 and ( EntityGetFirstComponent(players[1], "GenomeDataComponent") ~= nil ) and ( EntityGetFirstComponent(players[1], "GenomeDataComponent") > 0 ) and ( EntityGetHerdRelation(parent_id, players[1]) < 40 ) and ( is_invisible(players[1]) == false ) then
		  
			local player_x, player_y = EntityGetTransform(players[1])
			local did_hit, hit_x, hit_y = RaytraceSurfaces(x, y, player_x, player_y)
		  
			if not did_hit then
				SetValueNumber("number", 124)
			end
		end
	end

	if number == 124 then

		edit_component2( entity_id, "SpriteComponent", function(comp,vars)
		
			ComponentSetValue2( comp, "rect_animation", "charge")
		
		end)
		local child_id = EntityCreateNew()
		EntitySetTransform(child_id, x, y)
		EntityAddComponent(child_id, "InheritTransformComponent", {} )
		EntityAddChild(entity_id, child_id)
		local comp = EntityAddComponent2(child_id, "ParticleEmitterComponent", {
			emitted_material_name="spark_green_bright",
			-- gravity.y="0.0",
			lifetime_min=0.5,
			lifetime_max=1.5,
			count_min=1,
			count_max=3,
			render_on_grid=true,
			fade_based_on_lifetime=true,
			-- area_circle_radius.max="40",
			cosmetic_force_create=false,
			airflow_force=0.5,
			airflow_time=0.01,
			airflow_scale=0.05,
			emission_interval_min_frames=1,
			emission_interval_max_frames=1,
			emit_cosmetic_particles=true,
			is_emitting=true,
			draw_as_long=true,
			attractor_force=100,
		} )
		ComponentSetValue2(comp, "gravity", 0, 0)
		ComponentSetValue2(comp, "area_circle_radius", 0, 20)
		EntityAddComponent(child_id, "AudioComponent", {
			file="data/audio/Desktop/projectiles.bank",
			event_root="player_projectiles/megalaser",
		} )
		-- GamePlaySound("data/audio/Desktop/explosion.bank", "explosion_small", x, y)
		EntityAddComponent(child_id, "LifetimeComponent", {
			lifetime="75",
		} )
		
	elseif number == 69 then
			
		edit_component2( entity_id, "SpriteComponent", function(comp,vars)
		
			ComponentSetValue2( comp, "rect_animation", "charged")
		
		end)
			
	elseif number == 49 then
			
		edit_component2( entity_id, "SpriteComponent", function(comp,vars)
		
			ComponentSetValue2( comp, "rect_animation", "discharge")
		
		end)
		
		local child_id2 = EntityCreateNew()
		EntitySetTransform(child_id2, x, y)
		EntityAddComponent(child_id2, "InheritTransformComponent", {} )
		EntityAddChild(entity_id, child_id2)
		local comp2 = EntityAddComponent2(child_id2, "ParticleEmitterComponent", {
			emitted_material_name="spark_green_bright",
			-- gravity.y="0",
			-- offset.x="0",
			-- offset.y="0",
			x_pos_offset_min=0,
			y_pos_offset_min=0,
			x_pos_offset_max=0,
			y_pos_offset_max=0,
			x_vel_min=0,
			x_vel_max=0,
			y_vel_min=0,
			y_vel_max=0,
			friction=4,
			count_min=30,
			count_max=50,
			-- area_circle_radius.max="4",
			-- area_circle_radius.min="4",
			velocity_always_away_from_center=80,
			lifetime_min=0.9,
			lifetime_max=3.2,
			render_on_grid=false,
			airflow_force=0.25,
			airflow_time=0.101,
			airflow_scale=2.01,
			fade_based_on_lifetime=true,
			create_real_particles=false,
			emit_cosmetic_particles=true,
			emission_interval_min_frames=5,
			emission_interval_max_frames=5,
			delay_frames=8,
			is_emitting=true,
		} )
		ComponentSetValue2(comp2, "gravity", 0, 0)
		ComponentSetValue2(comp2, "offset", 0, 0)
		ComponentSetValue2(comp2, "area_circle_radius", 9, 9)
		EntityAddComponent(child_id2, "LuaComponent", {
			script_source_file="data/scripts/projectiles/giant_energy_projectile_spawner.lua",
			execute_every_n_frame="10",
			execute_on_added="1",
		} )
		-- EntityAddComponent(child_id2, "AudioLoopComponent", {
			-- file="data/audio/Desktop/animals.bank",
			-- event_name="animals/wraith/vortex_loop",
			-- auto_play="1",
		-- } )
		-- GamePlaySound("data/audio/Desktop/projectiles.bank", "player_projectiles/wall/create", x, y)
		EntityAddComponent(child_id2, "LifetimeComponent", {
			lifetime="55",
		} )
			
	elseif number == 1 then
			
		edit_component2( entity_id, "SpriteComponent", function(comp,vars)
		
			ComponentSetValue2( comp, "rect_animation", "stand")
		
		end)
		
	end
end