dofile_once("data/scripts/lib/utilities.lua")

function damage_received( damage, message, entity_thats_responsible, is_fatal  )
	local entity_id = GetUpdatedEntityID()
	local x, y, rot = EntityGetTransform(entity_id)
	if(is_fatal == true)then
	
		function distance(x1,y1,x2,y2)
			return math.sqrt((x1 - x2)^2 + (y1 - y2)^2)
		end
	
		function splash(x1,y1)
			-- Define the radius of the area
			local radius = 60  -- You can adjust the radius as needed

			-- Iterate through each pixel in the area
			for dx = -radius, radius, 5 do
				for dy = -radius, radius, 5 do
					local px = x1 + dx
					local py = y1 + dy
					if (dx * dx + dy * dy) <= radius * radius then
						local splash_entity = EntityLoad("mods/new_enemies/files/liquid_splash/liquid_splash.xml", px, py)
						GamePlaySound("mods/new_enemies/data/sound/more_sounds/my_mod_audio.bank", "snd_mod/splash", x1, y1)
						local dist_from_center = distance(x1,y1,px,py)
						local MaterialInventoryComponent = EntityGetFirstComponent(splash_entity, "MaterialInventoryComponent")

						local factor = 2 - math.min(1, dist_from_center / radius) * 2
						ComponentSetValue2(MaterialInventoryComponent, "death_throw_particle_velocity_coeff", factor)
						
					end
				end
			end
		end
		
		local components = EntityGetComponent( entity_id, "VariableStorageComponent" )
		if ( components ~= nil ) then
			for _,comp_id in pairs(components) do 
				local var_name = ComponentGetValue( comp_id, "name" )
				if ( var_name == "phase_value") then
					var_comp_phase = comp_id
				end
				if ( var_name == "cooldown") then
					var_comp_cooldown = comp_id
				end
			end
		end
		
		--ENSURING NO PHASE SKIPPING >:O
		LoadGameEffectEntityTo( entity_id, "data/entities/misc/cthulhu_effect_protection_all.xml" )
		local comp = EntityGetFirstComponentIncludingDisabled( entity_id, "DamageModelComponent" )
		if ( comp ~= nil ) then
			ComponentSetValue2( comp, "invincibility_frames", 300 )
			local max_hp = ComponentGetValue2( comp, "max_hp" )
			ComponentSetValue2( comp, "hp", max_hp )
			-- ComponentSetValue2( comp, "wait_for_kill_flag_on_death", true )
			
			EntityAddComponent2(entity_id, "LuaComponent", {
				script_source_file="data/scripts/buildings/set_hp_to_max.lua", 
				execute_every_n_frame=100,
				remove_after_executed=true
			})
		end
		local worm_component = EntityGetFirstComponentIncludingDisabled( entity_id, "WormComponent")
		ComponentSetValue2( worm_component, "is_water_worm", false )
		ComponentSetValue2( worm_component, "mSpeed", 2 )
		ComponentSetValue2( worm_component, "gravity", 0 )
		ComponentSetValue2( worm_component, "tail_gravity", 10 )
		ComponentSetValue2( worm_component, "speed", 0.5 )
		ComponentSetValue2( worm_component, "speed_hunt", 0.5 )
		ComponentSetValue2( worm_component, "ground_check_offset", 400 )
		ComponentSetValue2( worm_component, "target_kill_radius", 0 )
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)
		
		-- local var_comp = EntityGetFirstComponent( entity_id, "VariableStorageComponent" )
		ComponentSetValue2( var_comp_phase, "value_int", 2 )
		ComponentSetValue2( var_comp_cooldown, "value_int", 0 )
		
		EntityLoad( "data/entities/particles/image_emitters/magical_symbol_hellion.xml", x, y )
		GamePlaySound( "data/audio/Desktop/misc.snd", "misc/temple_collapse", x, y )
		
		local children = EntityGetAllChildren(entity_id)
		
		for i, child in ipairs(children) do
			if ( EntityGetName(child) == "face_worm_head" ) then
				local sprite_comp = EntityGetFirstComponent( child, "SpriteComponent" )
				ComponentSetValue2( sprite_comp, "image_file", "data/enemies_gfx/hellion2_flower.xml" )
				-- ComponentSetValue2( sprite_comp, "update_transform_rotation", false )
				-- ComponentSetValue2( sprite_comp, "has_special_scale", true )
				-- ComponentSetValue2( sprite_comp, "special_scale_x", -1 )
				-- ComponentSetValue2( sprite_comp, "special_scale_y", 1 )
				EntityRefreshSprite( child, sprite_comp )
				
				local lua_comp = EntityGetFirstComponent( child, "LuaComponent" )
				EntityRemoveComponent( child, lua_comp )
			end
			
			if ( EntityGetName(child) == "body" ) then
				EntityRemoveFromParent(child)
				local cx, cy, crot = EntityGetTransform(child)
				local damage_model_component = EntityGetFirstComponentIncludingDisabled(child, "DamageModelComponent")
				
				if ( damage_model_component ~= nil ) and ( damage_model_component > 0 ) then
					ComponentSetValue2(damage_model_component, "kill_now", true)
					ComponentSetValue2(damage_model_component, "hp", 0)
					ComponentSetValue2(damage_model_component, "air_needed", true)
					ComponentSetValue2(damage_model_component, "air_in_lungs", 0)
				end
				
				-- splash(cx,cy)

			end
			
		end
		
		local sprite_components = EntityGetComponent(entity_id, "SpriteComponent") or {}
		-- Find the first disabled sprite component and enable it
		for i, sprite_component in ipairs(sprite_components) do
			local image = ComponentGetValue2( sprite_component, "image_file" )
			if image == "data/enemies_gfx/hellion2_body1.png" then
				-- ComponentSetValue2( sprite_component, "image_file", "data/enemies_gfx/hellion2_body1.png" )
				-- EntityRefreshSprite( entity_id, sprite_component )
				ComponentSetValue2( sprite_component, "alpha", 1 )
			elseif image == "data/enemies_gfx/hellion2_body2.png" then
				-- ComponentSetValue2( sprite_component, "image_file", "data/enemies_gfx/hellion2_body2.png" )
				-- EntityRefreshSprite( entity_id, sprite_component )
				ComponentSetValue2( sprite_component, "alpha", 1 )
			elseif image == "data/enemies_gfx/hellion2_tail.png" then
				-- ComponentSetValue2( sprite_component, "image_file", "data/enemies_gfx/hellion2_tail.png" )
				-- EntityRefreshSprite( entity_id, sprite_component )
				ComponentSetValue2( sprite_component, "alpha", 1 )
			end
		end
		-- EntityAddComponent(entity, "LuaComponent", {
			-- script_source_file="data/scripts/animals/desert_mage_remove_flag.lua",
			-- execute_every_n_frame=20,
			-- execute_on_added=0,
		-- })
		
		
		EntityRemoveComponent( entity_id, GetUpdatedComponentID() )
	
	-- else
		-- for i, child_id in ipairs(EntityGetAllChildren(entity_id) or {}) do

			-- local damage_model_component = EntityGetFirstComponentIncludingDisabled(child_id, "DamageModelComponent")
			
			-- if ( damage_model_component ~= nil ) and ( damage_model_component > 0 ) and ( ( EntityGetName(child_id) == "body" ) or ( EntityGetName(child_id) == "face_worm_head" ) ) then
			
				-- EntityInflictDamage( child_id, 0.04, "DAMAGE_PROJECTILE", "", "NONE", 0, 0, entity_id, x, y )
				
			-- end

		-- end
	end
	
end