dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local times = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")
if times == 1 then
	SetValueNumber("origin_x", x)
	SetValueNumber("origin_y", y)
end

local origin_x = GetValueNumber("origin_x", x)
local origin_y = GetValueNumber("origin_y", y)

EntitySetTransform(entity_id, origin_x, origin_y)

local worm_component = EntityGetFirstComponentIncludingDisabled(entity_id, "BossDragonComponent")

if ( worm_component ~= nil ) and ( worm_component > 0 ) then

	ComponentSetValue2(worm_component, "bite_damage", 0)
	ComponentSetValue2(worm_component, "speed", 0)
	ComponentSetValue2(worm_component, "speed_hunt", 0)
	ComponentSetValue2(worm_component, "direction_adjust_speed", 0)
	ComponentSetValue2(worm_component, "direction_adjust_speed_hunt", 0)
	ComponentSetValue2(worm_component, "hunt_box_radius", 0)
	ComponentSetValue2(worm_component, "random_target_box_radius", 0)
	
	ComponentSetValue2(worm_component, "acceleration", 0)
	ComponentSetValue2(worm_component, "speed", 0)
	ComponentSetValue2(worm_component, "max_speed", 0)
	ComponentSetValue2(worm_component, "mSpeed", 0)

end

function explode()
	shoot_projectile( entity_id, "data/entities/misc/hellion_small_explode.xml", x , y, 0, 0)
	EntityLoad( "data/entities/projectiles/lava_explosion_small_hellion.xml", x, y )
end

local sprite_component = EntityGetFirstComponent(entity_id, "SpriteComponent", "enabled_in_hand")

local first_sprite_found = false

if ( sprite_component ~= nil ) and ( sprite_component > 0 ) then
	EntitySetComponentIsEnabled(entity_id, sprite_component, false)
	first_sprite_found = true
	
	local sprite_component2 = EntityGetFirstComponent(entity_id, "SpriteComponent", "enabled_in_hand")
	if ( sprite_component2 ~= nil ) and ( sprite_component2 > 0 ) then
		ComponentSetValue(sprite_component2, "alpha", 0)
	end
	explode()
end

-- If no second sprite component was found, kill the entity
if first_sprite_found == false then
	explode()
	EntityKill(entity_id)
end