dofile_once("data/scripts/lib/utilities.lua")

function collision_trigger(colliding_entity)

	local entity_id = GetUpdatedEntityID()
	local x, y = EntityGetTransform(entity_id)

	local times_executed = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")
	-- Calculate the animation index (1-based index)
	local animation_index = (times_executed % 7) + 1
	local animation_name = "stand" .. tostring(animation_index)

	local sprite_comp = EntityGetFirstComponentIncludingDisabled(entity_id, "SpriteComponent")
	if (sprite_comp ~= nil) and (sprite_comp > 0) then
		-- Set the animation based on the calculated index
		ComponentSetValue2(sprite_comp, "rect_animation", animation_name)
		ComponentSetValue2(sprite_comp, "next_rect_animation", animation_name)
	end
	if times_executed > 20 then
		if ( animation_name == "stand1" ) or ( animation_name == "stand2" ) or ( animation_name == "stand3" ) or ( animation_name == "stand4" ) or ( animation_name == "stand5" ) then
			local worm_component = EntityGetFirstComponentIncludingDisabled(entity_id, "WormComponent")
			if ( worm_component ~= nil ) and ( worm_component > 0 ) then
				local vx, vy = ComponentGetValue2(worm_component, "mTargetVec")
				ComponentSetValue2(worm_component, "mTargetVec", vx * 0.6, vy * 0.6)
			end
		else
			local worm_component = EntityGetFirstComponentIncludingDisabled(entity_id, "WormComponent")
			if ( worm_component ~= nil ) and ( worm_component > 0 ) then
				local vx, vy = ComponentGetValue2(worm_component, "mTargetVec")
				ComponentSetValue2(worm_component, "mTargetVec", vx * 1.6, vy * 1.6)
			end
		end
	end
end