function collision_trigger(colliding_entity)
	local this_lua = GetUpdatedComponentID()
		
	local entity_id = GetUpdatedEntityID()
	local x, y, rot = EntityGetTransform(entity_id)

	local root_id = EntityGetRootEntity(entity_id)
	local root_x, root_y, root_rot = EntityGetTransform(root_id)

	local verlet_component = EntityGetFirstComponentIncludingDisabled(entity_id, "VerletPhysicsComponent")
	local positions = ComponentGetValue2(verlet_component, "positions")

	-- Iterate over the positions table with a step of 2
	for i = 1, #positions, 2 do
		local pos_x = positions[i]       -- x coordinate
		local pos_y = positions[i + 1]   -- y coordinate

		-- Apply electricity damage at each position
		local entities = EntityGetInRadiusWithTag( pos_x, pos_y, 3, "mortal" )
		for _,id in pairs(entities) do
			EntityInflictDamage(id, 0.08, "DAMAGE_ELECTRICITY", "Jellyfish Stings", "NONE", 0, 0, root_id, pos_x, pos_y)
		end
	end

	-- Get the current frame number for animation purposes
	local frame_num = GameGetFrameNum()

	-- Wave function to control the tentacle's movement (smooth in and out motion)
	local wave_frequency = 0.01  -- Controls the speed of the movement
	local wave_amplitude = 1     -- Controls the extent of the tentacle's movement
	local times_executed = (frame_num * wave_frequency) + entity_id
	local wave = math.sin(times_executed) * wave_amplitude
	
	-- Calculate the direction based on the jellyfish's rotation
	local cos_rot = math.cos(root_rot)
	local sin_rot = math.sin(root_rot)

	-- Move the tentacle along the direction of the jellyfish's rotation
	local offset_x = cos_rot * wave
	local offset_y = sin_rot * wave

	-- Get the VerletPhysicsComponent and set the animation target offset
	local verlet_component = EntityGetFirstComponentIncludingDisabled(entity_id, "VerletPhysicsComponent")
	if verlet_component then
		ComponentSetValue2(verlet_component, "animation_target_offset", offset_x, offset_y)
		if times_executed < 12 then

			positions[3] = root_x
			positions[4] = root_y

			positions[59] = root_x
			positions[60] = root_y
			
			ComponentSetValue2(verlet_component, "positions", positions)
		end
	end
end