dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
local detection_range = 100

local limb_boss_component = EntityGetFirstComponentIncludingDisabled(entity_id, "LimbBossComponent")
local physics_ai_component = EntityGetFirstComponentIncludingDisabled(entity_id, "PhysicsAIComponent")

local enemy, enemy_x, enemy_y

for _, id in pairs(EntityGetInRadiusWithTag(x, y, detection_range, "player_unit") or {}) do
    if id > 0 and id ~= nil then
        local ex, ey = EntityGetFirstHitboxCenter(id)
        local dist = get_distance(x, y, ex, ey)
        if dist < detection_range then
            enemy = id
            enemy_x = ex
            enemy_y = ey
            SetValueBool("is_attacking", true)
        end
    end
end

local number = GetValueNumber("number", 0)
local is_attacking = GetValueBool("is_attacking", false)

if is_attacking == true then
    SetValueNumber("number", number + 1)
    if enemy ~= nil and enemy > 0 and number <= 3 then
        ComponentSetValue2(limb_boss_component, "state", 4)
        ComponentSetValue2(limb_boss_component, "mMoveToPositionX", enemy_x)
        ComponentSetValue2(limb_boss_component, "mMoveToPositionY", enemy_y)
        ComponentSetValue2(physics_ai_component, "force_max", 500)
        ComponentSetValue2(physics_ai_component, "force_coeff", 125)
        EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)
    else
        SetValueBool("is_attacking", false)
        SetValueNumber("number", 0)
        EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", false)
        ComponentSetValue2(limb_boss_component, "state", 5)
        ComponentSetValue2(physics_ai_component, "force_max", 100)
        ComponentSetValue2(physics_ai_component, "force_coeff", 20)
    end
end