dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()

local pos_x, pos_y, rotation = EntityGetTransform(entity_id)
local root_id = EntityGetRootEntity( entity_id )

-- locate nearest enemy
local enemy, enemy_x, enemy_y
local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	players = {player}
else
	local polymorphed_player = EntityGetClosestWithTag(pos_x, pos_y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		players = {polymorphed_player}
	end
end

if #players > 0 then
	enemy = players[1]
	enemy_x, enemy_y = EntityGetTransform( players[1] )
end

if enemy ~= 0 and enemy ~= nil then

	GameEntityPlaySound( entity_id, "mech_boss_move_cannon" )

	rotate_value = 0
	
	rotation = rotation - math.rad(rotate_value)
	local distance_from_center = 75
	local projectile_speed = 150
	-- SetRandomSeed(GameGetFrameNum(), x + y * i)
	-- local random_angle_adjustment = math.rad(Random(-60, 60))
	local target_x = pos_x + math.cos(rotation) * distance_from_center
	local target_y = pos_y + math.sin(rotation) * distance_from_center
	
	local vel_x = math.cos(rotation) * projectile_speed
	local vel_y = math.sin(rotation) * projectile_speed
	
	local times_executed = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")
	if times_executed % 2 == 0 then
		local proj = shoot_projectile(entity_id, "data/entities/projectiles/mechahub_bomb_down.xml", target_x, target_y, vel_x, vel_y)
		if (root_id ~= nil) and (root_id > 0) then
			EntityAddChild(root_id, proj)
		end
	else
		local proj = shoot_projectile(entity_id, "data/entities/projectiles/mechahub_bomb_up.xml", target_x, target_y, vel_x, vel_y)
		if (root_id ~= nil) and (root_id > 0) then
			EntityAddChild(root_id, proj)
		end
	end
	
end

