dofile_once( "data/scripts/lib/utilities.lua" )

GameTriggerMusicFadeOutAndDequeueAll()

-- Define the minimum and maximum depth for the effect
local min_depth = 20000
local max_depth = 41400

-- GameTriggerMusicFadeOutAndDequeueAll()

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

function approx_rolling_average(avg, new_sample, n)
  avg = avg - avg / n;
  avg = avg + new_sample / n;
  return avg
end

function distance(dx, dy, dx2, dy2)
    return math.sqrt(((dx-dx2)^2) + ((dy-dy2)^2))
end

local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	players = {player}
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		players = {polymorphed_player}
	end
end


local cx, cy = GameGetCameraPos()

--Getting the arena checker
-- local children = EntityGetAllChildren( entity_id, "pitcheck_b" )

local times_executed = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")

-- local state_duration = GetValueNumber("state_duration", 0)
-- local state_duration2 = GetValueNumber("state_duration2", 0)

local components = EntityGetComponent( entity_id, "VariableStorageComponent" )
if ( components ~= nil ) then
	for _,comp_id in pairs(components) do 
		local var_name = ComponentGetValue( comp_id, "name" )
		if ( var_name == "parallax_factor") then
			parallax_factor_var_comp = comp_id
		end
		if ( var_name == "init_origin") then
			init_origin_var_comp = comp_id
		end
		if ( var_name == "origin") then
			origin_var_comp = comp_id
		end
		if ( var_name == "wall_offset") then
			wall_offset_var_comp = comp_id
		end
		if ( var_name == "wall_offset_prev") then
			wall_offset_prev_var_comp = comp_id
		end
		if ( var_name == "wall_offset_target") then
			wall_offset_target_var_comp = comp_id
		end
		if ( var_name == "max_depth") then
			max_depth_var_comp = comp_id
		end
		if ( var_name == "ascending") then
			ascending_var_comp = comp_id
		end
	end
end

max_depth = ComponentGetValue2(max_depth_var_comp, "value_float")
local is_ascending = ComponentGetValue2(ascending_var_comp, "value_bool")

if is_ascending == true then
	ComponentSetValue2(max_depth_var_comp, "value_float", max_depth - 0.9)
end


local wall_offset = ComponentGetValue2(wall_offset_var_comp, "value_float")
local wall_offset_prev = ComponentGetValue2(wall_offset_prev_var_comp, "value_float")
local wall_offset_target = ComponentGetValue2(wall_offset_target_var_comp, "value_float")
ComponentSetValue2(wall_offset_prev_var_comp, "value_float", wall_offset)

local new_wall_offset = approx_rolling_average(wall_offset, wall_offset_target, 100)
ComponentSetValue2(wall_offset_var_comp, "value_float", new_wall_offset)

if (times_executed > 1 ) and ( times_executed % 600 == 0) then
	ComponentSetValue2(wall_offset_target_var_comp, "value_float", 50)
elseif (times_executed > 1 ) and ( times_executed % 600 == 300) then
	ComponentSetValue2(wall_offset_target_var_comp, "value_float", 200)
end

local cart_found = false
local cart_found2 = false
local cart_found3 = false
local cart_found4 = false
local cart_found5 = false
local mccy = y

local floor_count = 0
local right_wall_count = 0
local left_wall_count = 0
for _, child in ipairs(EntityGetAllChildren(entity_id) or {} ) do
	if EntityGetName(child) == "background1" then
		background1_id = child
	end
	if EntityGetName(child) == "background2" then
		background2_id = child
	end
	-- if EntityGetName(child) == "background3" then
		-- background3_id = child
	-- end
	if EntityGetName(child) == "sides" then
		sides_id = child
		sx, sy = EntityGetTransform( child )
		
		local sprite_comps = EntityGetComponent(child, "SpriteComponent") or {}
		for i, comp in ipairs(sprite_comps) do

			ComponentSetValue2(comp, "offset_x", wall_offset * -1)
			
		end
	end
	if EntityGetName(child) == "mechacart" then
		mechacart_id = child
		cart_found = true
		mccx1, mccy1 = EntityGetTransform( child )
	end
	
	if EntityGetName(child) == "mechacart_b" then
		mechacart2_id = child
		cart_found2 = true
		mccx2, mccy2 = EntityGetTransform( child )
	end
	
	if EntityGetName(child) == "mechacart_c" then
		mechacart3_id = child
		cart_found3 = true
		mccx3, mccy3 = EntityGetTransform( child )
	end
	if EntityGetName(child) == "mechacart_d" then
		mechacart4_id = child
		cart_found4 = true
		mccx4, mccy4 = EntityGetTransform( child )
	end
	if EntityGetName(child) == "mechacart_e" then
		mechacart5_id = child
		cart_found5 = true
		mccx5, mccy5 = EntityGetTransform( child )
	end

	if EntityGetName(child) == "physics_wall" then
		right_wall_count = right_wall_count + 1
		physics_wall_id = child
		if #players > 0 then
			local px, py = EntityGetTransform( players[1] )
			local physics_body_component = EntityGetFirstComponentIncludingDisabled(child, "PhysicsBodyComponent")
			if ( physics_body_component ~= nil ) and ( physics_body_component > 0 ) then
				EntitySetComponentIsEnabled( child, physics_body_component, false )
			end
			EntitySetTransform(child, sx + wall_offset, py - 150)
			if ( physics_body_component ~= nil ) and ( physics_body_component > 0 ) then
				EntitySetComponentIsEnabled( child, physics_body_component, true )
			end
		end
		local pwx, pwy = EntityGetTransform( child )
		if times_executed > 60 then
			local did_hit2, hit_x2, hit_y2 = RaytracePlatforms( pwx, pwy, pwx, pwy )
			if not did_hit2 then
				EntityKill(child)
				local new_wall = EntityLoad("data/entities/animals/mechahub_wall.xml", pwx, pwy)
				physics_wall_id = new_wall
				EntityAddChild(entity_id, new_wall)
			end
		end
	end
	
	if EntityGetName(child) == "physics_wall2" then
		left_wall_count = left_wall_count + 1
		physics_wall2_id = child
		if #players > 0 then
			local px, py = EntityGetTransform( players[1] )
			local physics_body_component = EntityGetFirstComponentIncludingDisabled(child, "PhysicsBodyComponent")
			if ( physics_body_component ~= nil ) and ( physics_body_component > 0 ) then
				EntitySetComponentIsEnabled( child, physics_body_component, false )
			end
			EntitySetTransform(child, sx - wall_offset - 16, py - 150)
			if ( physics_body_component ~= nil ) and ( physics_body_component > 0 ) then
				EntitySetComponentIsEnabled( child, physics_body_component, true )
			end
		end
		local pw2x, pw2y = EntityGetTransform( child )
		if times_executed > 60 then
			local did_hit2, hit_x2, hit_y2 = RaytracePlatforms( pw2x, pw2y, pw2x, pw2y )
			if not did_hit2 then
				EntityKill(child)
				local new_wall = EntityLoad("data/entities/animals/mechahub_wall2.xml", pw2x, pw2y)
				physics_wall2_id = new_wall
				EntityAddChild(entity_id, new_wall)
			end
		end
	end
	
	if EntityGetName(child) == "physics_floor" then
		floor_count = floor_count + 1
		physics_floor_id = child
		local fx, fy = EntityGetTransform( child )
		if #players > 0 then
			-- local px, py = EntityGetTransform( players[1] )
			-- local distance = get_distance(fx, fy, px, py)
			
			-- if distance < 200 then
				local physics_body_component = EntityGetFirstComponentIncludingDisabled(child, "PhysicsBodyComponent")
				if ( physics_body_component ~= nil ) and ( physics_body_component > 0 ) then
					EntitySetComponentIsEnabled( child, physics_body_component, false )
				end
				EntitySetTransform(child, sx - 256, max_depth + 3)
				if ( physics_body_component ~= nil ) and ( physics_body_component > 0 ) then
					EntitySetComponentIsEnabled( child, physics_body_component, true )
				end
			-- end
			
			local pw2x, pw2y = EntityGetTransform( child )
			if times_executed > 60 then
				local did_hit2, hit_x2, hit_y2 = RaytracePlatforms( fx, fy, fx, fy )
				if not did_hit2 then
					EntityKill(child)
					local new_wall = EntityLoad("data/entities/animals/mechahub_floor.xml", pw2x, pw2y)
					physics_floor_id = new_wall
					EntityAddChild(entity_id, new_wall)
				end
			end
		end
	end
	
	if EntityGetName(child) == "mechahub_mouth" then
		mouth_id = child
		mouthx, mouthy = EntityGetTransform( child )
	end
	
	if EntityGetName(child) == "mechahub_bottom" then
		bottom_id = child
	end
end

-- Right Movement Indicator
local time_val = GameGetFrameNum()
local cx, cy = GameGetCameraPos()
local amplitude = 5  -- Adjust the amplitude of the oscillation as needed
local frequency = 0.1   -- Adjust the frequency of the oscillation as needed

-- Calculate the new y-position using a sine wave
if cy < mouthy - 512 then
	local oscillating_y = cy + 100 + math.sin(time_val * frequency) * amplitude
	GameCreateSpriteForXFrames( "data/ui_gfx/indicator_down.png", cx, oscillating_y, true, 0, 0, 1, true )
end

if ( floor_count > 1 ) or ( right_wall_count > 1 ) or ( left_wall_count > 1 ) then
	for _, child in ipairs(EntityGetAllChildren(entity_id) or {} ) do
		
		if EntityGetName(child) == "physics_floor" then
			EntityKill(child)
		end
		if EntityGetName(child) == "physics_wall" then
			EntityKill(child)
		end
		if EntityGetName(child) == "physics_wall2" then
			EntityKill(child)
		end
	end
end

if ( times_executed > 60 ) and ( times_executed % 600 == 0) and (cart_found == false) then
	local new_cart = EntityLoad("data/entities/animals/mechahub_cart.xml", sx + wall_offset, cy - 300)
	EntityAddChild(entity_id, new_cart)
end

if ( times_executed > 60 ) and ( times_executed % 800 == 0) and (cart_found2 == false) then
	local new_cart = EntityLoad("data/entities/animals/mechahub_cart_b.xml", sx - wall_offset, cy + 300)
	EntityAddChild(entity_id, new_cart)
end

if ( times_executed > 60 ) and ( times_executed % 1000 == 0) and (cart_found3 == false) then
	local new_cart = EntityLoad("data/entities/animals/mechahub_cart_c.xml", sx - wall_offset, cy - 300)
	EntityAddChild(entity_id, new_cart)
end

if ( times_executed > 60 ) and ( times_executed % 1200 == 0) and (cart_found4 == false) then -- New cart d
	local new_cart = EntityLoad("data/entities/animals/mechahub_cart.xml", sx + wall_offset, cy - 300)
	EntitySetName( new_cart, "mechacart_d")
	EntityAddChild(entity_id, new_cart)
end

if ( times_executed > 60 ) and ( times_executed % 1400 == 0) and (cart_found5 == false) then -- New cart e
	local new_cart = EntityLoad("data/entities/animals/mechahub_cart.xml", sx - wall_offset, cy + 300)
	EntitySetName( new_cart, "mechacart_e")
	EntityAddChild(entity_id, new_cart)
end

if cart_found == true then
	local lmccx, lmccy = EntityGetTransform( mechacart_id )
	local cart_y = approx_rolling_average(lmccy, y, 50)
	EntitySetTransform(mechacart_id, sx + wall_offset, cart_y)
	
	--animation
	if lmccy >= cart_y then
		local sprite_comps = EntityGetComponent(mechacart_id, "SpriteComponent") or {}
		for i, comp in ipairs(sprite_comps) do
			ComponentSetValue2(comp, "rect_animation", "up")
			ComponentSetValue2(comp, "next_rect_animation", "up")
		end
	elseif lmccy < cart_y then
		local sprite_comps = EntityGetComponent(mechacart_id, "SpriteComponent") or {}
		for i, comp in ipairs(sprite_comps) do
			ComponentSetValue2(comp, "rect_animation", "down")
			ComponentSetValue2(comp, "next_rect_animation", "down")
		end
	end
end

if cart_found2 == true then
	if cart_found == true then
		mccy = mccy1
	end
	local lmccx, lmccy = EntityGetTransform( mechacart2_id )
	local cart_y = approx_rolling_average(lmccy, mccy + 512, 100)
	EntitySetTransform(mechacart2_id, sx - wall_offset, cart_y)
	
	if lmccy >= cart_y then
		local sprite_comps = EntityGetComponent(mechacart2_id, "SpriteComponent") or {}
		for i, comp in ipairs(sprite_comps) do
			ComponentSetValue2(comp, "rect_animation", "up")
			ComponentSetValue2(comp, "next_rect_animation", "up")
		end
	elseif lmccy < cart_y then
		local sprite_comps = EntityGetComponent(mechacart2_id, "SpriteComponent") or {}
		for i, comp in ipairs(sprite_comps) do
			ComponentSetValue2(comp, "rect_animation", "down")
			ComponentSetValue2(comp, "next_rect_animation", "down")
		end
	end
end

if cart_found3 == true then
	if cart_found == true then
		mccy = mccy1
	end
	local lmccx, lmccy = EntityGetTransform( mechacart3_id )
	local cart_y = approx_rolling_average(lmccy, mccy - 512, 100)
	EntitySetTransform(mechacart3_id, sx - wall_offset, cart_y)
	
	if lmccy >= cart_y then
		local sprite_comps = EntityGetComponent(mechacart3_id, "SpriteComponent") or {}
		for i, comp in ipairs(sprite_comps) do
			ComponentSetValue2(comp, "rect_animation", "up")
			ComponentSetValue2(comp, "next_rect_animation", "up")
		end
	elseif lmccy < cart_y then
		local sprite_comps = EntityGetComponent(mechacart3_id, "SpriteComponent") or {}
		for i, comp in ipairs(sprite_comps) do
			ComponentSetValue2(comp, "rect_animation", "down")
			ComponentSetValue2(comp, "next_rect_animation", "down")
		end
	end
end

if cart_found4 == true then 
	local lmccx, lmccy = EntityGetTransform( mechacart4_id )
	local cart_y = approx_rolling_average(lmccy, y - 800, 100)
	EntitySetTransform(mechacart4_id, sx + wall_offset, cart_y)
	
	if lmccy >= cart_y then
		local sprite_comps = EntityGetComponent(mechacart4_id, "SpriteComponent") or {}
		for i, comp in ipairs(sprite_comps) do
			ComponentSetValue2(comp, "rect_animation", "up")
			ComponentSetValue2(comp, "next_rect_animation", "up")
		end
	elseif lmccy < cart_y then
		local sprite_comps = EntityGetComponent(mechacart4_id, "SpriteComponent") or {}
		for i, comp in ipairs(sprite_comps) do
			ComponentSetValue2(comp, "rect_animation", "down")
			ComponentSetValue2(comp, "next_rect_animation", "down")
		end
	end
end

if cart_found5 == true then
	local lmccx, lmccy = EntityGetTransform( mechacart5_id )
	local cart_y = approx_rolling_average(lmccy, y + 800, 100)
	EntitySetTransform(mechacart5_id, sx + wall_offset, cart_y)
	
	if lmccy >= cart_y then
		local sprite_comps = EntityGetComponent(mechacart5_id, "SpriteComponent") or {}
		for i, comp in ipairs(sprite_comps) do
			ComponentSetValue2(comp, "rect_animation", "up")
			ComponentSetValue2(comp, "next_rect_animation", "up")
		end
	elseif lmccy < cart_y then
		local sprite_comps = EntityGetComponent(mechacart5_id, "SpriteComponent") or {}
		for i, comp in ipairs(sprite_comps) do
			ComponentSetValue2(comp, "rect_animation", "down")
			ComponentSetValue2(comp, "next_rect_animation", "down")
		end
	end
end
if #players > 0 then
	local px, py = EntityGetTransform( players[1] )
	if px > sx + wall_offset - 2 then
		EntitySetTransform(players[1], sx + wall_offset - 2, py)
	end
	
	if px < sx - wall_offset + 2 then
		EntitySetTransform(players[1], sx - wall_offset + 2, py)
	end
	px, py = EntityGetTransform( players[1] )
	if py > max_depth then
		EntitySetTransform(players[1], px, max_depth)
	end
end

--Parallax
if ComponentGetValue2(init_origin_var_comp, "value_bool") == false then
	ComponentSetValue2(init_origin_var_comp, "value_bool", true)
	
	ComponentSetValue2(origin_var_comp, "value_float", x)
	ComponentSetValue2(origin_var_comp, "value_string", cy + 1000)
	
	ox_raw = x
	oy_raw = y
	
	EntitySetTransform(sides_id, x, oy_raw)
	EntitySetTransform(physics_wall_id, x, oy_raw)
	EntitySetTransform(physics_wall2_id, x, oy_raw)
	EntitySetTransform(physics_floor_id, x, max_depth)
else
	local it_comp = EntityGetFirstComponent( sides_id, "InheritTransformComponent" )
	if ( it_comp ~= nil ) and ( it_comp > 0 ) then
		EntityRemoveComponent( sides_id, it_comp )
	end
end

if floor_count < 1 then
	local new_wall = EntityLoad("data/entities/animals/mechahub_floor.xml", sx, max_depth)
	EntitySetTransform(new_wall, sx, max_depth)
	EntityAddChild(entity_id, new_wall)
end
if right_wall_count < 1 then
	local new_wall = EntityLoad("data/entities/animals/mechahub_wall2.xml", sx + wall_offset, sy)
	EntitySetTransform(new_wall, sx + wall_offset, oy_raw)
	EntityAddChild(entity_id, new_wall)
end
if left_wall_count < 1 then
	local new_wall = EntityLoad("data/entities/animals/mechahub_wall.xml", sx - wall_offset - 50, sy)
	EntitySetTransform(new_wall, sx - wall_offset - 16, oy_raw)
	EntityAddChild(entity_id, new_wall)
end

-- GamePrint("Floors: " .. tostring(floor_count))
-- GamePrint("Right Walls: " .. tostring(right_wall_count))
-- GamePrint("Left Walls: " .. tostring(left_wall_count))

local ox_raw = ComponentGetValue2(origin_var_comp, "value_float")
local oy_raw = ComponentGetValue2(origin_var_comp, "value_string")

local ox = ox_raw
local oy = tonumber(oy_raw)

local parallaxFactor = ComponentGetValue2(parallax_factor_var_comp, "value_float")
if parallaxFactor < 0.9 then
    ComponentSetValue2(parallax_factor_var_comp, "value_float", parallaxFactor + 0.001)
    -- GamePrint(parallaxFactor)
end
local parallaxFactor2 = parallaxFactor * 0.8
local parallaxFactor3 = parallaxFactor * 0.7

-- Calculate the additional offset based on the depth
local depth_offset = 0
if cy > min_depth then
    -- Use smooth interpolation between min_depth and max_depth
    local t = (cy - min_depth) / (max_depth - min_depth)
    depth_offset = math.min(t, 1) * 150 -- Adjust the multiplier (100) as needed for the desired effect
end

local x2 = (cx - ox) * parallaxFactor
local y2 = (cy - oy - depth_offset) * parallaxFactor

local x3 = (cx - ox) * parallaxFactor2
local y3 = (cy - oy - depth_offset) * parallaxFactor2

local x4 = (cx - ox) * parallaxFactor3
local y4 = (cy - oy - depth_offset) * parallaxFactor3

EntitySetTransform(entity_id, ox + x2, oy + y2)
EntitySetTransform(background1_id, ox + x2, oy + y2)
EntitySetTransform(background2_id, ox + x3, oy + y3)
-- EntitySetTransform(background3_id, ox + x4, oy + y4)

EntitySetTransform(mouth_id, sx, max_depth - 80)

EntitySetTransform(bottom_id, sx, max_depth + 3)

local new_y = approx_rolling_average(y, cy, 300)

if cy > oy then
	ComponentSetValue2(origin_var_comp, "value_string", tostring(new_y))
elseif cy < oy then
	ComponentSetValue2(origin_var_comp, "value_string", tostring(new_y))
end

-- if times_executed % 15 == 0 then
	-- LoadPixelScene( "data/props_gfx/temporary_platform_mechahub_pixel.png", "data/props_gfx/temporary_platform_mechahub.png", sx - 210, max_depth, "", true, false, "", 50, true )
-- end


if cy < sy - 512  then
	EntitySetTransform(sides_id, sx, sy - 512)
	if ( times_executed > 200 ) and ( sy < min_depth ) and ( sy > 18500 ) then
		LoadPixelScene( "data/props_gfx/temporary_platform_mechahub_pixel.png", "data/props_gfx/temporary_platform_mechahub.png", sx - 400, sy - 756, "", true, false, "", 50, false )
		LoadPixelScene( "data/props_gfx/temporary_platform_mechahub_pixel.png", "data/props_gfx/temporary_platform_mechahub.png", sx, sy - 1024, "", true, false, "", 50, false )
	end
elseif cy > sy + 512  then
	EntitySetTransform(sides_id, sx, sy + 512)
	if times_executed > 200 then
		if sy < 38000 then
			LoadPixelScene( "data/props_gfx/temporary_platform_mechahub_pixel.png", "data/props_gfx/temporary_platform_mechahub.png", sx - 400, sy + 756, "", true, false, "", 50, false )
			LoadPixelScene( "data/props_gfx/temporary_platform_mechahub_pixel.png", "data/props_gfx/temporary_platform_mechahub.png", sx, sy + 1024, "", true, false, "", 50, false )
		else
			LoadPixelScene( "data/props_gfx/temporary_platform_mechahub_pixel.png", "data/props_gfx/temporary_platform_mechahub.png", sx - 500, sy + 756, "", true, false, "", 50, false )
			LoadPixelScene( "data/props_gfx/temporary_platform_mechahub_pixel.png", "data/props_gfx/temporary_platform_mechahub.png", sx  + 100, sy + 756, "", true, false, "", 50, false )
			LoadPixelScene( "data/props_gfx/temporary_platform_mechahub_pixel.png", "data/props_gfx/temporary_platform_mechahub.png", sx - 500, sy + 1024, "", true, false, "", 50, false )
			LoadPixelScene( "data/props_gfx/temporary_platform_mechahub_pixel.png", "data/props_gfx/temporary_platform_mechahub.png", sx  + 100, sy + 1024, "", true, false, "", 50, false )
		end
	end
end