dofile_once("data/scripts/lib/utilities.lua")

function get_distance(dx, dy, dx2, dy2)
	return math.sqrt(((dx-dx2)^2) + ((dy-dy2)^2))
end


local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

head_number = 0

for i, child in ipairs(EntityGetAllChildren(entity_id) or {}) do
	if EntityGetName(child) == "controls" then
		controls_id = child
	end
end

for i, child in ipairs(EntityGetAllChildren(entity_id) or {}) do
	if EntityGetName(child) == "triangle" then
		head_number = head_number + 1
		local cx, cy = EntityGetTransform(child)
		
		local players = {}
		local player = EntityGetWithName( "DEBUG_NAME:player" )
		if ( player ~= nil ) and ( player > 0 ) then
			local px, py = EntityGetTransform(player)
			local dist = get_distance(cx, cy, px, py)
			if dist <= 300 then
				players = {player}
			end
		else
			local polymorphed_player = EntityGetClosestWithTag(rx, ry, "polymorphed_player")
			if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
				local px, py = EntityGetTransform(polymorphed_player)
				local dist = get_distance(cx, cy, px, py)
				if dist <= 300 then
					players = {polymorphed_player}
				end
			end
		end
		
		if #players > 0 then
			local variable_storage = EntityGetFirstComponent(child, "VariableStorageComponent")
			if ( variable_storage ~= nil ) and ( variable_storage > 0 ) and ( ComponentGetValue2(variable_storage, "value_int") == 0 ) then
				ComponentSetValue2( variable_storage, "value_int", 1 )
				EntitySetComponentsWithTagEnabled(child, "enabled_in_world", true)
				-- local velocity_component = EntityGetFirstComponent(child, "VelocityComponent")
				-- if ( velocity_component ~= nil ) and ( velocity_component > 0 ) then
					-- ComponentSetValue2( velocity_component, "updates_velocity", true )
				-- end
			end
		else
			local variable_storage = EntityGetFirstComponent(child, "VariableStorageComponent")
			if ( variable_storage ~= nil ) and ( variable_storage > 0 ) and ( ComponentGetValue2(variable_storage, "value_int") == 1 )  then
				ComponentSetValue2( variable_storage, "value_int", 0 )
				EntitySetComponentsWithTagEnabled(child, "enabled_in_world", false)
				-- local velocity_component = EntityGetFirstComponent(child, "VelocityComponent")
				-- if ( velocity_component ~= nil ) and ( velocity_component > 0 ) then
					-- ComponentSetValue2( velocity_component, "updates_velocity", false )
				-- end
			end
		end
	end
end

local times = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")

-- spawn a new head if less than x
if head_number == 0 then
	for i=1,6 do
		local ent = shoot_projectile( controls_id, "data/entities/projectiles/mexxi_triangle.xml", x, y - 15 , Random(-15, 15), -50, false )
		EntitySetName(ent, "triangle")

		EntityAddChild(entity_id, ent)
	end
elseif head_number < 6 then
	local ent = shoot_projectile( controls_id, "data/entities/projectiles/mexxi_triangle.xml", x, y - 15 , 0, -50, false )
	EntitySetName(ent, "triangle")

	EntityAddChild(entity_id, ent)
end