dofile_once( "data/scripts/lib/utilities.lua" )
dofile_once( "data/scripts/invisibility_check.lua" )

local entity_id = GetUpdatedEntityID()
local x, y, rot, scale_x  = EntityGetTransform(entity_id)

local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	players = {player}
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		players = {polymorphed_player}
	end
end

if #players > 0 and ( is_invisible(players[1]) == false ) then
	local px, py  = EntityGetTransform(players[1])
	local did_hit, hit_x, hit_y = RaytracePlatforms(x, y, px, py)
	if not did_hit then
		local animal_ai_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AnimalAIComponent")
		if ( animal_ai_component ~= nil ) and ( animal_ai_component > 0 ) then
			ComponentSetValue2( animal_ai_component, "mGreatestPrey", players[1] )
			ComponentSetValue2( animal_ai_component, "mHasFoundPrey", true )
		end
	end
end

-- SetRandomSeed(x + GameGetFrameNum(), y)
-- ComponentSetValue(GetUpdatedComponentID(), "execute_every_n_frame", 10 + Random(140))
