dofile_once( "data/scripts/lib/utilities.lua" )
dofile_once( "data/scripts/invisibility_check.lua" )

local entity_id = GetUpdatedEntityID()
local x, y, rot, scale_x  = EntityGetTransform(entity_id)
local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	players = {player}
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		players = {polymorphed_player}
	end
end

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

if #players > 0 and ( is_invisible(players[1]) == false ) then
	local limb_boss_component = EntityGetFirstComponentIncludingDisabled(entity_id, "LimbBossComponent")
	if ( limb_boss_component ~= nil ) and ( limb_boss_component > 0 ) then
		if ( (EntityGetFirstComponent(entity_id, "GenomeDataComponent") ~= nil) and ( EntityGetFirstComponent(entity_id, "GenomeDataComponent") > 0 ) ) and ( ( EntityGetHerdRelation(entity_id, players[1]) > 40 ) or (EntityGetHerdRelation(entity_id, players[1]) <= 0 ) ) then
			ComponentSetValue2(limb_boss_component, "state", 4)
			local px, py  = EntityGetTransform(players[1])
			ComponentSetValue2(limb_boss_component, "mMoveToPositionX", px )
			ComponentSetValue2(limb_boss_component, "mMoveToPositionY", py )
		else
			ComponentSetValue2(limb_boss_component, "state", 1)
		end
	end
elseif #players > 0 and ( is_invisible(players[1]) == true ) and ( (EntityGetFirstComponent(entity_id, "GenomeDataComponent") ~= nil) and ( EntityGetFirstComponent(entity_id, "GenomeDataComponent") > 0 ) ) and ( ( EntityGetHerdRelation(entity_id, players[1]) > 40 ) or (EntityGetHerdRelation(entity_id, players[1]) <= 0 ) ) then
	local limb_boss_component = EntityGetFirstComponentIncludingDisabled(entity_id, "LimbBossComponent")
	if ( limb_boss_component ~= nil ) and ( limb_boss_component > 0 ) then
		ComponentSetValue2(limb_boss_component, "state", 4)
		
		local pathfinding_component = EntityGetFirstComponentIncludingDisabled(entity_id, "PathFindingComponent")
		if ( pathfinding_component ~= nil ) and ( pathfinding_component > 0 ) then
			local targ_calcx = x + Random(-100, 100)
			local targ_calcy = y + Random(-100, 100)
			
			if BiomeMapGetName(targ_calcx, targ_calcy) ~= "$biome_holymountain" then
				ComponentSetValue2(limb_boss_component, "mMoveToPositionX", targ_calcx )
				ComponentSetValue2(limb_boss_component, "mMoveToPositionY", targ_calcy )
			end
			

			-- local path_is_stuck = ComponentGetValue2(pathfinding_component, "path_is_stuck")
			-- local path_frames_stuck = ComponentGetValue2(pathfinding_component, "path_frames_stuck")
			
			-- local animal_ai_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AnimalAIComponent")
			-- if path_is_stuck or ( path_frames_stuck > 200 ) then
				-- if ( animal_ai_component ~= nil ) and ( animal_ai_component > 0 ) then
					-- local state = ComponentGetValue2(animal_ai_component, "ai_state")
					-- if state == 0 then
						-- ComponentSetValue2( animal_ai_component, "ai_state", 1 )
					-- end
				-- end
			-- end
		end
	end
else
	local limb_boss_component = EntityGetFirstComponentIncludingDisabled(entity_id, "LimbBossComponent")
	if ( limb_boss_component ~= nil ) and ( limb_boss_component > 0 ) then
		ComponentSetValue2(limb_boss_component, "state", 1)
	end
end

-- SetRandomSeed(x + GameGetFrameNum(), y)
-- ComponentSetValue(GetUpdatedComponentID(), "execute_every_n_frame", 10 + Random(140))
