dofile_once( "data/scripts/lib/utilities.lua" )
dofile_once( "data/scripts/invisibility_check.lua" )

--Setting The mirror shader to follow the entity
local entity_id = GetUpdatedEntityID()

local x, y = EntityGetTransform( entity_id )

local radius = 0.04

local variable_storage = EntityGetComponent(entity_id, "VariableStorageComponent")

if variable_storage then
	for k, v in pairs(variable_storage)do
		local name = ComponentGetValue2(v, "name")

		if(name == "shader_id")then
			local id = ComponentGetValue2(v, "value_string")   
			GameSetPostFxParameter("ballpos_" .. id, x, y, radius, 1.0)
			break
		end
	end
end

-- local maskTexturePath = "mods/new_enemies/files/shader_mask/shader_mask.png" -- Update with your mod's file path and texture name

-- -- Function to add mirror orb positions to the mask texture
-- function addMirrorOrbToMask(x, y)
    -- ModImageMakeEditable(maskTexturePath, 0, 0) -- Make the mask texture editable
    -- ModImageSetPixel(maskTexturePath, x, y, 0, 0, 0, 255) -- Set pixel at position (x, y) to black to represent mirror orb
-- end

-- -- Call addMirrorOrbToMask(x, y) whenever a mirror orb entity appears to add its position to the mask texture
-- addMirrorOrbToMask(x, y)

-- -- Pass the mask texture to the shader as a parameter
-- GameSetPostFxTextureParameter("mirrorOrbMaskTexture", maskTexturePath)


--Repelling all projectiles

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

local projectiles = EntityGetWithTag( "projectile" )
local direction_random = math.rad( Random( -30, 30 ) )
if ( #projectiles > 0 ) and Random( 1, 4 ) == 1 then
	for i,projectile_id in ipairs(projectiles) do	
			
		local px, py = EntityGetTransform( projectile_id )
		
		local distance = math.abs( x - px ) + math.abs( y - py )
		local distance_full = 15
		
		if ( distance < distance_full * 1.25 ) then
			distance = get_distance( px, py, x, y )
			direction = get_direction( px, py, x, y )
	
			if ( distance < distance_full ) then
			
				local is_converted = EntityHasTag(projectile_id, "projectile_converted")
				if not is_converted then
					EntityAddTag(projectile_id, "projectile_converted")
					GameEntityPlaySound( projectile_id, "suck_projectile" )
					EntityLoadToEntity("data/entities/animals/boss_centipede/boss_centipede_shield_trail_effect.xml", projectile_id)
				end
				
				local velocitycomponents = EntityGetComponent( projectile_id, "VelocityComponent" )
				
				local gravity_percent = math.max(( distance_full - distance ) / distance_full, 0.01)
				local gravity_coeff = 10000000
				
				local herd_id = get_herd_id(entity_id)
				local projectile_comp = EntityGetFirstComponentIncludingDisabled( projectile_id, "ProjectileComponent" )
				component_write( projectile_comp,
				{
					mWhoShot = entity_id,
					mShooterHerdId = herd_id,
					friendly_fire = false,
					collide_with_shooter_frames = -1,
				} )
				
				if ( velocitycomponents ~= nil ) then
					edit_component( projectile_id, "VelocityComponent", function(comp,vars)
						local vel_x,vel_y = ComponentGetValueVector2( comp, "mVelocity", vel_x, vel_y)
						
						local offset_x = math.cos( direction + direction_random ) * ( gravity_coeff * gravity_percent )
						local offset_y = 0 - math.sin( direction + direction_random ) * ( gravity_coeff * gravity_percent )

						vel_x = vel_x + offset_x
						vel_y = vel_y + offset_y

						ComponentSetValueVector2( comp, "mVelocity", vel_x, vel_y)
					end)
				end
			end
		end
	end
end

--movement
local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	players = {player}
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		players = {polymorphed_player}
	end
end

if #players > 0 then
	local px, py = EntityGetTransform( players[1] )
	local player_distance = get_distance(x, y, px, py)
	if ( BiomeMapGetName() ~= "$biome_holymountain" ) and player_distance < 100 then

		local range = 1000
		local target, targetX, targetY
		local min_dist = 1000
		-- is target a valid enemy
		if ( players[1] ~= entity_id ) and ( EntityGetFirstComponent(players[1], "GenomeDataComponent") ~= nil ) and ( EntityGetFirstComponent(players[1], "GenomeDataComponent") > 0 ) and ( EntityGetHerdRelation(entity_id, players[1]) < 40 ) and ( is_invisible(players[1]) == false ) then
			local target_x, target_y = EntityGetFirstHitboxCenter( players[1] )
			local dist = get_distance(x, y, target_x, target_y)
			if dist < min_dist then
				min_dist = dist
				target = players[1]
				targetX = target_x
				targetY = target_y
			end
		end
		
		target_id = target

		local did_hit, hit_x, hit_y = RaytraceSurfaces(x, y , targetX, targetY)

		if ( target_id ~= 0) and ( target_id ~= nil) and not did_hit then
			tx, ty = EntityGetTransform( target_id )
			angle = 0 - math.atan2( ty - y, tx - x )
			
			local length = Random( 600, 800 )

			vel_x = math.cos( angle ) * length
			vel_y = 0- math.sin( angle ) * length
			
			local velocity_component = EntityGetComponent(entity_id, "VelocityComponent")
			if(velocity_component ~= nil)then
				local velocity_x, velocity_y = ComponentGetValue2( velocity_component, "mVelocity")

				if(velocity_x ~= nil)then
					PhysicsApplyForce(entity_id, -velocity_x * 0.051, -velocity_y * 0.051)
				end
			end

			PhysicsApplyForce(entity_id, vel_x * 0.051, vel_y * 0.051)
			
		end
	end
end