dofile_once("data/scripts/lib/utilities.lua")

local times_executed = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")

--Remove Stains:
local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

local players = {}
local players_anywhere = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	local px, py = EntityGetTransform(player)
	local dist = get_distance(x, y, px, py)
	if dist <= 300 then
		players = {player}
	end
	players_anywhere = {player}
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		local px, py = EntityGetTransform(polymorphed_player)
		local dist = get_distance(x, y, px, py)
		if dist <= 300 then
			players = {polymorphed_player}
		end
		players_anywhere = {polymorphed_player}
	end
end


local player_id = players[1]

if #players > 0 then
	if (EntityGetHerdRelation(entity_id, player_id) < 40) then
	
		local animal_ai_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AnimalAIComponent")
		if ( animal_ai_component ~= nil ) and ( animal_ai_component > 0 ) then
			ComponentSetValue2( animal_ai_component, "mGreatestPrey", player_id )
			ComponentSetValue2( animal_ai_component, "mHasFoundPrey", true )
		end
		
		for i, child_id in ipairs(EntityGetAllChildren(player_id) or {}) do

			local game_effect_components = EntityGetComponentIncludingDisabled(child_id, "GameEffectComponent")
			
			for i, game_effect_component in ipairs(game_effect_components or {}) do
				
				if ComponentGetValue2(game_effect_component, "effect") == "PROTECTION_ALL" then 

					ComponentSetValue2( game_effect_component, "effect", "CUSTOM" )
					ComponentSetValue2( game_effect_component, "custom_effect_id", "NEW_ENEMIES_PROTECTION_REMOVED" )
					
					EntityAddComponent(child_id, "UIIconComponent", {
						icon_sprite_file="data/ui_gfx/status_indicators/protection_all_blocked.png",
						name="$no_protection_status_name",
						description="$no_protection_status_desc",
						display_above_head="1",
						display_in_hud="1",
						is_perk="0"
					})
				end
				
			end
			
		end
		
			-- local effect_entity = EntityGetWithName("new_enemies_remove_all_stains")

			-- if effect_entity == 0 then
					
				-- LoadGameEffectEntityTo( player_id, "data/entities/misc/effect_remove_stains.xml" )
				
				-- EntityAddComponent(player_id, "LuaComponent", {
					-- script_source_file="data/scripts/animals/necromancer_omega_stains_checker.lua",
					-- execute_every_n_frame=20,
					-- execute_on_added=0,
				-- }) 
						
			-- end

		-----------------

		local range_near = 40 -- if below, stop chase
		local range_far = 250
		local range_max = 600 -- if above, stop chase

		local speed_near = 0.5 -- speed used at range_near
		local speed_far = 1 -- speed used at range_far

		local entity_id = GetUpdatedEntityID()
		local pos_x, pos_y = EntityGetTransform(entity_id)

		local function set_fly_speed(spd)
			component_write( EntityGetFirstComponent( entity_id, "CharacterPlatformingComponent" ), { fly_speed_mult = spd, fly_velocity_x = spd * 2 } )
		end

		if #players_anywhere > 0 then
			set_fly_speed(40)
			return
		end

		local vx, vy = EntityGetTransform(player_id)
		vx, vy = vec_sub(vx, vy, pos_x, pos_y)
		local dist = get_magnitude(vx, vy, pos_x, pos_y)

		if dist < range_near or dist > range_max then
			set_fly_speed(40)
			return
		end

		-- move directly towards player
		set_fly_speed(0)
		local speed = map(dist, range_near, range_far, speed_near, speed_far)
		speed = clamp(speed, speed_near, speed_far)
		vx, vy = vec_normalize(vx, vy)
		vx, vy = vec_mult(vx, vy, speed)

		pos_x, pos_y = vec_add(pos_x, pos_y, vx, vy)
		EntitySetTransform(entity_id, pos_x, pos_y)

	end

end