dofile_once("data/scripts/lib/utilities.lua")
dofile_once( "data/scripts/invisibility_check.lua" )

local times_executed = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")
local entity_id    = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

local phase = GetValueNumber("number", 1)
local delay = GetValueNumber("number2", 0)

local enemy, enemy_x, enemy_y
for _,id in pairs(EntityGetInRadiusWithTag(x, y, 400, "mortal") or {}) do
	-- is target a valid enemy
	if ( entity_id ~= id ) and ( EntityGetFirstComponent(id, "GenomeDataComponent") ~= nil ) and ( EntityGetFirstComponent(id, "GenomeDataComponent") > 0 ) and (EntityGetHerdRelation(entity_id, id) < 40) and ( is_invisible(id) == false ) then
		local ex, ey = EntityGetFirstHitboxCenter( id )
		local did_hit, hit_x, hit_y = RaytracePlatforms(x, y - 20, ex, ey)
		if phase == 1 then
			if did_hit then
				enemy = id
				enemy_x = ex
				enemy_y = ey
				
				SetValueNumber("number2", delay + 1)
			else
				SetValueNumber("number2", 0)
			end
		elseif phase == 2 then
			if not did_hit then
				enemy = id
				enemy_x = ex
				enemy_y = ey
				
				SetValueNumber("number2", delay + 1)
			end
		end
	end
end
	
if phase == 1 then
	if ( enemy ~= nil ) and ( enemy > 0 ) and ( delay > 60 ) then
		SetValueNumber("number2", 0)
		EntityLoad( "data/entities/particles/phantom_boss_particles.xml", x, y - 20 )
		EntitySetTransform( entity_id, x, y - 5)

		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", false)

		local sprite_component = EntityGetFirstComponentIncludingDisabled(entity_id, "SpriteComponent")
		if ( sprite_component ~= nil ) and ( sprite_component > 0 ) then
			ComponentSetValue2( sprite_component, "image_file", "data/enemies_gfx/phantom_boss_tiny.xml" )
			EntityRefreshSprite( entity_id, sprite_component )
			ComponentSetValue2( sprite_component, "rect_animation", "stand" )
			ComponentSetValue2( sprite_component, "next_rect_animation", "stand" )
		end

		local animal_ai_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AnimalAIComponent")
		if ( animal_ai_component ~= nil ) and ( animal_ai_component > 0 ) then
			-- ComponentSetValue2( animal_ai_component, "attack_dash_enabled", true )
			ComponentSetValue2( animal_ai_component, "attack_melee_enabled", false )
			ComponentSetValue2( animal_ai_component, "ai_state", 18 )
			ComponentSetValue2( animal_ai_component, "can_walk", false )
			ComponentSetValue2( animal_ai_component, "can_fly", true )
		end

		local damage_model_component = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")
		if ( damage_model_component ~= nil ) and ( damage_model_component > 0 ) then
			ComponentSetValue2( damage_model_component, "minimum_knockback_force", 0 )
			
			-- local damage_projectile = ComponentObjectGetValue2( damage_model_component, "damage_multipliers", "projectile" )
			-- if damage_projectile > 0 then
				ComponentObjectSetValue2( damage_model_component, "damage_multipliers", "projectile", 0 )
			-- end
			
			-- local damage_fire = ComponentObjectGetValue2( damage_model_component, "damage_multipliers", "fire" )
			-- if damage_fire > 0 then
				ComponentObjectSetValue2( damage_model_component, "damage_multipliers", "fire", 0 )
			-- end
			
			-- local damage_melee = ComponentObjectGetValue2( damage_model_component, "damage_multipliers", "melee" )
			-- if damage_melee > 0 then
				ComponentObjectSetValue2( damage_model_component, "damage_multipliers", "melee", 0 )
			-- end
			
			-- local damage_drill = ComponentObjectGetValue2( damage_model_component, "damage_multipliers", "drill" )
			-- if damage_drill > 0 then
				ComponentObjectSetValue2( damage_model_component, "damage_multipliers", "drill", 0 )
			-- end
			
			-- local damage_slice = ComponentObjectGetValue2( damage_model_component, "damage_multipliers", "slice" )
			-- if damage_slice > 0 then
				ComponentObjectSetValue2( damage_model_component, "damage_multipliers", "slice", 0 )
			-- end
			
			-- local damage_radioactive = ComponentObjectGetValue2( damage_model_component, "damage_multipliers", "radioactive" )
			-- if damage_radioactive > 0 then
				ComponentObjectSetValue2( damage_model_component, "damage_multipliers", "radioactive", 0 )
			-- end
			
			-- local damage_explosion = ComponentObjectGetValue2( damage_model_component, "damage_multipliers", "explosion" )
			-- if damage_explosion > 0 then
				ComponentObjectSetValue2( damage_model_component, "damage_multipliers", "explosion", 0 )
			-- end
			
			-- local damage_electricity = ComponentObjectGetValue2( damage_model_component, "damage_multipliers", "electricity" )
			-- if damage_electricity > 0 then
				ComponentObjectSetValue2( damage_model_component, "damage_multipliers", "electricity", 0 )
			-- end
			
			-- local damage_poison = ComponentObjectGetValue2( damage_model_component, "damage_multipliers", "poison" )
			-- if damage_poison > 0 then
				ComponentObjectSetValue2( damage_model_component, "damage_multipliers", "poison", 0 )
			-- end
			
			-- local damage_physics_hit = ComponentObjectGetValue2( damage_model_component, "damage_multipliers", "physics_hit" )
			-- if damage_physics_hit > 0 then
				ComponentObjectSetValue2( damage_model_component, "damage_multipliers", "physics_hit", 0 )
			-- end
			
			-- local damage_ice = ComponentObjectGetValue2( damage_model_component, "damage_multipliers", "ice" )
			-- if damage_ice > 0 then
				ComponentObjectSetValue2( damage_model_component, "damage_multipliers", "ice", 0 )
			-- end
		end

		local character_data_component = EntityGetFirstComponentIncludingDisabled(entity_id, "CharacterDataComponent")
		if ( character_data_component ~= nil ) and ( character_data_component > 0 ) then
			ComponentSetValue2( character_data_component, "collision_aabb_min_x", -5 )
			ComponentSetValue2( character_data_component, "collision_aabb_max_x", 5 )
			ComponentSetValue2( character_data_component, "collision_aabb_min_y", -8 )
			ComponentSetValue2( character_data_component, "collision_aabb_max_y", 8 )
			ComponentSetValue2( character_data_component, "flying_needs_recharge", false )
			
		end
		
		local character_platforming_component = EntityGetFirstComponentIncludingDisabled(entity_id, "CharacterPlatformingComponent")
		if ( character_platforming_component ~= nil ) and ( character_platforming_component > 0 ) then
			ComponentSetValue2( character_platforming_component, "swim_idle_buoyancy_coeff", 1.2 )
		end

		local pathfinding_component = EntityGetFirstComponentIncludingDisabled(entity_id, "PathFindingComponent")
		if ( pathfinding_component ~= nil ) and ( pathfinding_component > 0 ) then
			ComponentSetValue2( pathfinding_component, "can_jump", true )
			ComponentSetValue2( pathfinding_component, "can_fly", true )
			ComponentSetValue2( pathfinding_component, "can_walk", false )
			ComponentSetValue2( pathfinding_component, "cost_of_flying", 0 )
		end

		local hitbox_component = EntityGetFirstComponent(entity_id, "HitboxComponent")
		if ( hitbox_component ~= nil ) and ( hitbox_component > 0 ) then
			ComponentSetValue2( hitbox_component, "aabb_min_y", -10 )
			ComponentSetValue2( hitbox_component, "aabb_max_y", 10 )
			ComponentSetValue2( hitbox_component, "aabb_min_x", -5 )
			ComponentSetValue2( hitbox_component, "aabb_max_x", 5 )
		end
		SetValueNumber("number", 2)
	end
elseif phase == 2 then
	local found, nx, ny, apd = GetSurfaceNormal(x, y, 13, 13)
	
	if ( not found ) and  ( BiomeMapGetName() ~= "$biome_holymountain" ) and ( enemy ~= nil ) and ( enemy > 0 ) and ( delay > 12 ) then
		SetValueNumber("number2", 0)
		EntitySetTransform( entity_id, x - nx, y - ny)
		EntityLoad( "data/entities/particles/phantom_boss_particles.xml", x - nx, y - ny)

		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)

		local sprite_component = EntityGetFirstComponentIncludingDisabled(entity_id, "SpriteComponent")
		if ( sprite_component ~= nil ) and ( sprite_component > 0 ) then
			ComponentSetValue2( sprite_component, "image_file", "data/enemies_gfx/phantom_boss.xml" )
			EntityRefreshSprite( entity_id, sprite_component )
			ComponentSetValue2( sprite_component, "rect_animation", "stand" )
			ComponentSetValue2( sprite_component, "next_rect_animation", "stand" )
		end

		local animal_ai_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AnimalAIComponent")
		if ( animal_ai_component ~= nil ) and ( animal_ai_component > 0 ) then
			-- ComponentSetValue2( animal_ai_component, "attack_dash_enabled", false )
			ComponentSetValue2( animal_ai_component, "attack_melee_enabled", true )
			ComponentSetValue2( animal_ai_component, "ai_state", 18 )
			ComponentSetValue2( animal_ai_component, "ai_state_timer", 0 )
			ComponentSetValue2( animal_ai_component, "can_walk", true )
			ComponentSetValue2( animal_ai_component, "can_fly", false )
		end

		local damage_model_component = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")
		if ( damage_model_component ~= nil ) and ( damage_model_component > 0 ) then
			ComponentSetValue2( damage_model_component, "minimum_knockback_force", 1000000 )
			-- local damage_projectile = ComponentObjectGetValue2( damage_model_component, "damage_multipliers", "projectile" )
			-- -- if damage_projectile > 0 then
				ComponentObjectSetValue2( damage_model_component, "damage_multipliers", "projectile", 0.5 )
			-- -- end
			
			-- local damage_fire = ComponentObjectGetValue2( damage_model_component, "damage_multipliers", "fire" )
			-- -- if damage_fire > 0 then
				ComponentObjectSetValue2( damage_model_component, "damage_multipliers", "fire", 0 )
			-- -- end
			
			-- local damage_melee = ComponentObjectGetValue2( damage_model_component, "damage_multipliers", "melee" )
			-- -- if damage_melee > 0 then
				ComponentObjectSetValue2( damage_model_component, "damage_multipliers", "melee", 1 )
			-- end
			
			-- local damage_drill = ComponentObjectGetValue2( damage_model_component, "damage_multipliers", "drill" )
			-- -- if damage_drill > 0 then
				ComponentObjectSetValue2( damage_model_component, "damage_multipliers", "drill", 1 )
			-- -- end
			
			-- local damage_slice = ComponentObjectGetValue2( damage_model_component, "damage_multipliers", "slice" )
			-- if damage_slice > 0 then
				ComponentObjectSetValue2( damage_model_component, "damage_multipliers", "slice", 1 )
			-- end
			
			-- local damage_radioactive = ComponentObjectGetValue2( damage_model_component, "damage_multipliers", "radioactive" )
			-- if damage_radioactive > 0 then
				ComponentObjectSetValue2( damage_model_component, "damage_multipliers", "radioactive", 1 )
			-- end
			
			-- local damage_explosion = ComponentObjectGetValue2( damage_model_component, "damage_multipliers", "explosion" )
			-- if damage_explosion > 0 then
				ComponentObjectSetValue2( damage_model_component, "damage_multipliers", "explosion", 0.4 )
			-- end
			
			-- local damage_electricity = ComponentObjectGetValue2( damage_model_component, "damage_multipliers", "electricity" )
			-- if damage_electricity > 0 then
				ComponentObjectSetValue2( damage_model_component, "damage_multipliers", "electricity", 1 )
			-- end
			
			-- local damage_poison = ComponentObjectGetValue2( damage_model_component, "damage_multipliers", "poison" )
			-- if damage_poison > 0 then
				ComponentObjectSetValue2( damage_model_component, "damage_multipliers", "poison", 1 )
			-- end
			
			-- local damage_physics_hit = ComponentObjectGetValue2( damage_model_component, "damage_multipliers", "physics_hit" )
			-- if damage_physics_hit > 0 then
				ComponentObjectSetValue2( damage_model_component, "damage_multipliers", "physics_hit", 1 )
			-- end
			
			-- local damage_ice = ComponentObjectGetValue2( damage_model_component, "damage_multipliers", "ice" )
			-- if damage_ice > 0 then
				ComponentObjectSetValue2( damage_model_component, "damage_multipliers", "ice", 1 )
			-- end
		end

		local character_data_component = EntityGetFirstComponentIncludingDisabled(entity_id, "CharacterDataComponent")
		if ( character_data_component ~= nil ) and ( character_data_component > 0 ) then
			ComponentSetValue2( character_data_component, "collision_aabb_min_x", -7 )
			ComponentSetValue2( character_data_component, "collision_aabb_max_x", 7 )
			ComponentSetValue2( character_data_component, "collision_aabb_min_y", -10 )
			ComponentSetValue2( character_data_component, "collision_aabb_max_y", 3 )
			ComponentSetValue2( character_data_component, "flying_needs_recharge", true )
		end
		
		local character_platforming_component = EntityGetFirstComponentIncludingDisabled(entity_id, "CharacterPlatformingComponent")
		if ( character_platforming_component ~= nil ) and ( character_platforming_component > 0 ) then
			ComponentSetValue2( character_platforming_component, "swim_idle_buoyancy_coeff", 0.8 )
		end

		local pathfinding_component = EntityGetFirstComponentIncludingDisabled(entity_id, "PathFindingComponent")
		if ( pathfinding_component ~= nil ) and ( pathfinding_component > 0 ) then
			ComponentSetValue2( pathfinding_component, "can_jump", false )
			ComponentSetValue2( pathfinding_component, "can_fly", false )
			ComponentSetValue2( pathfinding_component, "can_walk", true )
			ComponentSetValue2( pathfinding_component, "cost_of_flying", 9999999 )
		end

		local hitbox_component = EntityGetFirstComponent(entity_id, "HitboxComponent")
		if ( hitbox_component ~= nil ) and ( hitbox_component > 0 ) then
			ComponentSetValue2( hitbox_component, "aabb_min_y", -51 )
			ComponentSetValue2( hitbox_component, "aabb_max_y", 3 )
			ComponentSetValue2( hitbox_component, "aabb_min_x", -7 )
			ComponentSetValue2( hitbox_component, "aabb_max_x", 7 )
		end
		SetValueNumber("number", 1)
	end
	if times_executed % 12 == 0 then
		local did_hit, hit_x, hit_y = RaytraceSurfaces(x, y -8, x, y + 200)
		if did_hit then
			shoot_projectile( entity_id, "data/entities/projectiles/phantom_boss_wave2.xml", hit_x, hit_y, 0, 0 )
		end
	end
end