dofile_once( "data/scripts/lib/utilities.lua" )
dofile_once( "data/scripts/invisibility_check.lua" )
dofile_once( "data/scripts/teleporting_check.lua" )

function split_string(input_str, delimiter)
	local result = {}
	for match in (input_str .. delimiter):gmatch("(.-)" .. delimiter) do
		table.insert(result, match)
	end
	return result
end

-- Check if player is in range, and if they are, add the tracking script to them

local entity_id = GetUpdatedEntityID()
local parent_id = EntityGetParent(entity_id)
if ( parent_id == nil ) or ( parent_id == 0 ) then
	local world_state = GameGetWorldStateEntity()
	EntityAddChild( world_state, entity_id )
end
local x, y, rot, sx = EntityGetTransform(entity_id)

function get_distance(dx, dy, dx2, dy2)
	return math.sqrt(((dx-dx2)^2) + ((dy-dy2)^2))
end
--local x,y = EntityGetTransform( entity_id )
local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	players = {player}
end

local times_executed = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")

local old_x = GetValueNumber("old_x", x)
local old_y = GetValueNumber("old_y", y)

SetValueNumber("old_x", x)
SetValueNumber("old_y", y)

local dist = get_distance(old_x, old_y, x, y)
if dist > 16 then
	GamePlaySound("data/audio/Desktop/misc.bank", "game_effect/teleport/tick", x, y)
	EntityLoad( "data/entities/particles/teleportation_source.xml", x, y )
	EntityLoad( "data/entities/particles/teleportation_target.xml", x, y )

end

SetRandomSeed(GameGetFrameNum(), x + y + entity_id)

-- local has_died = GetValueNumber("has_died", 0)
-- if has_died ~= 0 then
	-- return
-- end

if #players > 0 then
	local player = players[1]
	local px, py = EntityGetTransform(player)
	
	local dist2 = get_distance(x, y, px, py)
	if ( times_executed % 30 == 0 ) and ( times_executed > 100 ) then
		if ( dist2 < 10 ) and ( is_invisible(player) == false ) then
			EntityInflictDamage( player, 0.04, "DAMAGE_PROJECTILE", "", "NONE", 2000 * sx, 0, entity_id, px, py, 500 )
			EntityInflictDamage( player, Randomf(0.4, 0.7), "DAMAGE_CURSE", "", "NONE", 2000 * sx, 0, entity_id, px, py, 500 )
			local sprite_comp = EntityGetFirstComponentIncludingDisabled( entity_id, "SpriteComponent" )
			if ( sprite_comp ~= nil ) and ( sprite_comp > 0 ) then
				ComponentSetValue2(sprite_comp, "rect_animation", "attack")
				ComponentSetValue2(sprite_comp, "next_rect_animation", "stand")
			end
		end
	end
	local var_store = get_variable_storage_component( player, "position_tracker_evil" )

	if ( var_store == nil ) or ( var_store == 0 ) then
		EntityAddComponent(player, "VariableStorageComponent", {
			name="position_tracker_evil",
			value_string=tostring(x)..","..tostring(y)..","..tostring(sx)..",fly_idle"
		})
		EntityAddComponent(player, "LuaComponent", {
			script_source_file="data/scripts/misc/position_tracker_evil.lua",
			execute_every_n_frame=1,
			execute_on_added=0
		}) 
		EntityAddComponent(player, "LuaComponent", {
			script_source_file="data/scripts/animals/position_tracker_checker_player_evil.lua",
			execute_every_n_frame=20,
			execute_on_added=0
		})
		-- EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)
		if tick == 0 then
			stored_coords = nil
		end
	else

		local val = ComponentGetValue2(var_store, "value_string")
		stored_coords = split_string(val, ",")
		-- stored_coords = decode_stored_coords_evil(val)

		if #stored_coords > 400 then
			while #stored_coords >= 4 do
				-- Attempt to convert the 4th index to a number
				local converted_number = tonumber(stored_coords[4])
				
				-- Check if conversion failed (meaning it's a string)
				if converted_number == nil then
					-- The 4th element is a string, so break the loop
					break
				else
					-- If the 4th element is not a string, remove the first element
					table.remove(stored_coords, 1)
				end
			end
			if ( is_invisible(player) == false ) then
				local scale_value = tonumber(stored_coords[3])
				if scale_value < 0 then
					scale_value = -1
				else
					scale_value = 1
				end
				EntitySetTransform(entity_id, tonumber(stored_coords[1]), tonumber(stored_coords[2]), rot, scale_value)
			end
			local sprite_comp = EntityGetFirstComponentIncludingDisabled( entity_id, "SpriteComponent" )
			if ( sprite_comp ~= nil ) and ( sprite_comp > 0 ) then
				local animation = ComponentGetValue2(sprite_comp, "rect_animation")
				if ( is_invisible(player) == true ) then
					local is_on_ground, hit_x, hit_y = RaytracePlatforms(x - 2, y + 3 , x + 2, y + 3)
					-- local character_data_comp = EntityGetFirstComponentIncludingDisabled(entity_id, "CharacterDataComponent")
					-- if ComponentGetValue2(character_data_comp, "is_on_ground") == false then
					if not is_on_ground then
						ComponentSetValue2(sprite_comp, "rect_animation", "fly_idle")
						ComponentSetValue2(sprite_comp, "next_rect_animation", "fly_idle")
					else
						ComponentSetValue2(sprite_comp, "rect_animation", "stand")
						ComponentSetValue2(sprite_comp, "next_rect_animation", "stand")
					end
				elseif ( stored_coords[4] == "stand" ) and ( animation ~= "attack" ) then
					local is_on_ground, hit_x, hit_y = RaytracePlatforms(x - 2, y + 4 , x + 2, y + 4)
					-- local character_data_comp = EntityGetFirstComponentIncludingDisabled(entity_id, "CharacterDataComponent")
					-- if ComponentGetValue2(character_data_comp, "is_on_ground") == false then
					if not is_on_ground then
						ComponentSetValue2(sprite_comp, "rect_animation", "fly_idle")
						ComponentSetValue2(sprite_comp, "next_rect_animation", "fly_idle")
					else
						ComponentSetValue2(sprite_comp, "rect_animation", stored_coords[4])
						ComponentSetValue2(sprite_comp, "next_rect_animation", stored_coords[4])
					end
				elseif ( ( stored_coords[4] == "burn" ) or ( stored_coords[4] == "run" ) or ( stored_coords[4] == "walk" ) or ( stored_coords[4] == "walk_backwards" )) and ( animation ~= "fly_move" ) then
					local is_on_ground, hit_x, hit_y = RaytracePlatforms(x - 2, y + 3 , x + 2, y + 3)
					local character_data_comp = EntityGetFirstComponentIncludingDisabled(entity_id, "CharacterDataComponent")
					-- if ComponentGetValue2(character_data_comp, "is_on_ground") == false then
					if not is_on_ground then
						ComponentSetValue2(sprite_comp, "rect_animation", "fly_move")
						ComponentSetValue2(sprite_comp, "next_rect_animation", "fly_move")
					else
						ComponentSetValue2(sprite_comp, "rect_animation", stored_coords[4])
						ComponentSetValue2(sprite_comp, "next_rect_animation", stored_coords[4])
					end
				elseif animation ~= "attack" then
					ComponentSetValue2(sprite_comp, "rect_animation", stored_coords[4])
					ComponentSetValue2(sprite_comp, "next_rect_animation", stored_coords[4])
				end
			end
			
			if ( is_invisible(player) == false ) then
				table.remove(stored_coords, 1)
				table.remove(stored_coords, 1)
				table.remove(stored_coords, 1)
				table.remove(stored_coords, 1)
			end
		end
	end
	
	if ( BiomeMapGetName(px, py) == "$biome_holymountain" ) and ( is_teleporting(player) == true ) then
		EntityRemoveFromParent(entity_id)
		EntityLoad( "data/entities/particles/player_evil_particles.xml", x , y )
		EntityLoad( "data/entities/animals/player_evil_green_sleep.xml", x , y )
		GlobalsSetValue("new_enemies_player_evil_active", "0")
		EntityRemoveComponent(entity_id, GetUpdatedComponentID() )

		EntityKill(entity_id)
	end

	if ( times_executed % 1000 == 0 ) then
		local hitbox = EntityLoad( "data/entities/animals/player_evil_hitbox.xml", x , y )

		local comp = EntityGetFirstComponentIncludingDisabled(hitbox, "VariableStorageComponent")
		if ( comp ~= nil ) and ( comp > 0 ) then
			ComponentSetValue2(comp, "value_int", entity_id)
		end
	end
end

