dofile_once("data/scripts/lib/utilities.lua")

function damage_about_to_be_received( dmg, x, y, source )
	local times_executed = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")
	local entity_id = GetUpdatedEntityID()
	local target = 0
	local telekinesis_damage = false
	local x,y = EntityGetTransform( entity_id )
	local comp = EntityGetFirstComponentIncludingDisabled(entity_id, "VariableStorageComponent")
	if ( comp ~= nil ) and ( comp > 0 ) then
		target = ComponentGetValue2( comp, "value_int" )	
		if target > 0 then
			-- local players = EntityGetInRadiusWithTag(x, y, 512, "player_unit")
			local players = {}
			local player = EntityGetWithName( "DEBUG_NAME:player" )
			if ( player ~= nil ) and ( player > 0 ) then
				local px, py = EntityGetTransform(player)
				local dist = get_distance(x, y, px, py)
				if dist <= 300 then
					players = {player}
				end
			else
				local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
				if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
					local px, py = EntityGetTransform(polymorphed_player)
					local dist = get_distance(x, y, px, py)
					if dist <= 300 then
						players = {polymorphed_player}
					end
				end
			end

			if #players > 0 then
				local block_damage = false
				local damage_comp = EntityGetFirstComponent( entity_id, "DamageModelComponent" )
				if ( damage_comp ~= nil ) and ( damage_comp > 0 ) then
					local physics_source = ComponentGetValue2(damage_comp, "mPhysicsDamageEntity")
					local telekinesis_physics_source = ComponentGetValue2(damage_comp, "mPhysicsDamageTelekinesisCasterEntity")
					if ( EntityHasTag( physics_source, "player_projectile" ) == true ) or
					( EntityHasTag( physics_source, "item_pickup" ) == true ) or
					( EntityHasTag( physics_source, "tablet" ) == true ) then
						block_damage = true			
					elseif ( physics_source > 0 ) and ( telekinesis_physics_source > 0 ) then
						telekinesis_damage = true
						dmg = dmg * 0.5
						block_damage = false	
					end
				end
				
				if ( ( EntityHasTag( source, "player_unit" ) == true ) or ( EntityHasTag( source, "player_projectile" ) == true ) ) and ( telekinesis_damage == false ) then
					block_damage = true
				end
				if ( block_damage == false ) then
					-- if source == 0 then
						-- if target > 0 then
							-- EntityInflictDamage( target, dmg, "DAMAGE_OVEREATING", "", "NONE", 0, 0, players[1], x, y )
						-- end
					-- else
					if ( target ~= nil ) and ( target > 0 ) then
						EntityInflictDamage( target, dmg, "DAMAGE_OVEREATING", "", "NONE", 0, 0, players[1], x, y )
					end
					-- end
				elseif block_damage == true then
					local entities = EntityGetInRadiusWithTag( x, y, 200, "player_ragdoll" )

					if ( #entities > 0 ) then
					else
						local block_text = EntityLoad( "data/entities/particles/player_evil_block_particles.xml", x , y )
						EntityInflictDamage( block_text, 0.5, "DAMAGE_PROJECTILE", "", "NONE", 0, 0, entity_id, x, y )
					end

				end
				if ( EntityHasTag( source, "boss_tag" ) == true ) then
					if ( target ~= nil ) and ( target > 0 ) then
						EntityInflictDamage( target, dmg, "DAMAGE_OVEREATING", "", "NONE", 0, 0, players[1], x, y )
					end
				end
			end
		end
	end
end