dofile_once("data/scripts/lib/utilities.lua")

function collision_trigger( colliding_entity_id )
	function spawn_fiend(path)
		dofile_once( "data/scripts/invisibility_check.lua" )
		local world_state = GameGetWorldStateEntity()
		local evil_player_found = false
		for i, child_id in ipairs(EntityGetAllChildren(world_state) or {}) do
			if EntityGetName( child_id ) == "$player_evil" then
				evil_player_found = true
			end
		end
		if evil_player_found == false then
			if is_invisible(colliding_entity_id) == false then
				local entity_id = GetUpdatedEntityID()
				local x, y = EntityGetTransform(entity_id)
				local animation_id = EntityLoad( path, x, y )
				
				EntityAddChild( world_state, animation_id )
				GlobalsSetValue("new_enemies_player_evil_active", "1")
				GamePlaySound( "data/audio/Desktop/animals.bank", "animals/statue/appear", x, y )
				EntityRemoveComponent( entity_id, GetUpdatedComponentID() )
				EntityKill(entity_id)
				return animation_id
			end
		end
	end
	if ( EntityGetName( colliding_entity_id ) == "DEBUG_NAME:player" ) or ( EntityHasTag( colliding_entity_id, "player_projectile" ) ) then
		if (GlobalsGetValue("new_enemies_player_evil_active", 0) == "0") then
			if BiomeMapGetName( x, y ) == "$biome_excavationsite" then
				local enemy_id = spawn_fiend("data/entities/animals/player_evil.xml")
				local damagemodels = EntityGetComponent( enemy_id, "DamageModelComponent" )
				if( damagemodels ~= nil ) then
					for i,damagemodel in ipairs(damagemodels) do
						ComponentSetValue( damagemodel, "max_hp", 7 )
						ComponentSetValue( damagemodel, "hp", 7 )
					end
				end
			elseif BiomeMapGetName( x, y ) == "$biome_snowcave" then
				local enemy_id = spawn_fiend("data/entities/animals/player_evil.xml")
				local damagemodels = EntityGetComponent( enemy_id, "DamageModelComponent" )
				if( damagemodels ~= nil ) then
					for i,damagemodel in ipairs(damagemodels) do
						ComponentSetValue( damagemodel, "max_hp", 10 )
						ComponentSetValue( damagemodel, "hp", 10 )
					end
				end
			elseif BiomeMapGetName( x, y ) == "$biome_rainforest" then
				local enemy_id = spawn_fiend("data/entities/animals/player_evil.xml")
				local damagemodels = EntityGetComponent( enemy_id, "DamageModelComponent" )
				if( damagemodels ~= nil ) then
					for i,damagemodel in ipairs(damagemodels) do
						ComponentSetValue( damagemodel, "max_hp", 12 )
						ComponentSetValue( damagemodel, "hp", 12 )
					end
				end
			elseif BiomeMapGetName( x, y ) == "$biome_vault" then
				local enemy_id = spawn_fiend("data/entities/animals/player_evil.xml")
				local damagemodels = EntityGetComponent( enemy_id, "DamageModelComponent" )
				if( damagemodels ~= nil ) then
					for i,damagemodel in ipairs(damagemodels) do
						ComponentSetValue( damagemodel, "max_hp", 15 )
						ComponentSetValue( damagemodel, "hp", 15 )
					end
				end
			elseif BiomeMapGetName( x, y ) == "$biome_tower" or BiomeMapGetName( x, y ) == "$biome_crypt" then
				local enemy_id = spawn_fiend("data/entities/animals/player_evil.xml")
				local damagemodels = EntityGetComponent( enemy_id, "DamageModelComponent" )
				if( damagemodels ~= nil ) then
					for i,damagemodel in ipairs(damagemodels) do
						local hp = tonumber( ComponentGetValue( damagemodel, "hp" ) ) * 4
						
						ComponentSetValue( damagemodel, "max_hp", hp )
						ComponentSetValue( damagemodel, "hp", hp )
					end
				end
			else
				spawn_fiend("data/entities/animals/player_evil.xml")
			end
		end
	end
end