dofile_once("data/scripts/lib/utilities.lua")

-- Functions to decode and encode stored coordinates
function decode_stored_coords_evil(encoded_string)
    local coords = {}
    for str in string.gmatch(encoded_string, "([^,]+)") do
        table.insert(coords, tostring(str) or str)
    end
    return coords
end

function split_string(input_str, delimiter)
	local result = {}
	for match in (input_str .. delimiter):gmatch("(.-)" .. delimiter) do
		table.insert(result, match)
	end
	return result
end

-- Check if player is in range, and if they are, add the tracking script to them

local entity_id = GetUpdatedEntityID()
local x, y, rot = EntityGetTransform(entity_id)
local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	players = {player}
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		players = {polymorphed_player}
	end
end

if #players > 0 then
    local player = players[1]
	local var_store = get_variable_storage_component( player, "position_tracker_evil" )

    if var_store then
        local tick = GetValueInteger("tick", 0)
        if tick == 0 then
            stored_coords = nil
        end
        SetValueInteger("tick", tick + 1)

        if not stored_coords then
            local val = ComponentGetValue2(var_store, "value_string")
			stored_coords = split_string(val, ",")
            -- stored_coords = decode_stored_coords_evil(val)
        end

        -- Debugging: print the contents of stored_coords
        -- GamePrint("Stored Coords Length: " .. tostring(#stored_coords))
        if #stored_coords > 0 then
            EntitySetTransform(entity_id, tonumber(stored_coords[#stored_coords - 3]), tonumber(stored_coords[#stored_coords - 2]), rot, tonumber(stored_coords[#stored_coords - 1]))

            local sprite_comps = EntityGetComponent(entity_id, "SpriteComponent") or {}
            for i, comp in ipairs(sprite_comps) do
                ComponentSetValue2(comp, "rect_animation", stored_coords[#stored_coords])
                ComponentSetValue2(comp, "next_rect_animation", stored_coords[#stored_coords])
            end

            table.remove(stored_coords, #stored_coords)
            table.remove(stored_coords, #stored_coords)
            table.remove(stored_coords, #stored_coords)
            table.remove(stored_coords, #stored_coords)
        end
    end
end