dofile_once( "data/scripts/lib/utilities.lua" )
dofile_once( "data/scripts/invisibility_check.lua" )

local entity_id = GetUpdatedEntityID()
local x, y, rot = EntityGetTransform( entity_id )
SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

local enemy_found = false

for _,id in pairs(EntityGetInRadiusWithTag(x, y, 100, "mortal")) do
	-- is target a valid enemy
	if ( id ~= entity_id ) and ( EntityGetFirstComponent(id, "GenomeDataComponent") ~= nil ) and ( EntityGetFirstComponent(id, "GenomeDataComponent") > 0 ) and ( EntityGetHerdRelation(entity_id, id) < 40 ) and ( is_invisible(id) == false ) then
		local ex, ey = EntityGetTransform( id )
		local did_hit, hit_x, hit_y = RaytracePlatforms(x, y, ex, ey)
		if not did_hit then
			enemy = id
			enemy_x = ex
			enemy_y = ey
			enemy_found = true
		end
	end
end

local times = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")

local sprite_component = EntityGetFirstComponentIncludingDisabled(entity_id, "SpriteComponent")
if ( sprite_component ~= nil ) and ( sprite_component > 0 ) then
	local animation = ComponentGetValue2(sprite_component, "rect_animation")
	if ( animation ~= "unpuff" ) and ( animation ~= "puffed" ) and ( animation ~= "puff" ) then
		if ( enemy_found == true ) and ( times % 200 == 0 ) and ( times > 5 ) then
			GamePlayAnimation(entity_id, "puff", 1, "puffed", 1)
			GamePlaySound("data/audio/Desktop/projectiles.bank", "player_projectiles/spore_pod_growing/create", x, y)
			
			-- EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)
			-- EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", false)

			local how_many = 20
			local angle_inc = ( 2 * 3.14159 ) / how_many
			local theta = 0
			local length = 200
			local dist = 5

			for i=1,how_many do
				local vel_x = math.cos( theta ) * length
				local vel_y = math.sin( theta ) * length
				theta = theta + angle_inc
				
				local newpos_x = x + math.cos( theta ) * dist
				local newpos_y = y + math.sin( theta ) * dist

				shoot_projectile( entity_id, "data/entities/projectiles/puffer_spike.xml", newpos_x + ( vel_x * 0.2 ), newpos_y + ( vel_y * 0.2 ), vel_x, vel_y )
			end
			
			for i=1, 100 do
				local bubble = EntityLoad( "data/entities/particles/gas_bubble.xml", x + Random(-35,35) , y + Random(-35,35) )
				local velocity_comp = EntityGetFirstComponent( entity_id, "GasBubbleComponent")
				if ( velocity_comp ~= nil ) and ( velocity_comp > 0 ) then
					ComponentSetValueVector2( velocity_comp, "mVelocity", Random(-100,100), Random(-100,100))
					ComponentSetValue2(velocity_comp, "acceleration", -2)
				end
			end
		end
	elseif ( animation ~= "unpuff" ) and ( ( animation == "puffed" ) or ( animation == "puff" ) ) then
		if ( enemy_found == false ) and ( times % 500 == 0 ) and ( times > 5 ) then
			GamePlayAnimation(entity_id, "unpuff", 1, "stand", 1)
		end
	elseif ( animation == "unpuff" ) then
		local bubble = EntityLoad( "data/entities/particles/gas_bubble.xml", x, y )
		local cdc_id = EntityGetFirstComponentIncludingDisabled(entity_id, "CharacterDataComponent")
		if ( cdc_id ~= nil ) and ( cdc_id > 0 ) then
			local velocity_x, velocity_y = ComponentGetValue2(cdc_id, "mVelocity")
			
			-- Calculate the force to apply based on the rotation
			local force_x = math.cos(rot) * 30  -- Adjust the multiplier as needed for the desired force
			local force_y = math.sin(rot) * 30  -- Adjust the multiplier as needed for the desired force
			
			-- Apply the force in the opposite direction
			ComponentSetValueVector2(cdc_id, "mVelocity", velocity_x - force_x, velocity_y - force_y)
		end
	end
	if ( animation == "unpuff" ) or ( animation == "puffed" ) then
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", false)
	else
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", false)
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", true)
	end
	if ( animation == "unpuff" ) then
		EntitySetComponentsWithTagEnabled(entity_id, "shoot_pos", true)
	else
		EntitySetComponentsWithTagEnabled(entity_id, "shoot_pos", false)
	end
end

function damage_received( damage, message, entity_thats_responsible, is_fatal  )
	if ( is_fatal == false ) then
		local entity_id = GetUpdatedEntityID()
		local x, y, rot = EntityGetTransform( entity_id )
		SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
		local sprite_component = EntityGetFirstComponentIncludingDisabled(entity_id, "SpriteComponent")
		if ( sprite_component ~= nil ) and ( sprite_component > 0 ) then
			local animation = ComponentGetValue2(sprite_component, "rect_animation")
			if ( animation ~= "unpuff" ) and ( animation ~= "puffed" ) and ( animation ~= "puff" ) then
				GamePlayAnimation(entity_id, "puff", 1, "puffed", 1)
				GamePlaySound("data/audio/Desktop/projectiles.bank", "player_projectiles/spore_pod_growing/create", x, y)
				-- EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)
				-- EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", false)
				local how_many = 20
				local angle_inc = ( 2 * 3.14159 ) / how_many
				local theta = 0
				local length = 200
				local dist = 5

				for i=1,how_many do
					local vel_x = math.cos( theta ) * length
					local vel_y = math.sin( theta ) * length
					theta = theta + angle_inc
					
					local newpos_x = x + math.cos( theta ) * dist
					local newpos_y = y + math.sin( theta ) * dist

					shoot_projectile( entity_id, "data/entities/projectiles/puffer_spike.xml", newpos_x + ( vel_x * 0.2 ), newpos_y + ( vel_y * 0.2 ), vel_x, vel_y )
				end
				
				for i=1, 100 do
					local bubble = EntityLoad( "data/entities/particles/gas_bubble.xml", x + Random(-35,35) , y + Random(-35,35) )
					local velocity_comp = EntityGetFirstComponent( entity_id, "GasBubbleComponent")
					if ( velocity_comp ~= nil ) and ( velocity_comp > 0 ) then
						ComponentSetValueVector2( velocity_comp, "mVelocity", Random(-100,100), Random(-100,100))
						ComponentSetValue2(velocity_comp, "acceleration", -2)
					end
				end
			end
		end
	end
end