dofile_once( "data/scripts/lib/utilities.lua" )
dofile_once( "data/scripts/game_helpers.lua" )
dofile_once( "data/scripts/invisibility_check.lua" )

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	players = {player}
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		players = {polymorphed_player}
	end
end

local player_id = players[1]

if ( #players > 0 ) and ( BiomeMapGetName() ~= "$biome_holymountain" ) and ( EntityGetFirstComponent(player_id, "GenomeDataComponent") ~= nil ) and ( EntityGetFirstComponent(player_id, "GenomeDataComponent") > 0 ) and ( EntityGetHerdRelation(entity_id, player_id) < 40 ) and ( is_invisible(player_id) == false ) then

	local tag = "fish_attractor"
				
	if not EntityHasTag(player_id, tag) then
			
		EntityAddTag( player_id, tag )
		
		EntityAddComponent(player_id, "LuaComponent", {
			script_source_file="data/scripts/animals/quin_attractor_checker.lua",
			execute_every_n_frame=20,
			execute_on_added=0,
		}) 
				
	end
end