dofile_once("data/scripts/lib/utilities.lua")

local range = 300

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	players = {player}
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		players = {polymorphed_player}
	end
end

local target = players[1]

if ( target ~= nil ) and ( target > 0 ) then
	local tx, ty = EntityGetTransform(target)
	local dist = get_distance(tx, ty, x, y)

	if dist > range then

		for i, child in ipairs(EntityGetAllChildren(entity_id) or {}) do
		  if EntityGetName(child) == "ik_leg" then
		  
			local lua_component = EntityGetFirstComponentIncludingDisabled(child, "LuaComponent")
			EntitySetComponentIsEnabled( child, lua_component, false )
			
			for i, child_of_child in ipairs(EntityGetAllChildren(child)) do
				local sprite_components = EntityGetComponentIncludingDisabled(child_of_child, "SpriteComponent")
				
				for k, sprite_component in pairs(sprite_components) do
					EntitySetComponentIsEnabled( child_of_child, sprite_component, false )
				end
			end
		  end
		end
		
	else

		for i, child in ipairs(EntityGetAllChildren(entity_id) or {}) do
		  if EntityGetName(child) == "ik_leg" then
		  
			local lua_component = EntityGetFirstComponentIncludingDisabled(child, "LuaComponent")
			EntitySetComponentIsEnabled( child, lua_component, true )
			
			for i, child_of_child in ipairs(EntityGetAllChildren(child)) do
				local sprite_components = EntityGetComponentIncludingDisabled(child_of_child, "SpriteComponent")
				
				for k, sprite_component in pairs(sprite_components) do
					EntitySetComponentIsEnabled( child_of_child, sprite_component, true )
				end
			end
			
		  end
		end

	end
end