dofile_once( "data/scripts/lib/utilities.lua" )
dofile_once( "data/scripts/game_helpers.lua" )
dofile_once( "data/scripts/invisibility_check.lua" )

local entity_id = GetUpdatedEntityID()
local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	players = {player}
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		players = {polymorphed_player}
	end
end

function get_state()
  state = state or {}
  state[entity_id] = state[entity_id] or {
    last_frame_hit = 0
  }
  return state[entity_id]
end

local state = get_state()
local frames_active_after_getting_hit = 60

function damage_received()
  state.last_frame_hit = GameGetFrameNum()
end

local is_angry = state.last_frame_hit + frames_active_after_getting_hit > GameGetFrameNum()

local player_x, player_y, player_scale_x = 0, 0, 1

local ghost_component = EntityGetFirstComponentIncludingDisabled(entity_id, "GhostComponent")

if #players > 0 then
	player_x, player_y, succ, player_scale_x = EntityGetTransform(players[1])
end

local x, y = EntityGetTransform( entity_id )

local current_state = current_state or "stand"

local previous_state = current_state

local sprite_comp = EntityGetFirstComponentIncludingDisabled(entity_id, "SpriteComponent")
local animation = ComponentGetValue2( sprite_comp, "rect_animation")

if ( is_invisible(players[1]) == true ) and ( not is_angry ) and (player_x > x) then

  current_state = "stand"
  if animation ~= "stand" then
    GamePlaySound("data/audio/Desktop/misc.bank", "game_effect/frozen/create", x, y)
  end
  play_animation( entity_id, "stand")
    
  EntitySetComponentIsEnabled( entity_id, ghost_component, false )

elseif ( is_invisible(players[1]) == true ) and ( not is_angry ) and (player_x < x) then

  current_state = "stand"
  
  if animation ~= "stand2" then
    GamePlaySound("data/audio/Desktop/misc.bank", "game_effect/frozen/create", x, y)
  end

  play_animation( entity_id, "stand2")
  
  EntitySetComponentIsEnabled( entity_id, ghost_component, false )

elseif not is_angry and (player_x > x) and player_scale_x < 0 then
  current_state = "stand"
  if animation ~= "stand" then
    GamePlaySound("data/audio/Desktop/misc.bank", "game_effect/frozen/create", x, y)
  end
  play_animation( entity_id, "stand")
    
  EntitySetComponentIsEnabled( entity_id, ghost_component, false )

elseif (is_angry and player_x > x) or (player_x > x and player_scale_x > 0 and not (BiomeMapGetName() == "$biome_holymountain")) then
  current_state = "angry"
  if animation ~= "attack" then
    GamePlaySound("data/audio/Desktop/misc.bank", "game_effect/frozen/game_effect_end", x, y)
    GamePlaySound("mods/new_enemies/data/sound/more_sounds/my_mod_audio.bank", "snd_mod/sneeker_vocal", x, y)
  end
  play_animation( entity_id, "attack")
  
  EntitySetComponentIsEnabled( entity_id, ghost_component, true )
    
elseif not is_angry and (player_x < x) and player_scale_x > 0 then

  current_state = "stand"
  
  if animation ~= "stand2" then
    GamePlaySound("data/audio/Desktop/misc.bank", "game_effect/frozen/create", x, y)
  end

  play_animation( entity_id, "stand2")
  
  EntitySetComponentIsEnabled( entity_id, ghost_component, false )

elseif (is_angry and player_x < x) or (player_x < x and player_scale_x < 0 and not (BiomeMapGetName() == "$biome_holymountain")) then
  current_state = "angry"
  if animation ~= "attack2" then
    GamePlaySound("data/audio/Desktop/misc.bank", "game_effect/frozen/game_effect_end", x, y)
	GamePlaySound("mods/new_enemies/data/sound/more_sounds/my_mod_audio.bank", "snd_mod/sneeker_vocal", x, y)
  end
  
  play_animation( entity_id, "attack2")
  
  EntitySetComponentIsEnabled( entity_id, ghost_component, true )
    
end

local dist = get_distance(x, y, player_x, player_y)
if dist <= 300 then
	ComponentSetValue2(GetUpdatedComponentID(), "execute_every_n_frame", 1)
else
	ComponentSetValue2(GetUpdatedComponentID(), "execute_every_n_frame", 60)
end

-- local x, y = EntityGetTransform( entity_id )

-- if not is_angry and (player_x > x) and player_scale_x < 0 then

    -- play_animation( entity_id, "stand")
	
	-- EntitySetComponentIsEnabled( entity_id, ghost_component, false )

-- elseif (is_angry and player_x > x) or (player_x > x and player_scale_x > 0 and not (BiomeMapGetName() == "$biome_holymountain")) then

    -- play_animation( entity_id, "attack")
	
	-- EntitySetComponentIsEnabled( entity_id, ghost_component, true )
    
-- elseif not is_angry and (player_x < x) and player_scale_x > 0 then

    -- play_animation( entity_id, "stand2")
	
	-- EntitySetComponentIsEnabled( entity_id, ghost_component, false )

-- elseif (is_angry and player_x < x) or (player_x < x and player_scale_x < 0 and not (BiomeMapGetName() == "$biome_holymountain")) then

    -- play_animation( entity_id, "attack2")
	
	-- EntitySetComponentIsEnabled( entity_id, ghost_component, true )
    
-- end