dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local entities = EntityGetInRadiusWithTag(x, y, 500, "enemy")

local leader_found = false

for i, entity in ipairs(entities) do

	if EntityGetName(entity) == "$snowman" then
		leader_found = true
		
		local leader_x, leader_y = EntityGetTransform(entity)
		local particle_emitter_component = EntityGetFirstComponent(entity_id, "ParticleEmitterComponent")

		ComponentSetValue2(particle_emitter_component, "mExPosition", leader_x, leader_y)
		
		break
	end
	
end

if not leader_found then
	
	local damage_model_component = EntityGetFirstComponent(entity_id, "DamageModelComponent")
		
	ComponentSetValue2(damage_model_component, "hp", 0)
	ComponentSetValue2(damage_model_component, "air_needed", true)
	ComponentSetValue2(damage_model_component, "air_in_lungs", 0)
	
end

local cx, cy = GameGetCameraPos()
local dist = get_distance(x, y, cx, cy)
if dist <= 300 then
	ComponentSetValue2(GetUpdatedComponentID(), "execute_every_n_frame", 5)
	ComponentSetValue2(GetUpdatedComponentID(), "mNextExecutionTime", GameGetFrameNum())
else
	ComponentSetValue2(GetUpdatedComponentID(), "execute_every_n_frame", 200)
end