dofile_once( "data/scripts/lib/utilities.lua" )
dofile_once( "data/scripts/game_helpers.lua" )
dofile_once( "data/scripts/invisibility_check.lua" )

local entity_id = GetUpdatedEntityID()
local players = get_players()
local player_x, player_y = 0, 0

if #players > 0 then
  player_x, player_y = EntityGetTransform(players[1])
end

local x, y, rot, sx = EntityGetTransform( entity_id )

if(player_x > x) then

    EntitySetTransform(entity_id, x, y, rot, 1)
    
elseif(player_x < x) then

    EntitySetTransform(entity_id, x, y, rot, -1)
    
end

--disable Ghost component if player is in holy mountain:

function get_state2()
  state2 = state2 or {}
  state2[entity_id] = state2[entity_id] or {
    last_frame_hit = 0
  }
  return state2[entity_id]
end

local state2 = get_state2()
local frames_active_after_getting_hit = 600

function damage_received()
  state2.last_frame_hit = GameGetFrameNum()
end

local is_angry = state2.last_frame_hit + frames_active_after_getting_hit > GameGetFrameNum()

local ghost_component = EntityGetFirstComponentIncludingDisabled(entity_id, "GhostComponent")

if not is_angry and BiomeMapGetName() == "$biome_holymountain" and #players > 0 then
	EntitySetComponentIsEnabled( entity_id, ghost_component, false )
elseif is_angry and BiomeMapGetName() == "$biome_holymountain" and #players > 0 then
	EntitySetComponentIsEnabled( entity_id, ghost_component, true )
else
	EntitySetComponentIsEnabled( entity_id, ghost_component, true )
end

local times = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")

if ( #players > 0 ) and ( is_invisible(players[1]) == true ) then

	for _, child in ipairs(EntityGetAllChildren(entity_id) or {} ) do
		if EntityGetName(child) == "Ghost Target" then
			target_id = child
			tx, ty = EntityGetTransform(target_id)
		end
	end
	
	SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
	
	if times % 120 == 0 then
		EntitySetTransform( target_id, x + Random(-200, 200), y + Random(-200, 200))
		ComponentSetValue2( ghost_component, "mNextTargetCheckFrame", GameGetFrameNum() )
	end
	
	tx, ty = EntityGetTransform(target_id)
	
	local ghost_component = EntityGetFirstComponentIncludingDisabled(entity_id, "GhostComponent")
	if ( ghost_component ~= nil ) and ( ghost_component > 0 ) then
		if ( target_id ~= nil ) and ( target_id > 0 ) then
			ComponentSetValue2( ghost_component, "mTargetEntityId", target_id )
		end
		if tx ~= nil and ty ~= nil then
			ComponentSetValue2( ghost_component, "mTargetPosition", tx, ty )
			ComponentSetValue2( ghost_component, "mRandomTarget", tx, ty )
		end
	end
end