local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local variable_component = EntityGetFirstComponentIncludingDisabled(entity_id, "VariableStorageComponent")
if ( variable_component ~= nil ) and ( variable_component > 0 ) then
	local value = ComponentGetValue2(variable_component, "value_int")
	if value == 0 then

		SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

		local orientation = Random(1,2)
		if orientation == 2 then
			EntitySetComponentsWithTagEnabled(entity_id, "kick_pos", true)
			EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", false)

			local animal_ai_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AnimalAIComponent")
			if ( animal_ai_component ~= nil ) and ( animal_ai_component > 0 ) then
				ComponentSetValue2( animal_ai_component, "attack_ranged_offset_y", 3 )
				ComponentSetValue2( animal_ai_component, "attack_ranged_offset_x", 3 )
				ComponentSetValue2( animal_ai_component, "eye_offset", -6 )
			end
			
			local damage_model_component = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")
			if ( damage_model_component ~= nil ) and ( damage_model_component > 0 ) then
				ComponentSetValue2( damage_model_component, "ragdoll_filenames_file", "data/ragdolls/stalker_ceiling/filenames.txt" )
				ComponentSetValue2( damage_model_component, "ragdoll_offset_y", 1 )
			end

			local character_data_component = EntityGetFirstComponentIncludingDisabled(entity_id, "CharacterDataComponent")
			if ( character_data_component ~= nil ) and ( character_data_component > 0 ) then
				ComponentSetValue2( character_data_component, "collision_aabb_min_y", -7 )
				ComponentSetValue2( character_data_component, "collision_aabb_max_y", -7 )
				ComponentSetValue2( character_data_component, "mass", 1.8 )
				ComponentSetValue2( character_data_component, "gravity", -10 )
			end

			local character_platforming_component = EntityGetFirstComponentIncludingDisabled(entity_id, "CharacterPlatformingComponent")
			if ( character_platforming_component ~= nil ) and ( character_platforming_component > 0 ) then
				ComponentSetValue2( character_platforming_component, "pixel_gravity", -600 )
			end
			
			-- local lua_comps = EntityGetComponentIncludingDisabled(entity_id, "LuaComponent") or {}

			-- for i, lua_comp in ipairs(lua_comps) do
				-- if ComponentGetValue2(lua_comp, "script_death") == "data/scripts/items/drop_money.lua" then
					-- ComponentSetValue2( lua_comp, "script_death", "data/scripts/items/drop_money_dripper.lua" )
				-- end
			-- end
		else
			EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", true)
			EntitySetComponentsWithTagEnabled(entity_id, "kick_pos", false)
		end

		local variable_component = EntityGetFirstComponentIncludingDisabled(entity_id, "VariableStorageComponent")
		if ( variable_component ~= nil ) and ( variable_component > 0 ) then
			ComponentSetValue2( variable_component, "value_int", orientation )
		end

		EntitySetComponentsWithTagEnabled(entity_id, "shoot_pos", true)
	end
end