dofile_once("data/scripts/lib/utilities.lua")

local range = 300

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	players = {player}
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		players = {polymorphed_player}
	end
end

local target = players[1]

if ( target ~= nil ) and ( target > 0 ) then
	local tx, ty = EntityGetTransform(target)
	local dist = get_distance(tx, ty, x, y)

	if dist > range then
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", false)
		for i, child in ipairs(EntityGetAllChildren(entity_id) or {}) do
			if ( EntityGetName(child) == "subverlet" ) or ( EntityGetName(child) == "controller" ) then
				EntityKill(child)
			end
		end
	else
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)
		local subverlet_count = 0
		local controller_count = 0
		for i, child in ipairs(EntityGetAllChildren(entity_id) or {}) do
			if ( EntityGetName(child) == "subverlet" ) then
				subverlet_count = subverlet_count + 1
			end
			if ( EntityGetName(child) == "controller" ) then
				controller_count = controller_count + 1
			end
		end
		
		if controller_count == 0 then
			local child_entity = EntityLoad( "data/entities/vine_monster/verlet_projectile.xml", x, y)
			EntityAddChild(entity_id, child_entity)
		end
		
		if subverlet_count == 0 then
			local child_entity2 = EntityLoad( "data/entities/tentacle_monster/kelp/slime_tentacle_01.xml", x, y)
			EntityAddChild(entity_id, child_entity2)
			
			child_entity2 = EntityLoad( "data/entities/tentacle_monster/kelp/slime_tentacle_02.xml", x, y)
			EntityAddChild(entity_id, child_entity2)
			
			child_entity2 = EntityLoad( "data/entities/tentacle_monster/kelp/slime_tentacle_03.xml", x, y)
			EntityAddChild(entity_id, child_entity2)
			
			child_entity2 = EntityLoad( "data/entities/tentacle_monster/kelp/slime_tentacle_alt_01.xml", x, y)
			EntityAddChild(entity_id, child_entity2)

			child_entity2 = EntityLoad( "data/entities/tentacle_monster/kelp/slime_tentacle_alt_02.xml", x, y)
			EntityAddChild(entity_id, child_entity2)
			
			child_entity2 = EntityLoad( "data/entities/tentacle_monster/kelp/slime_tentacle_alt_03.xml", x, y)
			EntityAddChild(entity_id, child_entity2)
			
			child_entity2 = EntityLoad( "data/entities/tentacle_monster/kelp/slime_tentacle_thin_01.xml", x, y)
			EntityAddChild(entity_id, child_entity2)
			
			child_entity2 = EntityLoad( "data/entities/tentacle_monster/kelp/slime_tentacle_thin_alt_01.xml", x, y)
			EntityAddChild(entity_id, child_entity2)
			
			child_entity2 = EntityLoad( "data/entities/tentacle_monster/kelp/slime_tentacle_01.xml", x, y)
			EntityAddChild(entity_id, child_entity2)
			
			child_entity2 = EntityLoad( "data/entities/tentacle_monster/kelp/slime_tentacle_02.xml", x, y)
			EntityAddChild(entity_id, child_entity2)
		end
	end
end