dofile_once( "data/scripts/lib/utilities.lua" )
dofile_once( "data/scripts/game_helpers.lua" )

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

function get_distance(dx, dy, dx2, dy2)
	return math.sqrt(((dx-dx2)^2) + ((dy-dy2)^2))
end
--local x,y = EntityGetTransform( entity_id )
local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	local px, py = EntityGetTransform(player)
	local dist = get_distance(x, y, px, py)
	if dist <= 1000 then
		players = {player}
	end
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		local px, py = EntityGetTransform(polymorphed_player)
		local dist = get_distance(x, y, px, py)
		if dist <= 1000 then
			players = {polymorphed_player}
		end
	end
end

if #players > 0 then

	local has_worm_attractor = false
	local worm_attractor_component = EntityGetFirstComponent(player_id, "WormAttractorComponent")
			
	if worm_attractor_component then
		has_worm_attractor = true
	end
	
	local this_lua_component = GetUpdatedComponentID()
			
	local worm_attractor_lifetime = ComponentGetValue2(this_lua_component, "execute_every_n_frame")
	
	if not has_worm_attractor then
	
		-- EntityAddComponent(player_id, "VariableStorageComponent", {
			-- name = "has_worm_attractor",
		-- })
		
		-- EntityAddComponent(player_id, "GameEffectComponent", {
			-- effect = "WORM_ATTRACTOR",
			-- frames = worm_attractor_lifetime,
		-- })
		
		-- GetGameEffectLoadTo(player_id, "WORM_ATTRACTOR", true)
		
		local game_effect_comp = GetGameEffectLoadTo(players[1], "WORM_ATTRACTOR", true)
		ComponentSetValue2(game_effect_comp, "frames", tonumber(worm_attractor_lifetime))
		
		--GamePrint("Added Worm Attractor")
		
		EntityAddComponent(players[1], "WormAttractorComponent", {
			direction = "1",
			radius = 3000,
		})
		
		EntityAddComponent(players[1], "LuaComponent", {
			script_source_file = "data/scripts/animals/worm_target_player_checker.lua",
			execute_every_n_frame = 20,
			execute_on_added = 0,
		}) 
				
	end
end