dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local entities = EntityGetInRadiusWithTag(x, y, 300, "mortal")

for i, entity in ipairs(entities) do

	if EntityGetName(entity) == "$xopon" then
		
		function get_distance(dx, dy, dx2, dy2)
			return math.sqrt(((dx-dx2)^2) + ((dy-dy2)^2))
		end

		local players = {}
		local player = EntityGetWithName( "DEBUG_NAME:player" )
		if ( player ~= nil ) and ( player > 0 ) then
			local px, py = EntityGetTransform(player)
			players = {player}
		else
			local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
			if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
				players = {polymorphed_player}
			end
		end

		if #players > 0 then

			local player_x, player_y = EntityGetTransform(players[1])
			EntitySetTransform(entity_id, player_x, player_y)
			
			local leader_x, leader_y = EntityGetTransform(entity)
			local particle_emitter_component = EntityGetFirstComponentIncludingDisabled(entity_id, "ParticleEmitterComponent")
			
			ComponentSetValue2(particle_emitter_component, "mExPosition", leader_x, leader_y)
			
		end
	end
	
end