dofile_once( "data/scripts/projectiles/overmind.lua" )
dofile_once("data/scripts/lib/utilities.lua")

local times = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")

local entity_id = GetUpdatedEntityID()
		
local x, y, rot = EntityGetTransform( entity_id )

local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	players = {player}
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		players = {polymorphed_player}
	end
end

local physbod2_component = EntityGetFirstComponentIncludingDisabled(entity_id, "PhysicsBody2Component")
local pathfinding_component = EntityGetFirstComponentIncludingDisabled(entity_id, "PathFindingComponent")

--Getting all my children
for i, child in ipairs(EntityGetAllChildren(entity_id) or {}) do
	if EntityGetName(child) == "controls" then
		pathfinding_component = EntityGetFirstComponentIncludingDisabled(child, "PathFindingComponent")
	end
end
	
if ( physbod2_component ~= nil ) and ( physbod2_component > 0 ) then

	local pixcount = ComponentGetValue2(physbod2_component, "mPixelCount")
	
	if #players > 0 then
		local px, py = EntityGetTransform(players[1])

		local dist = get_distance(x, y, px, py)
		if dist < 450 then
			if EntityGetComponent(entity_id, "GenomeDataComponent") ~= nil and ( ( EntityGetHerdRelation(entity_id, players[1]) > 40 ) or (EntityGetHerdRelation(entity_id, players[1]) <= 0 ) ) then
				-- Move directly towards the player when the distance is greater than 450
				local direction_x = px - x
				local direction_y = py - y
				local norm = math.sqrt(direction_x^2 + direction_y^2)
				direction_x = direction_x / norm
				direction_y = direction_y / norm

				PhysicsApplyForce(entity_id, (direction_x * pixcount / 10), (direction_y * pixcount / 10))

			else
				-- Use pathfinding when the distance is less than 450
				local targ_x, targ_y = ComponentGetValueVector2(pathfinding_component, "path_next_node_vector_to")
				PhysicsApplyForce(entity_id, (targ_x * pixcount / 100), (targ_y * pixcount / 100))
			end
		else
			-- Move directly towards the player when the distance is greater than 450
			local direction_x = px - x
			local direction_y = py - y
			local norm = math.sqrt(direction_x^2 + direction_y^2)
			direction_x = direction_x / norm
			direction_y = direction_y / norm

			PhysicsApplyForce(entity_id, (direction_x * pixcount / 5), (direction_y * pixcount / 5))
		end
	else
		local targ_x, targ_y = ComponentGetValueVector2(pathfinding_component, "path_next_node_vector_to")
		local pixcount = ComponentGetValue2(physbod2_component, "mPixelCount")
		PhysicsApplyForce( entity_id, ( targ_x * pixcount/100 ), ( targ_y * pixcount/100 ))
	end
	
	PhysicsApplyForce(entity_id, 0, -pixcount * 0.1)
	PhysicsApplyTorque(entity_id, -rot * 20 * pixcount / 100)
end