dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	players = {player}
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		players = {polymorphed_player}
	end
end

local components = EntityGetComponent( entity_id, "VariableStorageComponent" )
if ( components ~= nil ) then
	for _,comp_id in pairs(components) do 
		local var_name = ComponentGetValue( comp_id, "name" )
		if ( var_name == "last_player_pos") then
			last_player_pos_var_comp = comp_id
		end
	end
end

local lppx = ComponentGetValue2( last_player_pos_var_comp, "value_int" )
local lppy = ComponentGetValue2( last_player_pos_var_comp, "value_float" )
if #players > 0 then
	local player_x, player_y = EntityGetTransform(players[1])
	if ( player_x > x + 256 ) or ( player_x < x - 256 ) or ( player_y > y + 132 ) or ( player_y < y - 256 ) then  
		if ( lppx == nil ) or ( lppy == nil ) or ( lppx == 0 ) or ( lppy == 0 ) then
			EntitySetTransform(players[1], x, y)
		elseif ( lppx > x + 240 ) or ( lppx < x - 240 ) or ( lppy > y + 132 ) or ( lppy < y - 240 ) then
			EntitySetTransform(players[1], x, y)
		else
			EntitySetTransform(players[1], lppx, lppy)
		end
	elseif ( player_x < x + 240 ) and ( player_x > x - 240 ) and ( player_y < y + 132 ) and ( player_y > y - 240 ) then 
		ComponentSetValue2(last_player_pos_var_comp, "value_int", player_x)
		ComponentSetValue2(last_player_pos_var_comp, "value_float", player_y)
	end
end

if ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % 720 == 0 then
	LoadPixelScene( "data/biome_impl/orbroommwyahclosed_hydra_refresh.png", "", x-256, y-256, "", true, false, "", 50, true)
end