dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local var_comp = get_variable_storage_component( entity_id, "invincibility_frames" )
local inviframes = 0
if ( var_comp ~= nil ) and ( var_comp > 0 ) then
	inviframes = ComponentGetValue2( var_comp, "value_float" )
end

local comp = EntityGetFirstComponent( entity_id, "DamageModelComponent" )
if ( comp ~= nil ) and ( comp > 0 ) then
	ComponentSetValue2( comp, "invincibility_frames", inviframes )

	local lua_comps = EntityGetComponent(entity_id, "LuaComponent") or {}
	
	local pass1 = true
	local pass2 = true
	
	for i, comp in ipairs(lua_comps) do
		if ComponentGetValue2(comp, "script_source_file") == "data/scripts/buildings/boss_invincibility_frames3.lua" then
			pass1 = false
		end
		
		if ComponentGetValue2(comp, "script_source_file") == "data/scripts/buildings/boss_invincibility_frames4.lua" then
			pass2 = false
		end
	end
	
	if pass1 == true then
		EntityAddComponent2(entity_id, "LuaComponent", {
			script_source_file="data/scripts/buildings/boss_invincibility_frames3.lua",
			--script_damage_received="data/scripts/buildings/boss_invincibility_frames3.lua",
			--script_damage_about_to_be_received="data/scripts/buildings/boss_invincibility_frames3.lua",
			execute_every_n_frame=1
		})
	end
	
	if pass2 == true then
		EntityAddComponent2(entity_id, "LuaComponent", {
			script_source_file="data/scripts/buildings/boss_invincibility_frames4.lua",
			execute_every_n_frame=inviframes,
			remove_after_executed=true,
			execute_on_added=false
		})
	end
end