dofile_once("data/scripts/lib/utilities.lua")

local times_executed = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local time_now = GameGetRealWorldTimeSinceStarted()
local time_last_frame = GetValueNumber("old_time", time_now)
SetValueNumber("old_time", time_now)
local seconds_passed = time_now - (time_last_frame or 0)
local FPS = 1 / seconds_passed

-- Store the duration of low FPS
local low_fps_duration = GetValueNumber("low_fps_duration", 0)

if FPS < 5 then
    low_fps_duration = low_fps_duration + seconds_passed
else
    low_fps_duration = 0
end

SetValueNumber("low_fps_duration", low_fps_duration)

if low_fps_duration >= 1 then
    local projectiles = EntityGetInRadiusWithTag(x, y, 9999, "player_projectile")
    if (#projectiles > 0) then
        for i, projectile in ipairs(projectiles) do
            EntityApplyTransform(projectile, 66666666, 66666666)

            local all_comps = EntityGetAllComponents(projectile) or {}
            for i, comp in ipairs(all_comps) do
                EntityRemoveComponent(projectile, comp)
            end

            local lua_comp = EntityAddComponent2(projectile, "LuaComponent", {
                script_source_file = "data/scripts/animals/kill_entity.lua",
                execute_every_n_frame = 1,
                execute_on_added = false
            })
        end
    end
    -- GamePrint("Optimizing")
end

if times_executed > 200 then
	EntityRemoveComponent( entity_id, GetUpdatedComponentID() )
end
