dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

local projectiles = EntityGetInRadiusWithTag( x, y, 9999, "player_projectile" )
if ( #projectiles > 0 ) then
	for i,projectile in ipairs(projectiles) do
		-- if EntityHasTag( projectile, "undeletable" ) == false then
		
			local comp = EntityGetFirstComponent( projectile, "ProjectileComponent" )
			if( comp ~= nil ) then
				local d = ComponentGetValue2( comp, "damage" )
				if d > 0 then
					EntityInflictDamage( entity_id, d, "DAMAGE_PROJECTILE", "", "NONE", 0, 0, projectile, x, y )
				end
				
				local ed = ComponentObjectGetValue2( comp, "config_explosion", "damage" )
				if ed > 0 then
					EntityInflictDamage( entity_id, ed, "DAMAGE_EXPLOSION", "", "NONE", 0, 0, projectile, x, y )
				end
				
				local damage_fire = ComponentObjectGetValue2( comp, "damage_by_type", "fire" )
				if damage_fire > 0 then
					EntityInflictDamage( entity_id, damage_fire, "DAMAGE_FIRE", "", "NONE", 0, 0, projectile, x, y )
				end
				
				local damage_melee = ComponentObjectGetValue2( comp, "damage_by_type", "melee" )
				if damage_melee > 0 then
					EntityInflictDamage( entity_id, damage_melee, "DAMAGE_MELEE", "", "NONE", 0, 0, projectile, x, y )
				end
				
				local damage_drill = ComponentObjectGetValue2( comp, "damage_by_type", "drill" )
				if damage_drill > 0 then
					EntityInflictDamage( entity_id, damage_drill, "DAMAGE_DRILL", "", "NONE", 0, 0, projectile, x, y )
				end
				
				local damage_slice = ComponentObjectGetValue2( comp, "damage_by_type", "slice" )
				if damage_slice > 0 then
					EntityInflictDamage( entity_id, damage_slice, "DAMAGE_SLICE", "", "NONE", 0, 0, projectile, x, y )
				end
				
				local damage_radioactive = ComponentObjectGetValue2( comp, "damage_by_type", "radioactive" )
				if damage_radioactive > 0 then
					EntityInflictDamage( entity_id, damage_radioactive, "DAMAGE_RADIOACTIVE", "", "NONE", 0, 0, projectile, x, y )
				end
				
				local damage_explosion = ComponentObjectGetValue2( comp, "damage_by_type", "explosion" )
				if damage_explosion > 0 then
					EntityInflictDamage( entity_id, damage_explosion, "DAMAGE_EXPLOSION", "", "NONE", 0, 0, projectile, x, y )
				end
				
				local damage_electricity = ComponentObjectGetValue2( comp, "damage_by_type", "electricity" )
				if damage_electricity > 0 then
					EntityInflictDamage( entity_id, damage_electricity, "DAMAGE_ELECTRICITY", "", "NONE", 0, 0, projectile, x, y )
				end
				
				local damage_poison = ComponentObjectGetValue2( comp, "damage_by_type", "poison" )
				if damage_poison > 0 then
					EntityInflictDamage( entity_id, damage_poison, "DAMAGE_POISON", "", "NONE", 0, 0, projectile, x, y )
				end
				
				local damage_physics_hit = ComponentObjectGetValue2( comp, "damage_by_type", "physics_hit" )
				if damage_physics_hit > 0 then
					EntityInflictDamage( entity_id, damage_physics_hit, "DAMAGE_PHYSICS_HIT", "", "NONE", 0, 0, projectile, x, y )
				end
				
				local damage_ice = ComponentObjectGetValue2( comp, "damage_by_type", "ice" )
				if damage_ice > 0 then
					EntityInflictDamage( entity_id, damage_ice, "DAMAGE_ICE", "", "NONE", 0, 0, projectile, x, y )
				end
			end
			
			-- if is_within_hitbox(entity_id, projectile) == true then
				EntityApplyTransform(projectile, 66666666, 66666666)
				
				local all_comps = EntityGetAllComponents( projectile ) or {}
				for i, comp in ipairs(all_comps) do
					EntityRemoveComponent( projectile, comp )
				end
				
				local lua_comp = EntityAddComponent2(projectile, "LuaComponent", {
					script_source_file="data/scripts/animals/kill_entity.lua",
					execute_every_n_frame=1,
					execute_on_added=false
				})
			-- end
		-- end
	end
end