dofile_once( "data/scripts/lib/utilities.lua" )

local times_executed = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")

local entity_id = GetUpdatedEntityID()

local sprite_component = EntityGetFirstComponent(entity_id, "SpriteComponent")
local animation = ComponentGetValue2( sprite_component, "rect_animation")

local x, y, rot = EntityGetTransform( entity_id )

if ( times_executed % 4 ) == 0 then
	GamePlaySound("data/audio/Desktop/animals.bank", "animals/giant/attack_shoot", x, y)
	GamePlaySound("data/audio/Desktop/animals.bank", "collision/metalhollow", x, y)
	
	EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", false)
elseif ( times_executed % 4 ) == 2 then
	EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", true)
elseif ( times_executed % 4 ) == 3 then
	EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", false)
	GamePlayAnimation(entity_id,"smash",1,"open",1)
	
	--animation
	local sprite_comps = EntityGetComponent(entity_id, "SpriteComponent") or {}
	for i, comp in ipairs(sprite_comps) do

		ComponentSetValue2(comp, "rect_animation", "smash")
		ComponentSetValue2(comp, "next_rect_animation", "open")
		
	end
	
	EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)
	
	GamePlaySound("data/audio/Desktop/animals.bank", "explosions/barrel_oil", x, y)
	GamePlaySound("data/audio/Desktop/animals.bank", "explosions/cocktail", x, y)
	shoot_projectile( entity_id, "data/entities/projectiles/mechahub_explosion.xml", x, y - 100, 0, 0, false )
	shoot_projectile( entity_id, "data/entities/projectiles/mechahub_explosion.xml", x, y - 80, 0, 0, false )
	shoot_projectile( entity_id, "data/entities/projectiles/mechahub_explosion.xml", x, y - 60, 0, 0, false )
	shoot_projectile( entity_id, "data/entities/projectiles/mechahub_explosion.xml", x, y - 40, 0, 0, false )
	shoot_projectile( entity_id, "data/entities/projectiles/mechahub_explosion.xml", x, y - 20, 0, 0, false )
	shoot_projectile( entity_id, "data/entities/projectiles/mechahub_explosion.xml", x, y, 0, 0, false )
	shoot_projectile( entity_id, "data/entities/projectiles/mechahub_explosion.xml", x, y + 20, 0, 0, false )
end