dofile_once("data/scripts/lib/utilities.lua")
dofile_once( "data/scripts/game_helpers.lua" )

function collision_trigger( colliding_entity_id )
	local entity_id    = GetUpdatedEntityID()
	local x, y = EntityGetTransform( entity_id )
	
	dofile_once( "data/scripts/invisibility_check.lua" )
	
	if (
		EntityHasTag(colliding_entity_id, "projectile_player") == true or
		(
			(EntityHasTag(colliding_entity_id, "player_unit") == true and 
			EntityGetName(colliding_entity_id) == "DEBUG_NAME:player") or 
			EntityHasTag(colliding_entity_id, "polymorphed_player") == true
		) and 
		EntityGetFirstComponent(colliding_entity_id, "GenomeDataComponent") ~= nil and 
		EntityGetFirstComponent(colliding_entity_id, "GenomeDataComponent") > 0 and 
		EntityGetHerdRelation(entity_id, colliding_entity_id) < 40 and 
		is_invisible(colliding_entity_id) == false
	) then
	
		for i, child_id in ipairs(EntityGetAllChildren(entity_id) or {}) do
			
			if ( EntityGetName(child_id) == "eye" ) or ( EntityGetName(child_id) == "hand_spawner" ) then
			
				EntitySetComponentsWithTagEnabled(child_id, "enabled_in_world", true)
			end

		end
			
		GameTriggerMusicFadeOutAndDequeueAll( 3.0 )
		GameTriggerMusicEvent( "music/oneshot/dark_03", true, x, y )
		
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", false)
	end
end