dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
local player = EntityGetWithName( "DEBUG_NAME:player" )
local px, py = EntityGetTransform(player)

for i, child_id in ipairs(EntityGetAllChildren(entity_id) or {}) do

	local game_effect_component = EntityGetComponent(child_id, "GameEffectComponent")
	
	if ( game_effect_component ~= nil ) and ( #game_effect_component > 0 ) then
		for i, comp in ipairs(game_effect_component) do

			local effect = ComponentGetValue2( comp, "effect" )
			if effect == "POLYMORPH" then
				return
			end
		end
	end

end

if ( x == px ) and ( y == py ) then
	local function mergeTables(t1, t2)
		for i = 1, #t2 do
			table.insert(t1, t2[i])
		end
	end
	local _, _, day, hour, minute, second = GameGetDateAndTimeLocal()
	SetRandomSeed(day + hour + second, minute + second + entity_id)

	local enemy_list1 = PolymorphTableGet( false )

	enemy_list2 = { "data/entities/animals/acidmonster.xml",
		"data/entities/animals/alchaos.xml",
		"data/entities/animals/alien.xml",
		"data/entities/animals/alligator_temple.xml",
		"data/entities/animals/alligator_temple_small.xml",
		"data/entities/animals/angler.xml",
		"data/entities/animals/archer.xml",
		"data/entities/animals/axeman.xml",
		"data/entities/animals/babon.xml",
		"data/entities/animals/beanpodupine.xml",
		"data/entities/animals/bloodmage_greater.xml",
		"data/entities/animals/bloodmage_lesser.xml",
		"data/entities/animals/bloodmonster.xml",
		"data/entities/animals/bloodskull.xml",
		"data/entities/animals/bluemancer.xml",
		"data/entities/animals/book.xml",
		"data/entities/animals/bot.xml",
		"data/entities/animals/bouncer.xml",
		"data/entities/animals/camel.xml",
		"data/entities/animals/cargobot.xml",
		"data/entities/animals/landflower.xml",
		"data/entities/animals/chaoticpolyshooter.xml",
		"data/entities/animals/chest_great_boss.xml",
		"data/entities/animals/commander.xml",
		"data/entities/animals/conduit.xml",
		"data/entities/animals/copter.xml",
		"data/entities/animals/corrupt_alchemist.xml",
		"data/entities/animals/crawler.xml",
		"data/entities/animals/creeper.xml",
		"data/entities/animals/cyborg.xml",
		"data/entities/animals/darkghost2.xml",
		"data/entities/animals/flutterpede.xml",
		"data/entities/animals/cryogen.xml",
		"data/entities/animals/doom_bringer.xml",
		"data/entities/animals/drone_beam.xml",
		"data/entities/animals/drone_face2.xml",
		"data/entities/animals/drone_trail.xml",
		"data/entities/animals/drone2.xml",
		"data/entities/animals/earthmage.xml",
		"data/entities/animals/earthskull.xml",
		"data/entities/animals/eldari_big.xml",
		"data/entities/animals/electricskull.xml",
		"data/entities/animals/electrobot.xml",
		"data/entities/animals/draghoul.xml",
		"data/entities/animals/enigma.xml",
		"data/entities/animals/ent.xml",
		"data/entities/animals/eradicator.xml",
		"data/entities/animals/eye.xml",
		"data/entities/animals/eye_bat.xml",
		"data/entities/animals/eye_monster.xml",
		"data/entities/animals/eyeling.xml",
		"data/entities/animals/face_worm.xml",
		"data/entities/animals/fallen_alchemist.xml",
		"data/entities/animals/firemage_big.xml",
		"data/entities/animals/fish_angler2.xml",
		"data/entities/animals/flesh_monster.xml",
		"data/entities/animals/forgotten_alchemist.xml",
		"data/entities/animals/frog_bot.xml",
		"data/entities/animals/frog_tiny.xml",
		"data/entities/animals/fungus_spore.xml",
		"data/entities/animals/fungus_swamp2.xml",
		"data/entities/animals/gazer_laser.xml",
		"data/entities/animals/ghostling.xml",
		"data/entities/animals/ghuu.xml",
		"data/entities/animals/giant_alt.xml",
		"data/entities/animals/giant_energy.xml",
		"data/entities/animals/giant_old.xml",
		"data/entities/animals/giant_squid.xml",
		"data/entities/animals/gigashooter.xml",
		"data/entities/animals/gonha.xml",
		"data/entities/animals/goomonster.xml",
		"data/entities/animals/goomonster_giant.xml",
		"data/entities/animals/ground_terror.xml",
		"data/entities/animals/hazmat.xml",
		"data/entities/animals/head_statue_physics.xml",
		"data/entities/animals/hurpa.xml",
		"data/entities/animals/hybrid.xml",
		"data/entities/animals/icemage_big2.xml",
		"data/entities/animals/icemage2.xml",
		"data/entities/animals/icicle.xml",
		"data/entities/animals/icicle_king.xml",
		"data/entities/animals/igu.xml",
		"data/entities/animals/imp.xml",
		"data/entities/animals/invisiman.xml",
		"data/entities/animals/irtokki.xml",
		"data/entities/animals/jellyfish.xml",
		"data/entities/animals/jungle_worm.xml",
		"data/entities/animals/junkbot.xml",
		"data/entities/animals/knight.xml",
		"data/entities/animals/laserbot.xml",
		"data/entities/animals/lavashooter.xml",
		"data/entities/animals/lightling.xml",
		"data/entities/animals/llama.xml",
		"data/entities/animals/locust.xml",
		"data/entities/animals/long_ghost.xml",
		"data/entities/animals/longleg_big.xml",
		"data/entities/animals/lost_soul.xml",
		"data/entities/animals/lost_soul_big.xml",
		"data/entities/animals/lukki_blue.xml",
		"data/entities/animals/lukki_ominous.xml",
		"data/entities/animals/lukki_red.xml",
		"data/entities/animals/lukki_swamp2.xml",
		"data/entities/animals/lukki_weird.xml",
		"data/entities/animals/lukki_white.xml",
		"data/entities/animals/mammoth.xml",
		"data/entities/animals/mammoth_baby.xml",
		"data/entities/animals/manus.xml",
		"data/entities/animals/menace.xml",
		"data/entities/animals/menhir.xml",
		"data/entities/animals/minabomination.xml",
		"data/entities/animals/miner_alcohol.xml",
		"data/entities/animals/mirror_physics.xml",
		"data/entities/animals/moal.xml",
		"data/entities/animals/monkey.xml",
		"data/entities/animals/mutant2.xml",
		"data/entities/animals/nautilus.xml",
		"data/entities/animals/nightmare.xml",
		"data/entities/animals/nova.xml",
		"data/entities/animals/ooion.xml",
		"data/entities/animals/peasant.xml",
		"data/entities/animals/phan.xml",
		"data/entities/animals/phantom_trapper.xml",
		"data/entities/animals/phantom_boss.xml",
		"data/entities/animals/mutant_blob.xml",
		"data/entities/animals/polyp_gas.xml",
		"data/entities/animals/polyshooter.xml",
		"data/entities/animals/potionmaster2.xml",
		"data/entities/animals/radiobot.xml",
		"data/entities/animals/robot.xml",
		"data/entities/animals/sawbot.xml",
		"data/entities/animals/scarab.xml",
		"data/entities/animals/scavenger_alcohol.xml",
		"data/entities/animals/scavenger_civilian.xml",
		"data/entities/animals/scavenger_compressor.xml",
		"data/entities/animals/scavenger_compressor_robot.xml",
		"data/entities/animals/scavenger_electrocuter2.xml",
		"data/entities/animals/scavenger_gas.xml",
		"data/entities/animals/scavenger_gas_robot.xml",
		"data/entities/animals/scavenger_laser.xml",
		"data/entities/animals/scavenger_monster.xml",
		"data/entities/animals/scavenger_oiler.xml",
		"data/entities/animals/scavenger_plasma.xml",
		"data/entities/animals/scavenger_poison_immunity.xml",
		"data/entities/animals/scavenger_radiolava.xml",
		"data/entities/animals/scavenger_robot.xml",
		"data/entities/animals/scavenger_trigger.xml",
		"data/entities/animals/scavenger_turbo.xml",
		"data/entities/animals/scavenger_turbo_robot.xml",
		"data/entities/animals/scavenger_undercover.xml",
		"data/entities/animals/serpentor.xml",
		"data/entities/animals/shark.xml",
		"data/entities/animals/singularitor.xml",
		"data/entities/animals/skeleton.xml",
		"data/entities/animals/skullmage.xml",
		"data/entities/animals/skullspider.xml",
		"data/entities/animals/slime_ghoul.xml",
		"data/entities/animals/slime_roller.xml",
		"data/entities/animals/slime_turret.xml",
		"data/entities/animals/smoke_bot.xml",
		"data/entities/animals/sneeker.xml",
		"data/entities/animals/snowman.xml",
		"data/entities/animals/spider.xml",
		"data/entities/animals/spooky_ghost.xml",
		"data/entities/animals/sporeling.xml",
		"data/entities/animals/sporeling_large.xml",
		"data/entities/animals/sporeling_tiny.xml",
		"data/entities/animals/stalker.xml",
		"data/entities/animals/stone_crab.xml",
		"data/entities/animals/summoner.xml",
		"data/entities/animals/tank_fire2.xml",
		"data/entities/animals/thou.xml",
		"data/entities/animals/toxicmage_acid2.xml",
		"data/entities/animals/toxicmage2.xml",
		"data/entities/animals/twig.xml",
		"data/entities/animals/valkyrie2.xml",
		"data/entities/animals/void_mask2.xml",
		"data/entities/animals/wandmaster2.xml",
		"data/entities/animals/watermonster.xml",
		"data/entities/animals/welder.xml",
		"data/entities/animals/wizard_earthquake.xml",
		"data/entities/animals/wizard_madness.xml",
		"data/entities/animals/wizard_random.xml",
		"data/entities/animals/wizard_time.xml",
		"data/entities/animals/wizard_trip.xml",
		"data/entities/animals/wizard_twin.xml",
		"data/entities/animals/wizard_tiny.xml",
		"data/entities/animals/worm_fungal.xml",
		"data/entities/animals/worm_robot.xml",
		"data/entities/animals/worm_skull_old.xml",
		"data/entities/animals/wraith_speed.xml",
		"data/entities/animals/wraith_void2.xml",
		"data/entities/animals/zap_eel2.xml",
		"data/entities/animals/zombie_giant.xml",
		"data/entities/animals/zombie3.xml",
		"data/entities/animals/flopper_mother.xml",
		"data/entities/animals/oruai.xml",
		"data/entities/animals/jungle_flower.xml",
		"data/entities/animals/kiwiki.xml",
		"data/entities/animals/shield_physics.xml",
		"data/entities/animals/flopper_mother_giant.xml",
		"data/entities/animals/scorpio.xml",
		"data/entities/animals/mantis.xml",
		"data/entities/animals/chameleon.xml",
		"data/entities/animals/corpse_lily.xml",
		"data/entities/animals/fireworkman.xml",
		"data/entities/animals/mexxi.xml",
		"data/entities/animals/mummy.xml",
		"data/entities/animals/beehive.xml",
		"data/entities/animals/larva_crawler.xml",
		"data/entities/animals/crawler_bug.xml",
		"data/entities/animals/spider_crawler.xml",
		"data/entities/animals/fire_crawler.xml",
		"data/entities/animals/poly/worm_portal.xml",
		"data/entities/animals/manticore.xml",
		"data/entities/animals/bloodskull.xml",
		"data/entities/animals/gold_face_physics.xml",
		"data/entities/animals/bloodmage_enlightened.xml",
		"data/entities/animals/gazer_necromancer.xml",
		"data/entities/animals/bird.xml",
		"data/entities/animals/lemming.xml",
		"data/entities/animals/tank_propane.xml",
		"data/entities/animals/normal_bloom/bloom.xml",
		"data/entities/animals/vine_monster.xml",
		"data/entities/animals/puffer.xml",
		"data/entities/animals/yoyoer.xml",
		"data/entities/animals/lukki_saw.xml",
		"data/entities/animals/tentacle_monster2.xml",
		"data/entities/animals/hand2.xml",
		"data/entities/animals/head2.xml",
		"data/entities/animals/brain2.xml",
		"data/entities/animals/water_worm2.xml",
	}
	
	mergeTables(enemy_list1, enemy_list2)

	local random_index = Random(1, #enemy_list1)
	local creature = enemy_list1[random_index]

	local path = creature
	-- GamePrint(path)

	-- polycomp = GetGameEffectLoadTo( entity, "POLYMORPH", true )
	-- ComponentSetValue2( polycomp, "frames", 300 )
	-- ComponentSetValue2( polycomp, "polymorph_target", path )

	-- local child_id = EntityCreateNew()
	-- local child_id = EntityLoad( "data/entities/projectiles/morpher_template_projectile.xml", x, y )
	-- EntitySetTransform(child_id, x, y)
	-- EntityAddComponent2(child_id, "InheritTransformComponent", {} )
	local frames = 600
	local comp = EntityGetFirstComponentIncludingDisabled( entity_id, "GameEffectComponent" )
	if ( comp ~= nil ) then
		ComponentSetValue2(comp, "mSerializedData", "")
		local frames_val = ComponentGetValue2( comp, "frames" )
		if ( frames_val ~= nil ) and ( frames_val > 0 ) then
			frames = frames_val
			EntityAddComponent2(entity_id, "GameEffectComponent", {
				effect="POLYMORPH",
				frames=frames,
				disable_movement=false,
				polymorph_target=path
			} )
			EntityRemoveComponent( entity_id, comp )
		end
	end
end

-- EntityAddChild(entity, child_id)
