dofile_once( "data/scripts/lib/utilities.lua" )
dofile_once( "data/scripts/invisibility_check.lua" )

function split_string(input_str, delimiter)
	local result = {}
	for match in (input_str .. delimiter):gmatch("(.-)" .. delimiter) do
		table.insert(result, match)
	end
	return result
end

function encode_coords_to_store(coords)
    return table.concat(coords, ",")
end

local max_amount_to_store = 800

local entity_id = GetUpdatedEntityID()
local x, y, rot, sx = EntityGetTransform( entity_id )

local ssprite_comps = EntityGetComponent(entity_id, "SpriteComponent") or {}
local normal_player = false
for i, scomp in ipairs(ssprite_comps) do

	if ComponentGetValue2(scomp, "image_file") == "data/enemies_gfx/player.xml" then
		rect_animation = ComponentGetValue2(scomp, "rect_animation")
		normal_player = true
	end
end

if normal_player == false then
	local first_sprite_component = EntityGetFirstComponentIncludingDisabled(entity_id, "SpriteComponent", "character")
	if ( first_sprite_component ~= nil ) and ( first_sprite_component > 0 ) then
		rect_animation = ComponentGetValue2(first_sprite_component, "rect_animation")
	else
		rect_animation = "fly_idle"
	end
end

local var_store = get_variable_storage_component( entity_id, "position_tracker_evil" )
if ( var_store ~= nil ) and ( var_store > 0 ) and ( is_invisible(entity_id) == false ) then
	local val = ComponentGetValue2(var_store, "value_string")
	local stored_coords = split_string(val, ",")
	table.insert(stored_coords, tostring(x))
	table.insert(stored_coords, tostring(y))
	table.insert(stored_coords, tostring(sx))
	table.insert(stored_coords, rect_animation)

	if ( #stored_coords > max_amount_to_store ) and ( #stored_coords > 4 ) then
	  table.remove(stored_coords, 1)
	  table.remove(stored_coords, 1)
	  table.remove(stored_coords, 1)
	  table.remove(stored_coords, 1)
	end

	local encode_string = encode_coords_to_store(stored_coords)
	ComponentSetValue2(var_store, "value_string", encode_string )
end
