dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/new_enemies/files/resize_entity_lib/shrink_lib.lua")

local entity_id = GetUpdatedEntityID()
local parent_id = EntityGetParent(entity_id)

local count = 0
for i, child_id in ipairs(EntityGetAllChildren(parent_id) or {}) do
	
	local game_effect_component = EntityGetFirstComponentIncludingDisabled(child_id, "GameEffectComponent")
	
	if ( game_effect_component ~= nil ) and ( game_effect_component > 0 ) then
		
		local id = ComponentGetValue2(game_effect_component, "custom_effect_id")
		if id == "NEW_ENEMIES_SHRINK" then
			count = count + 1
			last_child = child_id
		end
	end

end

if count > 1 then
	EntityKill(last_child)
end
	
local entity_name = EntityGetName(parent_id)
local x, y = EntityGetTransform( parent_id )
local value = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")

-- local game_effect_component = EntityGetFirstComponentIncludingDisabled(entity_id, "GameEffectComponent")
-- ComponentSetValue2(game_effect_component, "mCooldown", value)

function toggle_all_emissive(bool)

	local all_entities = EntityGetInRadius( x, y, 9999999999999999 )

	--Turn off all emissive sprites D:
	for i, entity in ipairs(all_entities) do
	
		local ex, ey = EntityGetTransform( entity )

		local sprite_comps = EntityGetComponent(entity, "SpriteComponent") or {}
		
		for i, comp in ipairs(sprite_comps) do
		
			if bool == true then
			
				local cx, cy = GameGetCameraPos()
			
				
				if (ex < cx + 256) or
					(ex > cx - 256) or
					(ey > cy - 150) or
					(ey < cy + 150) then

					
				
					if ComponentGetValue2(comp, "emissive") == true then
					
						ComponentSetValue2(comp, "emissive", false)
						ComponentSetValue2(comp, "z_index", -50)
						EntityRefreshSprite(entity, comp)
						
						if ComponentHasTag( comp, "has_emissive_sprite" ) == false then
							ComponentAddTag( comp, "has_emissive_sprite" )
						end
					
					end
				else
					if ComponentHasTag( comp, "has_emissive_sprite" ) == true then
					
						if ComponentGetValue2(comp, "emissive") == false then
						
							ComponentSetValue2(comp, "emissive", true)
							EntityRefreshSprite(entity, comp)
							
						end
					end
				end
				
			elseif bool == false then
			
				if ComponentHasTag( comp, "has_emissive_sprite" ) == true then
				
					if ComponentGetValue2(comp, "emissive") == false then
					
						ComponentSetValue2(comp, "emissive", true)
						EntityRefreshSprite(entity, comp)
						
					end
				end
				
			end
		end
		
		local sprite_particle_comps = EntityGetComponent(entity, "SpriteParticleEmitterComponent") or {}
		
		for i, comp in ipairs(sprite_particle_comps) do
		
			if bool == true then
			
				local cx, cy = GameGetCameraPos()
				
				if (ex < cx + 256) or
					(ex > cx - 256) or
					(ey > cy - 150) or
					(ey < cy + 150) then
				
					if ComponentGetValue2(comp, "emissive") == true then
					
						ComponentSetValue2(comp, "emissive", false)
						ComponentSetValue2(comp, "z_index", -50)
						-- EntityRefreshSprite(entity, comp)
						if ComponentHasTag( comp, "has_emissive_sprite" ) == false then
							ComponentAddTag( comp, "has_emissive_sprite" )
						end
					
					end
				else
					if ComponentHasTag( comp, "has_emissive_sprite" ) == true then
					
						if ComponentGetValue2(comp, "emissive") == false then
							ComponentSetValue2(comp, "emissive", true)					
						end
					end
				end
				
			elseif bool == false then
			
				if ComponentHasTag( comp, "has_emissive_sprite" ) == true then
				
					if ComponentGetValue2(comp, "emissive") == false then
						ComponentSetValue2(comp, "emissive", true)	
					end
				end
			end
		end
		
		function remove_emissive_from_explosion(entity_value, component_name)
			local val_comps = EntityGetComponent(entity_value, component_name) or {}
			
			for i, comp in ipairs(val_comps) do
			
				if bool == true then
				
					local cx, cy = GameGetCameraPos()
					
					if (ex < cx + 256) or
						(ex > cx - 256) or
						(ey > cy - 150) or
						(ey < cy + 150) then
					
						if ComponentObjectGetValue2( comp, "config_explosion", "explosion_sprite_emissive" ) == true then
						
							ComponentObjectSetValue2( comp, "config_explosion", "explosion_sprite_emissive", false )
							-- EntityRefreshSprite(entity, comp)
							if ComponentHasTag( comp, "has_emissive_sprite" ) == false then
								ComponentAddTag( comp, "has_emissive_sprite" )
							end
						
						end
					else
						if ComponentHasTag( comp, "has_emissive_sprite" ) == true then
						
							if ComponentObjectGetValue2( comp, "config_explosion", "explosion_sprite_emissive" ) == false then
							
								ComponentObjectSetValue2( comp, "config_explosion", "explosion_sprite_emissive", true )
								
							end
						end
					end
					
				elseif bool == false then
				
					if ComponentHasTag( comp, "has_emissive_sprite" ) == true then
					
						if ComponentObjectGetValue2( comp, "config_explosion", "explosion_sprite_emissive" ) == false then
							ComponentObjectSetValue2( comp, "config_explosion", "explosion_sprite_emissive", true )	
						end
					end
				end
			end
		end
		
		remove_emissive_from_explosion(entity, "ProjectileComponent")
		remove_emissive_from_explosion(entity, "LightningComponent")
		-- remove_emissive_from_explosion(entity, "AnimalAIComponent")
		remove_emissive_from_explosion(entity, "ExplosionComponent")
		remove_emissive_from_explosion(entity, "ExplodeOnDamageComponent")
	end
end

-- ComponentSetValue2(sprite_component, "has_special_scale", false)
-- mCounter

local game_effect_component = EntityGetFirstComponentIncludingDisabled(entity_id, "GameEffectComponent")

if ( game_effect_component ~= nil ) and ( game_effect_component > 0 ) then
	ComponentSetValue2(game_effect_component, "frames", 2202 - value)
end

if value > 2202 then
	children = EntityGetAllChildren(parent_id)
	for _, child in ipairs(children) do
		local entity_name = EntityGetName(child)
		if entity_name == "inventory_quick" then
			local children2 = EntityGetAllChildren(child)
			for _, this_entity in ipairs(children2) do

				local sprite_components = EntityGetComponentIncludingDisabled(this_entity, "SpriteComponent")
				if sprite_components ~= nil then
					for _, sprite_component in ipairs(sprite_components) do
						ComponentSetValue2(sprite_component, "has_special_scale", false)
						EntityRefreshSprite(this_entity, sprite_component)
					end
				end
			end
		end
	end
	EntityKill(entity_id)
elseif value == 2202 then
	toggle_all_emissive(false)
elseif value == 2200 then
	if entity_name == "DEBUG_NAME:player" then
		revert_scalable_player(parent_id)
		
		scale = 1
		children = EntityGetAllChildren(parent_id)
		for _, child in ipairs(children) do
			local entity_name = EntityGetName(child)
			if entity_name == "inventory_quick" then
				local children2 = EntityGetAllChildren(child)
				for _, this_entity in ipairs(children2) do
					function entity_is_wand(entity_id)
						local ability_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AbilityComponent")
						return ComponentGetValue2(ability_component, "use_gun_script") == true
					end
					if entity_is_wand(this_entity) then
						scale_wand(this_entity, scale)
						local sprite_components = EntityGetComponentIncludingDisabled(this_entity, "SpriteComponent")
						if sprite_components ~= nil then
							for _, sprite_component in ipairs(sprite_components) do
								ComponentSetValue2(sprite_component, "has_special_scale", false)
								EntityRefreshSprite(this_entity, sprite_component)
							end
						end
						local var_comp = get_variable_storage_component( this_entity, "set_up_original_scale_adjuster" )
						if ( var_comp ~= nil ) and ( var_comp > 0 ) then
							EntityRemoveComponent(this_entity, var_comp)
						end
					end
					
					if EntityHasTag(this_entity, "item_pickup") or EntityHasTag(this_entity, "item_physics") then
						local sprite_components = EntityGetComponentIncludingDisabled(this_entity, "SpriteComponent")
						if sprite_components ~= nil then
							for _, sprite_component in ipairs(sprite_components) do
								ComponentSetValue2(sprite_component, "has_special_scale", false)
								EntityRefreshSprite(this_entity, sprite_component)
							end
						end
						--handle any particle effects on the held item
						scale_particle_effects_on_entity(this_entity, scale)
						local var_comp = get_variable_storage_component( this_entity, "set_up_original_scale_adjuster" )
						if ( var_comp ~= nil ) and ( var_comp > 0 ) then
							EntityRemoveComponent(this_entity, var_comp)
						end
					end
				end
			end
		end
	end
	
elseif value > 1600 then
	update_entity_scale_from_juice(entity_id, "grow")
	if entity_name == "DEBUG_NAME:player" then
		toggle_all_emissive(true)
	end
elseif value > 20 then
	update_entity_scale_from_juice(entity_id, "shrink")
	if entity_name == "DEBUG_NAME:player" then
		toggle_all_emissive(true)
	end
elseif value == 1 then

	--Setting up the player to shrink
	local entity_name = EntityGetName(parent_id)

	if entity_name == "DEBUG_NAME:player" then
		update_entity_scale_from_juice(entity_id, "restore_original")
		local children = EntityGetAllChildren(parent_id)
		for _, child in ipairs(children) do
			--kill the arm hotspot tracker
			if EntityHasTag(child, "arm_hotspot_tracker") then
				EntityKill(child)
			end

			--kill the dummy arm
			if EntityHasTag(child, "dummy_arm") then
				local sprite_comp = EntityGetFirstComponentIncludingDisabled(child, "SpriteComponent")
				file = ComponentGetValue2(sprite_comp, "image_file")
				EntityKill(child)
			end

			--set player component values back to their original defaults and then delete the scalable_player entity
			if EntityGetName(child) == "scalable_player" then
				local original_values_string = get_variable_component(child, 'beeg_smol.original_values', "value_string")
				local original_values = string_to_table(original_values_string)

				local character_data_component = EntityGetFirstComponentIncludingDisabled(parent_id, "CharacterDataComponent")
				local character_platforming_component = EntityGetFirstComponentIncludingDisabled(parent_id, "CharacterPlatformingComponent")
				local platform_shooter_player_component = EntityGetFirstComponentIncludingDisabled(parent_id, "PlatformShooterPlayerComponent")
				local damage_model_component = EntityGetFirstComponentIncludingDisabled(parent_id, "DamageModelComponent")
				local kick_component = EntityGetFirstComponentIncludingDisabled(parent_id, "KickComponent")
				local hitbox_component = EntityGetFirstComponentIncludingDisabled(parent_id, "HitboxComponent")

				ComponentSetValue2(character_data_component, "buoyancy_check_offset_y", tonumber(original_values.buoyancy_check_offset_y))
				ComponentSetValue2(character_data_component, "climb_over_y", tonumber(original_values.climb_over_y))
				ComponentSetValue2(character_data_component, "check_collision_max_size_x", tonumber(original_values.check_collision_max_size_x))
				ComponentSetValue2(character_data_component, "check_collision_max_size_y", tonumber(original_values.check_collision_max_size_y))
				ComponentSetValue2(character_data_component, "collision_aabb_min_x", tonumber(original_values.collision_aabb_min_x))
				ComponentSetValue2(character_data_component, "collision_aabb_max_x", tonumber(original_values.collision_aabb_max_x))
				ComponentSetValue2(character_data_component, "collision_aabb_min_y", tonumber(original_values.collision_aabb_min_y))
				ComponentSetValue2(character_data_component, "collision_aabb_max_y", tonumber(original_values.collision_aabb_max_y))
				ComponentSetValue2(character_data_component, "eff_hg_size_x", tonumber(original_values.eff_hg_size_x))
				ComponentSetValue2(character_data_component, "eff_hg_size_y", tonumber(original_values.eff_hg_size_y))
				ComponentSetValue2(character_data_component, "eff_hg_damage_min", tonumber(original_values.eff_hg_damage_min))
				ComponentSetValue2(character_data_component, "eff_hg_damage_max", tonumber(original_values.eff_hg_damage_max))

				ComponentSetValue2(character_platforming_component, "fly_speed_mult", tonumber(original_values.fly_speed_mult))
				ComponentSetValue2(character_platforming_component, "velocity_min_x", tonumber(original_values.velocity_min_x))
				ComponentSetValue2(character_platforming_component, "velocity_max_x", tonumber(original_values.velocity_max_x))
				
				ComponentSetValue2(platform_shooter_player_component, "eating_area_min", tonumber(original_values.eating_area_min_x), tonumber(original_values.eating_area_min_y))
				ComponentSetValue2(platform_shooter_player_component, "eating_area_max", tonumber(original_values.eating_area_max_x), tonumber(original_values.eating_area_max_y))
				ComponentSetValue2(platform_shooter_player_component, "eating_cells_per_frame", tonumber(original_values.eating_cells_per_frame))


				ComponentObjectSetValue2(damage_model_component, "damage_multipliers", "curse", tonumber(original_values.damage_multiplier_curse))
				ComponentObjectSetValue2(damage_model_component, "damage_multipliers", "drill", tonumber(original_values.damage_multiplier_drill))
				ComponentObjectSetValue2(damage_model_component, "damage_multipliers", "electricity", tonumber(original_values.damage_multiplier_electricity))
				ComponentObjectSetValue2(damage_model_component, "damage_multipliers", "explosion", tonumber(original_values.damage_multiplier_explosion))
				ComponentObjectSetValue2(damage_model_component, "damage_multipliers", "fire", tonumber(original_values.damage_multiplier_fire))
				ComponentObjectSetValue2(damage_model_component, "damage_multipliers", "healing", tonumber(original_values.damage_multiplier_healing))
				ComponentObjectSetValue2(damage_model_component, "damage_multipliers", "ice", tonumber(original_values.damage_multiplier_ice))
				ComponentObjectSetValue2(damage_model_component, "damage_multipliers", "melee", tonumber(original_values.damage_multiplier_melee))
				ComponentObjectSetValue2(damage_model_component, "damage_multipliers", "overeating", tonumber(original_values.damage_multiplier_overeating))
				ComponentObjectSetValue2(damage_model_component, "damage_multipliers", "poison", tonumber(original_values.damage_multiplier_poison))
				ComponentObjectSetValue2(damage_model_component, "damage_multipliers", "projectile", tonumber(original_values.damage_multiplier_projectile))
				ComponentObjectSetValue2(damage_model_component, "damage_multipliers", "radioactive", tonumber(original_values.damage_multiplier_radioactive))
				ComponentObjectSetValue2(damage_model_component, "damage_multipliers", "slice", tonumber(original_values.damage_multiplier_slice))

				ComponentSetValue2(kick_component, "kick_radius", tonumber(original_values.kick_radius))

				ComponentSetValue2(hitbox_component, "aabb_min_x", tonumber(original_values.hitbox_aabb_min_x))
				ComponentSetValue2(hitbox_component, "aabb_max_x", tonumber(original_values.hitbox_aabb_max_x))
				ComponentSetValue2(hitbox_component, "aabb_min_y", tonumber(original_values.hitbox_aabb_min_y))
				ComponentSetValue2(hitbox_component, "aabb_max_y", tonumber(original_values.hitbox_aabb_max_y))
				EntityKill(child)
			end
		end
		local scalable_player = EntityLoad("mods/new_enemies/files/resize_entity_lib/scalable_player.xml", x, y)
		EntityAddChild(parent_id, scalable_player)
		
	else
		--setting up the enemy to shrink
        local enemy_id = parent_id
        local has_scalable_tag = EntityHasTag(enemy_id, "scalable_initialized")
		
        --local is_valid_enemy_for_scaling = is_valid_enemy_for_scaling(enemy_id)
        if has_scalable_tag ~= true then
            local has_prop_tag = EntityHasTag(enemy_id, "prop")
            local has_player_tag = EntityHasTag(enemy_id, "player_unit")
            --local has_boss_centipede_tag = EntityHasTag(enemy_id, "boss_centipede")
            if not has_prop_tag and not has_player_tag --[[and not has_boss_centipede_tag]] then
                local scalable_enemy = EntityLoad("mods/new_enemies/files/resize_entity_lib/scalable_enemy.xml", 0, 0)
                EntityAddChild(enemy_id, scalable_enemy)
            else
                --not what we're looking for but tag it so it doesn't come up again
                EntityAddTag(enemy_id, "scalable_initialized")
            end
        end
		
	end
	
end