dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/new_enemies/files/resize_entity_lib/shrink_lib.lua")

local entity_id = GetUpdatedEntityID()
local parent_id = EntityGetParent(entity_id)
local entity_name = EntityGetName(parent_id)
local x, y = EntityGetTransform( parent_id )
local value = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")
-- local game_effect_component = EntityGetFirstComponentIncludingDisabled(entity_id, "GameEffectComponent")
-- ComponentSetValue2(game_effect_component, "mCooldown", value)

function toggle_all_emissive(bool)

	local all_entities = EntityGetInRadius( x, y, 9999999999999999 )

	--Turn off all emissive sprites D:
	for i, entity in ipairs(all_entities) do
	
		local ex, ey = EntityGetTransform( entity )

		local sprite_comps = EntityGetComponent(entity, "SpriteComponent") or {}
		
		for i, comp in ipairs(sprite_comps) do
		
			if bool == true then
			
				local cx, cy = GameGetCameraPos()
			
				
				if (ex < cx + 256) or
					(ex > cx - 256) or
					(ey > cy - 150) or
					(ey < cy + 150) then

					
				
					if ComponentGetValue2(comp, "emissive") == true then
					
						ComponentSetValue2(comp, "emissive", false)
						ComponentSetValue2(comp, "z_index", -50)
						EntityRefreshSprite(entity, comp)
						
						if ComponentHasTag( comp, "has_emissive_sprite" ) == false then
							ComponentAddTag( comp, "has_emissive_sprite" )
						end
					
					end
				else
					if ComponentHasTag( comp, "has_emissive_sprite" ) == true then
					
						if ComponentGetValue2(comp, "emissive") == false then
						
							ComponentSetValue2(comp, "emissive", true)
							EntityRefreshSprite(entity, comp)
							
						end
					end
				end
				
			elseif bool == false then
			
				if ComponentHasTag( comp, "has_emissive_sprite" ) == true then
				
					if ComponentGetValue2(comp, "emissive") == false then
					
						ComponentSetValue2(comp, "emissive", true)
						EntityRefreshSprite(entity, comp)
						
					end
				end
				
			end
		end
		
		local sprite_particle_comps = EntityGetComponent(entity, "SpriteParticleEmitterComponent") or {}
		
		for i, comp in ipairs(sprite_particle_comps) do
		
			if bool == true then
			
				local cx, cy = GameGetCameraPos()
				
				if (ex < cx + 256) or
					(ex > cx - 256) or
					(ey > cy - 150) or
					(ey < cy + 150) then
				
					if ComponentGetValue2(comp, "emissive") == true then
					
						ComponentSetValue2(comp, "emissive", false)
						ComponentSetValue2(comp, "z_index", -50)
						-- EntityRefreshSprite(entity, comp)
						if ComponentHasTag( comp, "has_emissive_sprite" ) == false then
							ComponentAddTag( comp, "has_emissive_sprite" )
						end
					
					end
				else
					if ComponentHasTag( comp, "has_emissive_sprite" ) == true then
					
						if ComponentGetValue2(comp, "emissive") == false then
							ComponentSetValue2(comp, "emissive", true)					
						end
					end
				end
				
			elseif bool == false then
			
				if ComponentHasTag( comp, "has_emissive_sprite" ) == true then
				
					if ComponentGetValue2(comp, "emissive") == false then
						ComponentSetValue2(comp, "emissive", true)	
					end
				end
			end
		end
		
		function remove_emissive_from_explosion(entity_value, component_name)
			local val_comps = EntityGetComponent(entity_value, component_name) or {}
			
			for i, comp in ipairs(val_comps) do
			
				if bool == true then
				
					local cx, cy = GameGetCameraPos()
					
					if (ex < cx + 256) or
						(ex > cx - 256) or
						(ey > cy - 150) or
						(ey < cy + 150) then
					
						if ComponentObjectGetValue2( comp, "config_explosion", "explosion_sprite_emissive" ) == true then
						
							ComponentObjectSetValue2( comp, "config_explosion", "explosion_sprite_emissive", false )
							-- EntityRefreshSprite(entity, comp)
							if ComponentHasTag( comp, "has_emissive_sprite" ) == false then
								ComponentAddTag( comp, "has_emissive_sprite" )
							end
						
						end
					else
						if ComponentHasTag( comp, "has_emissive_sprite" ) == true then
						
							if ComponentObjectGetValue2( comp, "config_explosion", "explosion_sprite_emissive" ) == false then
							
								ComponentObjectSetValue2( comp, "config_explosion", "explosion_sprite_emissive", true )
								
							end
						end
					end
					
				elseif bool == false then
				
					if ComponentHasTag( comp, "has_emissive_sprite" ) == true then
					
						if ComponentObjectGetValue2( comp, "config_explosion", "explosion_sprite_emissive" ) == false then
							ComponentObjectSetValue2( comp, "config_explosion", "explosion_sprite_emissive", true )	
						end
					end
				end
			end
		end
		
		remove_emissive_from_explosion(entity, "ProjectileComponent")
		remove_emissive_from_explosion(entity, "LightningComponent")
		-- remove_emissive_from_explosion(entity, "AnimalAIComponent")
		remove_emissive_from_explosion(entity, "ExplosionComponent")
		remove_emissive_from_explosion(entity, "ExplodeOnDamageComponent")
	end
end

if value > 2202 then
	children = EntityGetAllChildren(parent_id)
	for _, child in ipairs(children) do
		local entity_name = EntityGetName(child)
		if entity_name == "inventory_quick" then
			local children2 = EntityGetAllChildren(child)
			for _, this_entity in ipairs(children2) do

				local sprite_components = EntityGetComponentIncludingDisabled(this_entity, "SpriteComponent")
				if sprite_components ~= nil then
					for _, sprite_component in ipairs(sprite_components) do
						ComponentSetValue2(sprite_component, "has_special_scale", false)
						EntityRefreshSprite(this_entity, sprite_component)
					end
				end
			end
		end
	end
	EntityKill(entity_id)
elseif value == 2202 then
	toggle_all_emissive(false)
elseif value == 2200 then
	if entity_name == "DEBUG_NAME:player" then
		revert_scalable_player(parent_id)
		
		scale = 1
		children = EntityGetAllChildren(parent_id)
		for _, child in ipairs(children) do
			local entity_name = EntityGetName(child)
			if entity_name == "inventory_quick" then
				local children2 = EntityGetAllChildren(child)
				for _, this_entity in ipairs(children2) do
					function entity_is_wand(entity_id)
						local ability_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AbilityComponent")
						return ComponentGetValue2(ability_component, "use_gun_script") == true
					end
					if entity_is_wand(this_entity) then
						scale_wand(this_entity, scale)
						local sprite_components = EntityGetComponentIncludingDisabled(this_entity, "SpriteComponent")
						if sprite_components ~= nil then
							for _, sprite_component in ipairs(sprite_components) do
								ComponentSetValue2(sprite_component, "has_special_scale", false)
								EntityRefreshSprite(this_entity, sprite_component)
							end
						end
						local var_comp = get_variable_storage_component( this_entity, "set_up_original_scale_adjuster" )
						if ( var_comp ~= nil ) and ( var_comp > 0 ) then
							EntityRemoveComponent(this_entity, var_comp)
						end
					end
					
					if EntityHasTag(this_entity, "item_pickup") or EntityHasTag(this_entity, "item_physics") then
						local sprite_components = EntityGetComponentIncludingDisabled(this_entity, "SpriteComponent")
						if sprite_components ~= nil then
							for _, sprite_component in ipairs(sprite_components) do
								ComponentSetValue2(sprite_component, "has_special_scale", false)
								EntityRefreshSprite(this_entity, sprite_component)
							end
						end
						--handle any particle effects on the held item
						scale_particle_effects_on_entity(this_entity, scale)
						local var_comp = get_variable_storage_component( this_entity, "set_up_original_scale_adjuster" )
						if ( var_comp ~= nil ) and ( var_comp > 0 ) then
							EntityRemoveComponent(this_entity, var_comp)
						end
					end
				end
			end
		end
	end
	
elseif value > 1600 then
	update_entity_scale_from_juice(entity_id, "grow")
	if entity_name == "DEBUG_NAME:player" then
		toggle_all_emissive(true)
	end
elseif value > 20 then
	update_entity_scale_from_juice(entity_id, "shrink")
	if entity_name == "DEBUG_NAME:player" then
		toggle_all_emissive(true)
	end
elseif value == 1 then

	--Setting up the player to shrink
	local entity_name = EntityGetName(parent_id)

	if entity_name == "DEBUG_NAME:player" then

		local scalable_player = EntityLoad("mods/new_enemies/files/resize_entity_lib/scalable_player.xml", x, y)
		EntityAddChild(parent_id, scalable_player)
		
	else
		--setting up the enemy to shrink
        local enemy_id = parent_id
        local has_scalable_tag = EntityHasTag(enemy_id, "scalable_initialized")
		
        --local is_valid_enemy_for_scaling = is_valid_enemy_for_scaling(enemy_id)
        if has_scalable_tag ~= true then
            local has_prop_tag = EntityHasTag(enemy_id, "prop")
            local has_player_tag = EntityHasTag(enemy_id, "player_unit")
            --local has_boss_centipede_tag = EntityHasTag(enemy_id, "boss_centipede")
            if not has_prop_tag and not has_player_tag --[[and not has_boss_centipede_tag]] then
                local scalable_enemy = EntityLoad("mods/new_enemies/files/resize_entity_lib/scalable_enemy.xml", 0, 0)
                EntityAddChild(enemy_id, scalable_enemy)
            else
                --not what we're looking for but tag it so it doesn't come up again
                EntityAddTag(enemy_id, "scalable_initialized")
            end
        end
		
	end
	
end