dofile_once( "data/scripts/lib/utilities.lua" )

function add_status_effect( game_effect_entity, icon_file, name, description, above_head )
    if game_effect_entity ~= nil then
        display_hud = true
        if(above_head)then
            display_hud = false
        end
        EntityAddComponent2( game_effect_entity, "UIIconComponent",
        {
            name = name,
            description = description,
            icon_sprite_file = icon_file,
            display_above_head = above_head,
            display_in_hud = display_hud,
            is_perk = false,
        })
    end
end

local entity_id = GetUpdatedEntityID()

add_status_effect( entity_id, "data/ui_gfx/status_indicators/trip.png", "$trip_status_name", "$trip_status_desc", false )

local parent_id = EntityGetParent(entity_id)

if ( EntityGetName( parent_id ) == "DEBUG_NAME:player" ) or ( EntityHasTag( parent_id, "polymorphed_player" ) == true ) then
else
	local game_effect_components = EntityGetComponentIncludingDisabled(entity_id, "GameEffectComponent")
	
	for i, game_effect_component in ipairs(game_effect_components or {}) do
	
		if ( ComponentGetValue2(game_effect_component, "custom_effect_id") == "TRIP_00" ) then 
			EntityRemoveComponent( entity_id, game_effect_component )
		end
		
	end
	
	local lua_components = EntityGetComponentIncludingDisabled(entity_id, "LuaComponent")
	
	for i, lua_component in ipairs(lua_components or {}) do
	
		if ( ComponentGetValue2(lua_component, "script_source_file") == "data/scripts/misc/trip_no_shift.lua" ) then 
			EntityRemoveComponent( entity_id, lua_component )
		end
		
	end
end
