dofile_once("data/scripts/lib/utilities.lua")

local times_executed = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")
local entity_id = GetUpdatedEntityID()
local x, y, rot = EntityGetTransform(entity_id)

SetRandomSeed(GameGetFrameNum(), x + y + entity_id)

local parent_id = EntityGetParent(entity_id)
local px, py = EntityGetTransform(parent_id)

local spiral_speed = 0.7  -- Speed at which the spiral expands
local angle_speed = 0.03  -- Speed of rotation

local random_val = Random(0, 2 * math.pi)

local initial_angle = GetValueNumber("initial_angle", 0)
local initial_x = GetValueNumber("initial_x", px)
local initial_y = GetValueNumber("initial_y", py)

-- Store initial random angle in the entity's storage
if times_executed == 1 then
    initial_angle = Random(0, 2 * math.pi)
	SetValueNumber("initial_angle", initial_angle)
	SetValueNumber("initial_x", px)
	SetValueNumber("initial_y", py)
end

edit_component(entity_id, "VelocityComponent", function(comp2, vars)
    local frame_num = GameGetFrameNum()
    local angle = initial_angle + angle_speed * times_executed  -- Angle increases over time with initial offset
    local radius = spiral_speed * times_executed  -- Radius increases over time

    local vel_x = math.cos(angle) * radius
    local vel_y = math.sin(angle) * radius

    ComponentSetValueVector2(comp2, "mVelocity", vel_x, vel_y)
	
	local x2 = (px - initial_x)
	local y2 = (py - initial_y)
	
	local child = EntityGetAllChildren(entity_id)[1]

	EntitySetTransform(child, x + x2, y + y2, angle)
end)

