
--Just in case blob_projectile_shooter_id hasn't had a chance to run yet, we do it here. 
-- dofile( "mods/new_enemies/data/scripts/projectiles/blob_projectile_shooter_id.lua" )

-- local mWhoShot_status_effect_data_component = EntityGetFirstComponentIncludingDisabled(mWhoShot, "StatusEffectDataComponent")

-- spawned_entity = EntityLoad( "data/entities/animals/mutant_blob_ceiling.xml", x, y + 4 )

-- local who_shot_damage_model_component = EntityGetFirstComponentIncludingDisabled(mWhoShot, "DamageModelComponent")
-- local who_spawned_damage_model_component = EntityGetFirstComponentIncludingDisabled( spawned_entity, "DamageModelComponent" )
-- -- local who_spawned_status_effect_data_component = EntityGetFirstComponentIncludingDisabled( spawned_entity, "StatusEffectDataComponent" )

-- -- EntitySetComponentIsEnabled( spawned_entity, who_spawned_status_effect_data_component, true )
-- if ( who_shot_damage_model_component ~= nil ) and ( who_shot_damage_model_component > 0 ) then
	-- hp = ComponentGetValue2(who_shot_damage_model_component, "hp")
	-- max_hp = ComponentGetValue2(who_shot_damage_model_component, "max_hp")
-- end

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
local parent_id = EntityGetParent( entity_id )

if ( parent_id ~= nil ) and ( parent_id > 0 ) then
	EntitySetTransform( parent_id, x, y + 4)

	EntitySetComponentsWithTagEnabled(parent_id, "enabled_in_hand", true)
	-- EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", false)

	local sprite_comps = EntityGetComponent(parent_id, "SpriteComponent") or {}
	for i, comp in ipairs(sprite_comps) do
		EntityRefreshSprite( parent_id, comp )
	end

	local animal_ai_component = EntityGetFirstComponentIncludingDisabled(parent_id, "AnimalAIComponent")
	if ( animal_ai_component ~= nil ) and ( animal_ai_component > 0 ) then
		ComponentSetValue2( animal_ai_component, "attack_ranged_max_distance", 200 )
		ComponentSetValue2( animal_ai_component, "attack_melee_max_distance", 0 )
		ComponentSetValue2( animal_ai_component, "attack_dash_distance", 0 )
	end

	local character_data_component = EntityGetFirstComponentIncludingDisabled(parent_id, "CharacterDataComponent")
	if ( character_data_component ~= nil ) and ( character_data_component > 0 ) then
		ComponentSetValue2( character_data_component, "collision_aabb_min_y", -4.5 )
		ComponentSetValue2( character_data_component, "collision_aabb_max_y", 4.5 )
		ComponentSetValue2( character_data_component, "mVelocity", 0, 0 )
	end

	local velocity_component = EntityGetFirstComponentIncludingDisabled(parent_id, "VelocityComponent")
	if ( velocity_component ~= nil ) and ( velocity_component > 0 ) then
		ComponentSetValue2( character_data_component, "mVelocity", 0, 0 )
	end

	local character_platforming_component = EntityGetFirstComponentIncludingDisabled(parent_id, "CharacterPlatformingComponent")
	if ( character_platforming_component ~= nil ) and ( character_platforming_component > 0 ) then
		ComponentSetValue2( character_platforming_component, "pixel_gravity", -600 )
		ComponentSetValue2( character_platforming_component, "jump_velocity_y", 0 )
		ComponentSetValue2( character_platforming_component, "run_velocity", 0 )
		ComponentSetValue2( character_platforming_component, "velocity_min_x", 0 )
		ComponentSetValue2( character_platforming_component, "velocity_max_x", 0 )
		ComponentSetValue2( character_platforming_component, "velocity_min_y", 0 )
		ComponentSetValue2( character_platforming_component, "velocity_max_y", 0 )
	end

	local pathfinding_component = EntityGetFirstComponentIncludingDisabled(parent_id, "PathFindingComponent")
	if ( pathfinding_component ~= nil ) and ( pathfinding_component > 0 ) then
		ComponentSetValue2( pathfinding_component, "can_swim_on_surface", false )
		ComponentSetValue2( pathfinding_component, "can_dive", false )
		ComponentSetValue2( pathfinding_component, "frames_to_get_stuck", 0 )
		ComponentSetValue2( pathfinding_component, "can_jump", false )
		-- ComponentSetValue2( pathfinding_component, "can_fly", false )
		ComponentSetValue2( pathfinding_component, "can_walk", false )
	end

	local hitbox_component = EntityGetFirstComponent(parent_id, "HitboxComponent")
	if ( hitbox_component ~= nil ) and ( hitbox_component > 0 ) then
		ComponentSetValue2( hitbox_component, "aabb_min_y", -6.5 )
		ComponentSetValue2( hitbox_component, "aabb_max_y", 3.5 )
		ComponentSetValue2( hitbox_component, "aabb_min_x", -4.5 )
		ComponentSetValue2( hitbox_component, "aabb_max_x", 4.5 )
	end

	local lua_comps = EntityGetComponentIncludingDisabled(parent_id, "LuaComponent") or {}

	local blob_ceiling_found = false

	for i, lua_comp in ipairs(lua_comps) do
		if ComponentGetValue2(lua_comp, "script_source_file") == "data/scripts/animals/blob_ceiling.lua" then
			blob_ceiling_found = true
		end
	end

	if blob_ceiling_found == false then
		EntityAddComponent(parent_id, "LuaComponent", {
			script_source_file="data/scripts/animals/blob_ceiling.lua",
			execute_every_n_frame=300,
			execute_on_added=0,
		})
	end
end

-- if max_hp and hp then

	-- ComponentSetValue2( who_spawned_damage_model_component, "max_hp", max_hp )
	-- ComponentSetValue2( who_spawned_damage_model_component, "hp", hp )
		
	-- EntityKill(mWhoShot)
-- end