dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local x, y, rotation = EntityGetTransform( entity_id )

-- local entities = EntityGetInRadiusWithTag(x, y, 50, "player_unit")

function get_distance(dx, dy, dx2, dy2)
	return math.sqrt(((dx-dx2)^2) + ((dy-dy2)^2))
end
--local x,y = EntityGetTransform( entity_id )
local entities = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	local px, py = EntityGetTransform(player)
	local dist = get_distance(x, y, px, py)
	if dist <= 50 then
		entities = {player}
	end
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		local px, py = EntityGetTransform(polymorphed_player)
		local dist = get_distance(x, y, px, py)
		if dist <= 50 then
			players = {polymorphed_player}
		end
	end
end

local blood_mage_detected = EntityGetInRadiusWithTag(x, y, 50, "monk_hand")

if not ( #blood_mage_detected > 0 ) or ( #entities > 0 ) then

	for i, entity in ipairs(entities) do

		local entity_x, entity_y = EntityGetTransform( entity )
		local did_hit, hit_x, hit_y = RaytracePlatforms(x, y, entity_x, entity_y)
			
		if not did_hit then
			
			-- EntityLoad( "data/entities/projectiles/orb_mist_blood.xml", x , y )
			-- local wall_id = EntityLoad( "data/entities/projectiles/temporary_blood_wall.xml", x , y )
			
			-- EntitySetTransform( wall_id, x , y , rotation)
			
			local vx, vy = GameGetVelocityCompVelocity(entity_id)
			local vx1, vy1 = vec_rotate(vx, vy, math.rad(90))
			local vx2, vy2 = vec_rotate(vx, vy, math.rad(-90))
			shoot_projectile_from_projectile(entity_id, "data/entities/projectiles/blood_mist_barrier_spawner.xml", x, y, vx1, vy1)
			shoot_projectile_from_projectile(entity_id, "data/entities/projectiles/blood_mist_barrier_spawner.xml", x, y, vx2, vy2)
			
			local lua_component = EntityGetFirstComponentIncludingDisabled(entity_id, "LuaComponent")
			EntityRemoveComponent(entity_id, lua_component)
			
		end
		
	end

end