dofile_once( "data/scripts/lib/utilities.lua" )
dofile_once( "data/scripts/invisibility_check.lua" )

local bouncer = GetUpdatedEntityID()
local bouncer_x, bouncer_y = EntityGetTransform( bouncer )

function get_distance(dx, dy, dx2, dy2)
    return math.sqrt(((dx-dx2)^2) + ((dy-dy2)^2))
end

local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	local px, py = EntityGetTransform(player)
	local dist = get_distance(bouncer_x, bouncer_y, px, py)
	if dist <= 500 then
		players = {player}
	end
else
	local polymorphed_player = EntityGetClosestWithTag(bouncer_x, bouncer_y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		local px, py = EntityGetTransform(polymorphed_player)
		local dist = get_distance(bouncer_x, bouncer_y, px, py)
		if dist <= 500 then
			players = {polymorphed_player}
		end
	end
end

if #players > 0 and ( EntityGetFirstComponent( players[1], "GenomeDataComponent") ~= nil ) and ( EntityGetFirstComponent( players[1], "GenomeDataComponent") > 0 ) and ( EntityGetHerdRelation(bouncer, players[1]) < 40 ) and ( is_invisible(players[1]) == false ) then
  
  local player_x, player_y = EntityGetTransform(players[1])
  
  local did_hit, hit_x, hit_y = RaytraceSurfaces(bouncer_x, bouncer_y, player_x, player_y)
  
  if not did_hit and ( player_x < ( bouncer_x + 200 ) ) and ( player_x > bouncer_x ) and ( player_y < ( bouncer_y + 50 ) ) and ( player_y > ( bouncer_y - 50 ) ) then
  
	shoot_projectile( bouncer, "data/entities/projectiles/laser_bouncer.xml", bouncer_x + 10, bouncer_y, 60, 0, false )
  
  elseif not did_hit and ( player_x > ( bouncer_x - 200 ) ) and ( player_x < bouncer_x ) and ( player_y < ( bouncer_y + 50 ) ) and ( player_y > ( bouncer_y - 50 ) ) then
  
	shoot_projectile( bouncer, "data/entities/projectiles/laser_bouncer.xml", bouncer_x - 10, bouncer_y, -60, 0, false )

  end
  
end