dofile_once("data/scripts/lib/utilities.lua")
dofile_once("data/scripts/gun/procedural/gun_action_utils.lua")

local entity_id = GetUpdatedEntityID()
local x,y,dir,sx,sy = EntityGetTransform( entity_id )

local function getDistance(x1, y1, x2, y2)
	return math.sqrt(math.pow((y2-y1),2)+math.pow((x2-x1),2))
end

local x2 =x+ math.cos( dir ) * 288
local y2 = y+math.sin( dir ) * 288
local did_hit, hit_x,hit_y = RaytraceSurfacesAndLiquiform( x, y, x2, y2 )
local sprite_enable_num
local distance

local sprite_width = 9
local max_distance = 300

if did_hit then

	distance= getDistance(x,y,hit_x,hit_y)

	local scale = math.min(distance, max_distance) / sprite_width
	
	EntitySetTransform(entity_id, x, y, dir , scale, sy)
	
	EntityLoad("data/entities/particles/particle_explosion/eradicator_laser_explosion.xml", hit_x, hit_y)
	
	local sprite_component = EntityGetFirstComponentIncludingDisabled(entity_id, "SpriteComponent")
	if ( sprite_component ~= nil ) and ( sprite_component > 0 ) then
		if ComponentGetValue2(sprite_component, "image_file") == "data/projectiles_gfx/cerebracle_laser.png" then
			ComponentSetValue2( sprite_component, "image_file", "data/projectiles_gfx/cerebracle_laser_full.png" )
			EntityRefreshSprite( entity_id, sprite_component )
		end
	end
	
	-- if GameGetFrameNum() % 5 == 0 then
	
		-- EntityLoad("data/entities/particles/particle_explosion/eradicator_laser_explosion_delayed.xml", hit_x, hit_y)
	
	-- end
	
else

	distance= max_distance

	local scale = math.min(distance, max_distance) / sprite_width

	EntitySetTransform(entity_id, x, y, dir , scale, sy)
	
	local sprite_component = EntityGetFirstComponentIncludingDisabled(entity_id, "SpriteComponent")
	if ( sprite_component ~= nil ) and ( sprite_component > 0 ) then
		if ComponentGetValue2(sprite_component, "image_file") == "data/projectiles_gfx/cerebracle_laser_full.png" then
			ComponentSetValue2( sprite_component, "image_file", "data/projectiles_gfx/cerebracle_laser.png" )
			EntityRefreshSprite( entity_id, sprite_component )
		end
	end

end

