dofile_once( "data/scripts/projectiles/overmind.lua" )
dofile_once( "data/scripts/lib/utilities.lua" )
dofile_once( "data/scripts/invisibility_check.lua" )
-- dofile( "data/scripts/game_helpers.lua" )

local entity_id = GetUpdatedEntityID()

local x, y = EntityGetTransform( entity_id )

function get_distance(dx, dy, dx2, dy2)
    return math.sqrt(((dx-dx2)^2) + ((dy-dy2)^2))
end

local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	local px, py = EntityGetTransform(player)
	local dist = get_distance(x, y, px, py)
	if dist <= 300 then
		players = {player}
	end
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		local px, py = EntityGetTransform(polymorphed_player)
		local dist = get_distance(x, y, px, py)
		if dist <= 300 then
			players = {polymorphed_player}
		end
	end
end

if #players > 0 then
	if ( EntityGetFirstComponent( players[1], "GenomeDataComponent") ~= nil ) and ( EntityGetFirstComponent( players[1], "GenomeDataComponent") > 0 ) and ( EntityGetHerdRelation(entity_id, players[1]) < 40 )  and ( is_invisible(players[1]) == false ) then
		shoot_at_entity(entity_id, players[1], 1, 0, 0, 130, "data/entities/animals/soul.xml", 20, 160)
	end
	-- play_animation(entity_id, "blink", "stand")

end