dofile_once( "data/scripts/projectiles/overmind.lua" )
dofile_once( "data/scripts/lib/utilities.lua" )
dofile_once( "data/scripts/invisibility_check.lua" )
-- dofile( "data/scripts/game_helpers.lua" )

function collision_trigger(colliding_entity)
	local entity_id = GetUpdatedEntityID()

	-- local players = EntityGetWithTag("player_unit")

	local x, y = EntityGetTransform( entity_id )

	function get_distance(dx, dy, dx2, dy2)
		return math.sqrt(((dx-dx2)^2) + ((dy-dy2)^2))
	end
	--local x,y = EntityGetTransform( entity_id )
	local players = {}
	local player = EntityGetWithName( "DEBUG_NAME:player" )
	if ( player ~= nil ) and ( player > 0 ) then
		local px, py = EntityGetTransform(player)
		local dist = get_distance(x, y, px, py)
		if dist <= 250 then
			players = {player}
		end
	else
		local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
		if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
			local px, py = EntityGetTransform(polymorphed_player)
			local dist = get_distance(x, y, px, py)
			if dist <= 250 then
				players = {polymorphed_player}
			end
		end
	end

	function play_animation( entity_id, animation_name, next_animation )
		local sprite_components = EntityGetComponent( entity_id, "SpriteComponent" )
		if( sprite_components ~= nil ) then
			for i,v in ipairs(sprite_components) do
				ComponentSetValue2( v, "rect_animation", animation_name)
				ComponentSetValue2( v, "next_rect_animation", next_animation)
			end
		end
	end

	if #players > 0 then
		if ( BiomeMapGetName() ~= "$biome_holymountain" ) and ( EntityGetFirstComponent( players[1], "GenomeDataComponent") ~= nil ) and ( EntityGetFirstComponent( players[1], "GenomeDataComponent") > 0 ) and ( EntityGetHerdRelation(entity_id, players[1] ) < 40 ) and ( is_invisible(players[1]) == false ) then
			-- if GameIsBetaBuild() == false then
				-- if ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % 180 == 0 then
					-- shoot_at_entity(entity_id, closestEntity, 1, 0, 0, 51, "data/entities/projectiles/eye_shot.xml", 900, 250)
				-- end
			-- else
				shoot_at_entity(entity_id, players[1], 1, 0, 0, 51, "data/entities/projectiles/eye_shot.xml", 900, 250)
			-- end
			play_animation(entity_id, "attack", "stand")
		end
	end
end