dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y, dir, sx, sy = EntityGetTransform(entity_id)

local root_id = EntityGetRootEntity(entity_id)
local wall_offset = 200

if (root_id ~= nil) and (root_id > 0) then
    local wall_offset_component = EntityGetFirstComponentIncludingDisabled(root_id, "VariableStorageComponent")
    if wall_offset_component then
        wall_offset = ComponentGetValue2(wall_offset_component, "value_float")
    end
end

local cx, cy = 0, 0
for _, child in ipairs(EntityGetAllChildren(root_id) or {}) do
    if EntityGetName(child) == "sides" then
        cx, cy = EntityGetTransform(child)
    end
end

if x < ( cx - (wall_offset + 14 ) ) then
	EntitySetTransform(entity_id, cx - (wall_offset + 20 ), y)
	
	local phys = EntityGetFirstComponentIncludingDisabled(entity_id, "PhysicsBodyComponent")
	local targphysx, targphysy = GamePosToPhysicsPos( cx - (wall_offset + 20 ), y )
	if ( phys ~= nil ) and ( phys > 0 ) then
		local physics_bodies = PhysicsBodyIDGetFromEntity( entity_id, phys )
		for i, body_id in ipairs(physics_bodies or {}) do
			bx, by, bangle, bvel_x, bvel_y, bangular_vel = PhysicsBodyIDGetTransform( body_id )
			PhysicsBodyIDSetTransform( body_id, targphysx, targphysy, bangle, -bvel_x, bvel_y, -bangular_vel)
		end
	end
	-- GamePrint("yes")
end

if x > ( cx + (wall_offset - 14 ) ) then
	EntitySetTransform(entity_id, cx + (wall_offset - 20 ), y)
	
	local phys = EntityGetFirstComponentIncludingDisabled(entity_id, "PhysicsBodyComponent")
	local targphysx, targphysy = GamePosToPhysicsPos( cx + (wall_offset - 20 ), y )
	if ( phys ~= nil ) and ( phys > 0 ) then
		local physics_bodies = PhysicsBodyIDGetFromEntity( entity_id, phys )
		for i, body_id in ipairs(physics_bodies or {}) do
			bx, by, bangle, bvel_x, bvel_y, bangular_vel = PhysicsBodyIDGetTransform( body_id )
			PhysicsBodyIDSetTransform( body_id, targphysx, targphysy, bangle, -bvel_x, bvel_y, -bangular_vel)
		end
	end
	-- GamePrint("yes2")
end