dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

-- Use the entity ID to generate a unique phase offset for each snake
local phase_offset = entity_id * 1

-- Get the current frame number for animation purposes
local frame_num = GameGetFrameNum()

-- Calculate the new position using sine and cosine functions
local angle = (frame_num * 0.02) + phase_offset
local radius = 8  -- Adjust the radius to control the size of the circular motion

local offset_x = math.cos(angle) * radius
local offset_y = math.sin(angle) * radius

local verlet_component = EntityGetFirstComponentIncludingDisabled(entity_id, "VerletPhysicsComponent")
if verlet_component then
    ComponentSetValue2(verlet_component, "animation_target_offset", offset_x, offset_y - 7 )
end