dofile_once( "data/scripts/invisibility_check.lua" )

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local times_executed = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")

local sub_verlets = {}

for _, child in ipairs(EntityGetAllChildren(entity_id) or {} ) do
	if EntityGetName(child) == "controller" then
		controller = child
		cx, cy = EntityGetTransform(child)
	end
	
	if EntityGetName(child) == "subverlet" then
		table.insert(sub_verlets, child)
	end
end

function velocity_from_to(x1, y1, x2, y2)
	-- Calculate the direction vector from the ghost to the player
	local dir_x = x2 - x1
	local dir_y = y2 - y1

	-- Normalize the direction vector
	local length = math.sqrt(dir_x * dir_x + dir_y * dir_y)
	if length > 0 then
		dir_x = dir_x / length
		dir_y = dir_y / length
	end

	-- Define a speed value for the ghost
	local speed = 40  -- Adjust this value as needed

	-- Set the velocity towards the player
	local val_x = dir_x * speed
	local val_y = dir_y * speed
	return val_x, val_y
end

if ( controller ~= nil ) and ( controller > 0 ) then
	if times_executed < 50 then
		EntitySetTransform(controller, x, y)
	end

	--GOTO PLAYER if seen

	local ghost_component = EntityGetFirstComponentIncludingDisabled( controller, "GhostComponent")

	if ghost_component then
		local enemy = 0
		for _,id in pairs(EntityGetInRadiusWithTag(x, y, 200, "mortal")) do
			-- is target a valid enemy
			if ( id ~= entity_id ) and ( EntityGetFirstComponent(id, "GenomeDataComponent") ~= nil ) and ( EntityGetFirstComponent(id, "GenomeDataComponent") > 0 ) and ( EntityGetHerdRelation(entity_id, id) < 40 ) and ( is_invisible(id) == false ) then
				local ex, ey = EntityGetTransform(id)
				local did_hit = RaytraceSurfaces( cx, cy, ex, ey )
				if not did_hit then
					enemy = id
				end
			end
		end
		local has_player_tag = EntityHasTag(entity_id, "polymorphed_player")
		if has_player_tag == true then
			local controls_component = EntityGetFirstComponentIncludingDisabled(entity_id, "ControlsComponent")
			local closest_x, closest_y = ComponentGetValue2(controls_component, "mMousePosition")
			local vel_x, vel_y = velocity_from_to(cx, cy, closest_x, closest_y)
			ComponentSetValueVector2(ghost_component, "velocity", vel_x, vel_y )
		elseif ( enemy ~= nil ) and ( enemy > 0 ) and ( times_executed > 180 ) then
			local px, py = EntityGetTransform(enemy)
			local vel_x, vel_y = velocity_from_to(cx, cy, px, py)
			ComponentSetValueVector2(ghost_component, "velocity", vel_x, vel_y )
		else
			local vel_x, vel_y = velocity_from_to(cx, cy, x, y)
			ComponentSetValueVector2(ghost_component, "velocity", vel_x, vel_y )
		end
	end
	
	-- if ( verlet ~= nil ) and ( verlet > 0 ) then
		local verlet_component = EntityGetFirstComponentIncludingDisabled(entity_id, "VerletPhysicsComponent")
		local positions = ComponentGetValue2(verlet_component, "positions")
		positions[3] = x
		positions[4] = y
		
		EntitySetTransform(sub_verlets[1], positions[5], positions[6])
		EntitySetTransform(sub_verlets[2], positions[9], positions[10])
		EntitySetTransform(sub_verlets[3], positions[13], positions[14])
		EntitySetTransform(sub_verlets[4], positions[15], positions[16])
		EntitySetTransform(sub_verlets[5], positions[21], positions[22])
		EntitySetTransform(sub_verlets[6], positions[25], positions[26])
		EntitySetTransform(sub_verlets[7], positions[27], positions[28])
		EntitySetTransform(sub_verlets[8], positions[29], positions[30])
		EntitySetTransform(sub_verlets[9], positions[35], positions[36])
		EntitySetTransform(sub_verlets[10], positions[37], positions[38])
		
		positions[45] = cx
		positions[46] = cy
		ComponentSetValue2(verlet_component, "positions", positions)
	-- end
end