dofile_once("data/scripts/lib/utilities.lua")
dofile_once( "data/scripts/invisibility_check.lua" )

local entity = GetUpdatedEntityID()

local x, y, r = EntityGetTransform(entity)

local parent_id = EntityGetParent(entity)
-- GamePrint(parent_id)

local root_id = EntityGetParent(parent_id)
-- GamePrint(root_id)

local rx, ry, r = EntityGetTransform(root_id)

function get_distance(dx, dy, dx2, dy2)
	return math.sqrt(((dx-dx2)^2) + ((dy-dy2)^2))
end

local players = {}
-- local players_closer = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	local px, py = EntityGetTransform(player)
	local dist = get_distance(rx, ry, px, py)
	if dist <= 200 then
		players = {player}
	end
	-- if dist <= 10 then
		-- players_closer = {player}
	-- end
else
	local polymorphed_player = EntityGetClosestWithTag(rx, ry, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		local px, py = EntityGetTransform(polymorphed_player)
		local dist = get_distance(rx, ry, px, py)
		if dist <= 200 then
			players = {polymorphed_player}
		end
		-- if dist <= 10 then
			-- players_closer = {polymorphed_player}
		-- end
	end
end

local nearby = 0

if #players > 0 then
	nearby = players[1]
end

local variable_storage = EntityGetComponent(entity, "VariableStorageComponent")

local holder = nil
local radius = 100
local move_speed = 60
local tag = nil
local enable_raytrace = 0
local velocity_falloff = 0
local y_offset = 0

if(variable_storage ~= nil)then
    for k, v in pairs(variable_storage)do
        local name = ComponentGetValue2(v, "name")
        if(name == "holder")then
            holder = tonumber(ComponentGetValue2(v, "value_string"))
        elseif(name == "attack_radius")then
            radius = tonumber(ComponentGetValue2(v, "value_string"))        
        elseif(name == "attack_speed")then
            move_speed = tonumber(ComponentGetValue2(v, "value_string")) 
        elseif(name == "enable_raytrace")then
            enable_raytrace = tonumber(ComponentGetValue2(v, "value_string")) 
        elseif(name == "velocity_falloff")then
            velocity_falloff = tonumber(ComponentGetValue2(v, "value_string")) 
        elseif(name == "y_offset")then
            y_offset = tonumber(ComponentGetValue2(v, "value_string"))
        elseif(name == "target_tag")then
            tag = ComponentGetValue2(v, "value_string")     
        end
    end

    velocity_falloff = velocity_falloff / 100

    local raytrace_enabled = (enable_raytrace == 1)

    if ( root_id ~= nil ) then
        if ( EntityGetIsAlive(root_id) ) then
            local holder_x, holder_y = EntityGetTransform(root_id)

			-- GamePrint(nearby[1])
			local has_player_tag = EntityHasTag(root_id, "polymorphed_player")
			if has_player_tag == true then
				local controls_component = EntityGetFirstComponentIncludingDisabled(root_id, "ControlsComponent")
				local closest_x, closest_y = ComponentGetValue2(controls_component, "mMousePosition")

                closest_y = closest_y + y_offset

                local direction_x = closest_x - x
                local direction_y = closest_y - y

                local len = math.sqrt((direction_x*direction_x) + (direction_y*direction_y))

                local dir_x = direction_x / len
                local dir_y = direction_y / len       

				edit_component( entity, "VelocityComponent", function(comp,vars)
					local velocity_x, velocity_y = ComponentGetValueVector2( comp, "mVelocity")
			
					local force_x = (velocity_x*velocity_falloff) +  (dir_x * move_speed)
					local force_y = (velocity_y*velocity_falloff) + (dir_y * move_speed)
				
					ComponentSetValue( comp, "gravity_x", 0 )
					ComponentSetValue( comp, "gravity_y", 0 )
					ComponentSetValueVector2( comp, "mVelocity", force_x, force_y )
			
				end)
            elseif ( ( nearby ~= nil ) and ( nearby > 0 ) ) and ( EntityGetFirstComponent( nearby, "GenomeDataComponent") ~= nil ) and ( EntityGetFirstComponent( nearby, "GenomeDataComponent") > 0 ) and ( EntityGetHerdRelation(root_id, nearby) < 40 ) and ( is_invisible(nearby) == false ) then
                local closest_x, closest_y = EntityGetTransform(nearby)
                closest_y = closest_y + y_offset

                local direction_x = closest_x - x
                local direction_y = closest_y - y

                local len = math.sqrt((direction_x*direction_x) + (direction_y*direction_y))

                local dir_x = direction_x / len
                local dir_y = direction_y / len       

                local did_hit, hit_x, hit_y = RaytraceSurfaces( x, y, closest_x, closest_y)

                if not did_hit then
                    edit_component( entity, "VelocityComponent", function(comp,vars)
                        local velocity_x, velocity_y = ComponentGetValueVector2( comp, "mVelocity")
                
                        local force_x = (velocity_x*velocity_falloff) +  (dir_x * move_speed)
                        local force_y = (velocity_y*velocity_falloff) + (dir_y * move_speed)
                    
                        ComponentSetValue( comp, "gravity_x", 0 )
                        ComponentSetValue( comp, "gravity_y", 0 )
                        ComponentSetValueVector2( comp, "mVelocity", force_x, force_y )
                    end)
                else
                    local direction_x = holder_x - x
                    local direction_y = holder_y - y
                
                    local len = math.sqrt((direction_x*direction_x) + (direction_y*direction_y))
            
                    local dir_x = direction_x / len
                    local dir_y = direction_y / len    
            
                    edit_component( entity, "VelocityComponent", function(comp,vars)
                        local velocity_x, velocity_y = ComponentGetValueVector2( comp, "mVelocity") 
            
                        local force_x = (velocity_x*velocity_falloff) +  (dir_x * move_speed)
                        local force_y = (velocity_y*velocity_falloff) + (dir_y * move_speed)
                    
                        ComponentSetValue( comp, "gravity_x", 0 )
                        ComponentSetValue( comp, "gravity_y", 0 )
                        ComponentSetValueVector2( comp, "mVelocity", force_x, force_y )
                
                    end)               
                end
            else
				local direction_x = holder_x - x
				local direction_y = holder_y - y
			
				local len = math.sqrt((direction_x*direction_x) + (direction_y*direction_y))
		
				local dir_x = direction_x / len
				local dir_y = direction_y / len    
		
				edit_component( entity, "VelocityComponent", function(comp,vars)
					local velocity_x, velocity_y = ComponentGetValueVector2( comp, "mVelocity") 
		
					local force_x = (velocity_x*velocity_falloff) +  (dir_x * move_speed)
					local force_y = (velocity_y*velocity_falloff) + (dir_y * move_speed)
				
					ComponentSetValue( comp, "gravity_x", 0 )
					ComponentSetValue( comp, "gravity_y", 0 )
					ComponentSetValueVector2( comp, "mVelocity", force_x, force_y )
			
				end)       
            end
        end
    end 
end