dofile_once("data/scripts/lib/utilities.lua")
dofile_once( "data/scripts/invisibility_check.lua" )

local entity_id    = GetUpdatedEntityID()
local pos_x, pos_y = EntityGetTransform( entity_id )
SetRandomSeed( GameGetFrameNum(), pos_x + pos_y + entity_id )

function play_animation( entity_id, animation_name, next_animation )
	local sprite_components = EntityGetComponent( entity_id, "SpriteComponent" )
	if( sprite_components ~= nil ) then
		for i,v in ipairs(sprite_components) do
			ComponentSetValue2( v, "rect_animation", animation_name)
			ComponentSetValue2( v, "next_rect_animation", next_animation)
		end
	end
end

local nearby = EntityGetInRadiusWithTag(pos_x, pos_y, 512, "mortal")

local count = 0

for i, entity in ipairs(nearby) do

	if EntityGetName(entity) == "$head2" then
	
		count = count + 1
		
	end
	
end
-- print(count)
if count < 5 then

	if( Random(0,100) < 75 ) then
		local spawn_distance = 200
		local e_id = EntityGetClosestWithTag( pos_x, pos_y, "player_unit")
		if ( EntityGetFirstComponent(e_id, "GenomeDataComponent") ~= nil ) and ( EntityGetFirstComponent(e_id, "GenomeDataComponent") > 0 ) and ( EntityGetHerdRelation(entity_id, e_id) < 40 ) and ( is_invisible(e_id) == false ) then

			local x, y = EntityGetTransform( e_id )
			local distance_sqrt = (x-pos_x)*(x-pos_x)+(y-pos_y)*(y-pos_y)
			if( distance_sqrt < spawn_distance * spawn_distance ) then
				
				local sprite_component = EntityGetFirstComponent(entity_id, "SpriteComponent")
				local animation = ComponentGetValue2( sprite_component, "rect_animation")

				ComponentSetValue2(sprite_component, "rect_animation", "open")
				ComponentSetValue2(sprite_component, "next_rect_animation", "stand")
				
				new_entity = EntityLoad( "data/entities/animals/head2.xml", pos_x, pos_y )
				
				edit_component( new_entity, "LuaComponent", function(comp,vars)
					vars.script_death = ""
				end)
			end
		end
	end
end

